#ifndef __CSelection
#define __CSelection
#include "types.h"
#include "XDrivers.h"
#include "TBaseObject.h"
class	TImageWindow ;
class CSelection : public TBaseObject {

public:
	CSelection(Point &pt,TImageWindow *window) ;
	CSelection() { mSignature = 'isel' ; } ;
	~CSelection() ;
	void	GetSelectionRect(Rect &rect) { rect = mSelectionRect ; } ;
	void	SetSelectionRect(Rect &rect) { mSelectionRect = rect ; SetActiveHandles() ; } ;
	void 	DoMouseDown(Point &loc) ;
	void	Select(bool state) { mIsSelected = state ; } ;
	void	GetObjectInfo(char *text) ;
	void	ShowInfo() ;
	bool 	IsNullSelection() { return (mSelectionRect.left == mSelectionRect.right
				|| mSelectionRect.top == mSelectionRect.bottom) ; } ;
	bool	IsInside(Point &loc) { return PtInRect(&loc,&mSelectionRect) ; } ;
	bool	InSelection(Point &pt) ;
    bool	IsSelected() { return mIsSelected ; } ;
	void	Draw() ;
	void 	Zoom(float factor,short x,short y) ;
	void 	Pan(short dx,short dy) ;
	void	Update(Rect *clipRect) ;
	void 	Modify(Point &loc) ;
    // CSelection	*Copy() { CSelection *selection = new CSelection ; *selection = *this ; return selection ; }  ; 
    TBaseObject	*Copy() { CSelection *selection = new CSelection ; *selection = *this ; return (TBaseObject *)selection ; }  ; 
	void	SetWindow(TImageWindow *window) { mWindow = window ; } ;
private:
	Rect	mSelectionRect ;
	Rect	mTopLeftCorner ;
	Rect	mTopRightCorner ;
	Rect	mBottomLeftCorner ;
	Rect	mBottomRightCorner ;
	Rect	mTopMiddle ;
	Rect	mLeftMiddle ;
	Rect	mBottomMiddle ;
	Rect	mRightMiddle ;
	
	bool	mIsSelected ;

	TImageWindow	*mWindow ;
	
	void 	Drag(Point &loc) ;
	void 	DragTopLeft(Point &loc) ;
	void 	DragTopRight(Point &loc) ;
	void 	DragBottomLeft(Point &loc) ;
	void 	DragBottomRight(Point &loc) ;
	void 	DragTop(Point &loc) ;
	void 	DragLeft(Point &loc) ;
	void 	DragBottom(Point &loc) ;
	void 	DragRight(Point &loc) ;
	void 	Shift(Point &loc) ;
	void 	SetActiveHandles() ;
	void	DrawHandles() ;
} ;

#endif

