#ifndef _TCalibrationDialog_h
#define _TCalibrationDialog_h
#include "TDialog.h"
#include "TImage.h"

typedef struct {
	float			pixelLength ;
	float			calibrationConstant ;
	float			calibratedLength ;
	CalibrationUnit	calibrationUnit ;
} TCalibrationRecord ;

class	TCalibrationDialog : public TDialog {

	public:
		TCalibrationDialog(TCalibrationRecord *calibrationData) ;
		void	GetDialogData(void *data) { *(TCalibrationRecord *)data = mCalibrationRecord ; } ;
		void	DoMouseDownInObject(TObject *,Point *) ;
	private:
		TStaticText		*mTextPixelLength ;
		TEditText		*mTextCalibratedLength ;
		TEditText		*mTextInverseLength ;
		TRadioButton	*mPixelUnit ;
		TRadioButton	*mInversePixelUnit ;
		TRadioButton	*mAngstromUnit ;
		TRadioButton	*mInverseAngstromUnit ;
		TRadioButton	*mNanometerUnit ;
		TRadioButton	*mInverseNanometerUnit ;
		TCalibrationRecord	mCalibrationRecord ;

		void	OnCommandHelp() { EDMHelp("TCalibrationDialog") ; } ;
		
		TRadioButton	*mCurrentUnit ;

} ;

#endif
