// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------

#include "types.h"
#include "TBaseObject.h"
TClipboardEntry::TClipboardEntry() {
	mNextClipboardEntry = nil ;
	mObject = nil ;
}

TClipboardEntry::~TClipboardEntry() {
	mNextClipboardEntry = nil ;
	if (mObject != nil)	
		delete mObject ;
}

TClipboard::TClipboard() {
	mNumEntries = 0 ;
	mClipboardEntry = nil ;
}

TClipboard::~TClipboard() {
	TClipboardEntry *entry ;
	TClipboardEntry *nextEntry ;
	
	entry = mClipboardEntry ;
	while(entry != nil) {
		nextEntry = entry->mNextClipboardEntry ;
		delete entry ;
		entry = nextEntry ;
		mNumEntries-- ;
	} ;
}

void TClipboard::Add(TBaseObject *theObject) {
	
	TClipboardEntry *aNewEntry = new TClipboardEntry ;
	aNewEntry->mObject = theObject ;
	
	// We save time by always adding to the beginning of the list
	aNewEntry->mNextClipboardEntry = mClipboardEntry ;
	mClipboardEntry = aNewEntry ;
	mNumEntries++ ;
}



TBaseObject *TClipboard::GetClipboardObject(int number) {
	TClipboardEntry* entry;
	int i ;
	
	if (number >= mNumEntries || number < 0)
		return nil ;
		
	for (i = 0,entry = mClipboardEntry ;entry != nil; entry = entry->mNextClipboardEntry,i++) {
		if (i == number) {
			return entry->mObject ;
		}
	}
	return nil ;
}

