#ifndef __TDialog_h
#define __TDialog_h

#define	kDialogPosX	240
#define kDialogPosY	100
typedef enum {kDialogCancel, kDialogOK, kDialogNO } DialogReturnCode ;
#include "TWindow.h"

void	DisplayMessage(char *text) ;
class	TDialog : public TWindow {
	public:
		TDialog(short xloc,short yloc,short width,short height,char *title = nil) ;
		~TDialog() ;

		virtual	void	SetDialogData(void *data) {} ;
		virtual	void	GetDialogData(void *data) {} ;
		virtual	void	RetrieveDialogItems() {} ;
		virtual	void	DefineDialog() {} ;
		void			Show() ;

		virtual	void	Draw() ;
		virtual	void	DoUpdate(XEvent *) ;
		virtual	DialogReturnCode		DoModalDialog() ;

		void	SetCancelButton(TObject *obj) { mCancelButton = obj ; } ;
		void	SetOKButton(TObject *obj) { mOKButton = obj ; } ;
		void	SetDefaultButton(TObject *obj) { mDefaultButton = obj ; } ;

		virtual	void	DoEvent(XEvent *) ;
		virtual	void	DoMouseDown(XEvent *) ;
		virtual	void	DoKeyDown(XEvent *) ;
		virtual	void	DoMouseDownInObject(TObject *,Point *);
		
	protected:
		Boolean		mDone ;
		TObject		*mOKButton ;
		TObject		*mCancelButton ;
		TObject		*mDefaultButton ;
		DialogReturnCode	mDialogReturnCode ;
		GrafPtr		mPreviousPort ;
} ;

class	TMessageDialog : public TDialog {
	public:
		TMessageDialog(short xloc,short yloc,short width,short height,char *text) ;
		TMessageDialog(char *text) ;
		void	DefineDialog() ;
} ;

class	TCancelOKDialog : public TDialog {
	public:
		TCancelOKDialog(short xloc,short yloc,short width,short height,char *text) ;
		TCancelOKDialog(char *text) ;
} ;

class	TGetOneRealNumberDialog :  public TDialog {
	public:
		TGetOneRealNumberDialog(char *text,float initialValue) ;
		void	GetDialogData(void *data) { *(float *)data = mValue ;  } ;
		void	RetrieveDialogItems() ;
	private:
		TEditText	*mTextValue ;
		float		mValue ;
} ;

class	TGetOneIntegerNumberDialog :  public TDialog {
	public:
		TGetOneIntegerNumberDialog(char *text,long initialValue) ;
		void	RetrieveDialogItems() ;
		void	GetDialogData(void *data) { *(long *)data = mValue ; } ;
	private:
		TEditText	*mTextValue ;
		long		mValue ;
} ;

float	GetRealNumberWithPrompt(char *text,float defValue) ;
long	GetIntegerNumberWithPrompt(char *text,long defValue) ;

#endif // __TDialog_h
