#ifndef TImportRawImageDialog_h_
#define TImportRawImageDialog_h_

#include "types.h"
#include "TImage.h"
#include "TDialog.h"
#include "TMenu.h"

typedef struct {
	ImageDataType	dataType ;
	short	imageWidth ;
	short	imageHeight ;
	Boolean	swapBytes ;	
	long	numBytes ;
	long	byteOffset ;
} TImportRawImageDialogRec ;

class TImportRawImageDialog : public TDialog {
	public:
		TImportRawImageDialog(char *filename,long size);
		void	DefineDialog(char *filename) ;
		void	SetDialogData(void *data) ;
		void	GetDialogData(void *data) ;
		void	DoKeyDownInObject(TObject *) ;
		void	DoMouseDownInObject(TObject *,Point *) ;
	private:
		TStaticText	*mFileLengthF;
		TPopupMenu	*mDataTypeF;
		TEditText	*mImageWidthF;
		TEditText	*mImageHeightF;
		TEditText	*mByteOffsetF;
		TCheckBox	*mSwapBytesF ;
		long		mFileSize ;
		long		mDataSize ;
		short		mBytesPerElement ;
		long 		mImageWidth ;
		long		mImageHeight ;
		long		mNumElements ;
		long		mByteOffset ;
		ImageDataType	mImageDataType ;
		Boolean		mSwapBytes ;
		
} ;

#endif
