#ifndef __TMotifWindow_h
#define __TMotifWindow_h
#include "TButton.h"
#include "TImageWindow.h"
#include "TDialog.h"

#ifndef	__UnitCellDisplayRecord
#define __UnitCellDisplayRecord
typedef struct UnitCellDisplayRecord {
	short 	numCellsA ;
	short	numCellsB ;
	bool	createImageMatchingExperiment ;
} UnitCellDisplayRecord ;
#endif

class TCreateSymmetrizedImageDialog : public TDialog {
	public:
		TCreateSymmetrizedImageDialog(UnitCellDisplayRecord *data) ;
		void	DoMouseDownInObject(TObject *,Point *);
		void	GetDialogData(void *data) { *(UnitCellDisplayRecord *)data = mData ; } ;
		void	RetrieveDialogItems() ;
		void	OnCommandHelp() { EDMHelp("TCreateSymmetrizedImageDialog") ; } ;
	private:
		TEditText		*mTextNumA ;
		TEditText		*mTextNumB ;
		TRadioButton	*mCreateSymmetrizedUnitCellImage ;
		TRadioButton	*mCreateSymmetrizedExperimentalImage ;
		UnitCellDisplayRecord		mData ;		
} ;

class TMotifWindow : public TWindow {

	public:
		TMotifWindow(TDiffractionPeaks *diffractionData) ;
		~TMotifWindow() ;
		
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
		void	DoWMRequestDelete() ;
		
		void	OnCommandHelp() { EDMHelp("TMotifWindow") ; } ;
	protected:
		void 	CalculatePhaseResiduals() ;
		void 	CreateImage() ;
		void 	DisplayHKs() ;
		void 	ExportUnitCellImage() ;
		void	ShowPotentialMapWindow() ;
		
		TArray 	*Symmetrize(short numPlaneGroup,short &xc,short &yc,float &residual) ;
		
		void	DisplayResiduals() ;
		void	DisplaySymmetrizedImage() ;
		void	DisplayPhaseResidualImage() ;
		void	UpdateImages() { DisplaySymmetrizedImage() ; DisplayPhaseResidualImage() ; XFlush(gDisplay) ; } ;

		TDiffractionPeaks	*mDiffractionData ;
		TArray				*mPhaseResiduals[17] ;
		float				mMinimumPhaseResidual[17] ;
		Point				mSymmetryOrigin[17] ;
		TImage				*mSymmetrizedImage ;
		TImage				*mPhaseResidualImage ;
		float				mGamma ;
		TUserRect			*mResidualRectObject ;
		TUserRect			*mListRectObject ;
		Rect				mImageRect ;
		Rect				mResidualRect ;
		Rect				mActualImageRect ;
		Rect				mActualResidualRect ;
		Rect				mListRect ;
		TButton				*mTryAllGroups ;
		TButton				*mCreateImage ;
		TButton				*mShowHKs ;
		TButton				*mComputePotentialMap ;
		TButton				*mClose ;
		TCheckBox			*mShowOutline ;
		short				mCurrentPlaneGroup ;
		float				mScaleFactor ;
		Boolean				mShowUCOutline ;
} ;

#endif
