#ifndef TShowSolutionsWindow_h_
#define TShowSolutionsWindow_h_

#include "types.h"
#include "TDialog.h"
#include "TMenu.h"
#include "TTable.h"
#include "TImage.h"
#include "FS98ControlRecord.h"

typedef TImage	*TImagePtr ;
class TSolutionTable : public TTable {
	public:
		TSolutionTable(TableAttributes *attr) ;
		~TSolutionTable() ;
		
		void 	DrawCellValue(TableCellT &inCell,Rect &cellFrame) ;
		void	SetImages(TImagePtr *imagePtr,short numImages,short startNum) 
			{ mImageList=imagePtr;mNumImages=numImages;mStartingNumber=startNum; } ;
	private:
		friend	class	TShowSolutionsWindow ;
		TImagePtr		*mImageList ;
		short			mNumImages ;
		short			mStartingNumber ;

} ;

class TShowSolutionsWindow : public TWindow {
	public:
		TShowSolutionsWindow(FS98ControlRecord &dataRecord);
		~TShowSolutionsWindow();
		void	Draw() ;
		void	DoMouseDown(XEvent *event) ;
		void	DoKeyDownInObject(TObject *) ;
		void	DoMouseDownInObject(TObject *,Point *) ;
		void	OnCommandHelp() { EDMHelp("TShowSolutionsWindow") ; } ;
	private:

		bool	CountGeneralSolutions() ;
		bool	CountUniqueSolutions() ;
		
		void	RunPeaks(short whichImage) ;
		
		TEditText		*mCrossCorrelationToleranseText ;
		TEditText		*mNumberOfTopSolutionsText ;		
		TStaticText		*mNumGeneralSolutionsText ;		
		TStaticText		*mNumUniqueSolutionsText ;		
		TEditText		*mFromText ;		
		TEditText		*mToText ;	
		TEditText		*mUniqueFromText ;		
		TEditText		*mUniqueToText ;	
				
		TTablePane		*mTablePane ;
		TSolutionTable	*mDataTable ;
		
		TButton			*mCalculateUniqueSolutionsButton ;
		TButton			*mDisplaySolutionsButton ;
		TButton			*mDisplayUniqueSolutionsButton ;
		TButton			*mCreateSolutionImageButton ;
		TButton			*mAnalyzeSolutionButton ;
		TButton			*mCloseButton ;
		
		FS98ControlRecord	mFS98ControlRecord ;
		
		TImagePtr		*mImageList ;
		short			mNumImages ;
		long			mNumGeneralSolutions ;
		long			mNumUniqueSolutions ;
						
} ;

#endif
