#ifndef __XDrivers_h
#define __XDrivers_h

#include "TWindow.h"

#ifndef	__TMenuKey
	#define __TMenuKey
	typedef KeySym	TMenuKey ;
#endif

#ifndef topLeft
	#define topLeft(r) (((Point *)&(r))[0])
#endif

#ifndef botRight
	#define botRight(r) (((Point *)&(r))[1])
#endif

#ifndef __DrawingMode
	#define __DrawingMode
	typedef enum { kCopyMode, kXOrMode, kOrMode } DrawingMode ;
#endif

void DrawPixel(int x,int y) ;
void DrawLine(int x1,int y1,int x2,int y2);
void MoveTo(int ix,int iy);
void LineTo(int ix,int iy) ;
void SetLineWidth(int width) ;
short GetLineWidth();
int TextHeight() ;
void Beep() ;
void DrawChar(int x,int y,char c);
void DrawRect(int xlow,int ylow,int xhi,int yhi);
void DrawText(int x,int y,char *text);
void DrawString(char *text) ;
void DrawFilledText(int x,int y,char *text);
void DrawFilledString(char *text) ;
void DrawCross(short x,short y) ;
void DrawImageLine(int x,int y,int n,unsigned char *imageline);
Boolean ReadImageLine(int x,int y,int n,unsigned char *imageline);
Boolean DrawImage(unsigned char *image,int x,int y,int width,int height);
Boolean ReadImage(unsigned char *image,int x,int y,int width,int height);
void DrawRGBImageLine(int x,int y,int n,unsigned char *imageline);
Boolean ReadRGBImageLine(int x,int y,int n,unsigned char *imageline);
Boolean DrawRGBImage(unsigned char *image,int x,int y,int width,int height);
Boolean ReadRGBImage(unsigned char *image,int x,int y,int width,int height);
void RDrawRect(Rect *tRect);
void FrameRect(Rect *tRect);
void FillRect(Rect *tRect);
void InvertRect(Rect *tRect) ;
inline void PaintRect(Rect *rect) {FillRect(rect) ; } ;
void EraseRect(Rect *tRect);
void EraseCircle(short x,short y,short rad);
void ClearDisplay();
void GetMouseDownPosition(int *x,int *y);
void GetPort(GrafPtr *port);
void SetPort(GrafPtr port);
void SetRect(Rect *tRect,short x1,short y1,short x2,short y2);
Boolean PtInRect(Point *pt,Rect *tRect);
Boolean	PtInRgn(Point *pt,RgnHandle rgn) ;
void OffsetRect(Rect *tRect,short x,short y);
void InsetRect(Rect *tRect,short x,short y);
void DrawCircle(short x,short y,short rad);
void FillCircle(short x,short y,short rad);
void PaintOval(Rect *rect) ;	// Actually only does a circle
void FrameOval(Rect *rect) ;
void	RGBForeColor(RGBColor *color) ;
void	RGBBackColor(RGBColor *color) ;
unsigned long GetFgColor();
unsigned long GetBkColor();
void SetFgColor(unsigned long value);
void SetBkColor(unsigned long value);
void TextSize(short size);
void TextFace(short face);
void PenSize(short width,short height);
void PenMode(DrawingMode mode) ;
void PenNormal();
void SetWatchCursor();
void InitCursor();
void SetTrackingMode();
void UnSetTrackingMode();
KeySym	GetEventKey(XEvent *theEvent) ;
Boolean Button();
Boolean	ButtonDown() ;
void GetGlobalMouse(Point *where) ;
void	GlobalToLocal(Point *pos) ;
void	LocalToGlobal(Point *pos) ;
void GetMouse(Point *where);
void CopyBits(GrafPtr source,GrafPtr dest,Rect *srcRect,Rect *dstRect,CopyMode mode) ;
int StringWidth(char *text);
void UnionRect(Rect *srcRect1,Rect *srcRect2,Rect *destRect);
void RegionRect(Region rgn,Rect *rect) ;
void RectRgn(Region rgn,Rect *rect) ;
Boolean RectInRgn(Rect *rect,Region rgn) ;
Boolean RectInRect(Rect *rect1,Rect *rect2) ;
inline	Region	NewRgn() { return XCreateRegion() ; } ;
inline	void	DisposeRgn(Region rgn) { XDestroyRegion(rgn) ; } ;
Boolean RectISectRect(Rect *aRect,Rect *bRect);
void	SetClip(RgnHandle) ;
void	SetClip(Rect &rect) ;
void	GetClip(RgnHandle region) ;
void	GetClip(Rect *theRect) ;
void	FormRGBForeColor(RGBColor *) ;
void	FormRGBBackColor(RGBColor *) ;
void	SetFormFgColor(FL_COLOR) ;
void	SetFormBkColor(FL_COLOR) ;
Boolean	OptionKeyDown() ;
Boolean	ControlKeyDown() ;
Boolean	ShiftKeyDown() ;
Boolean	CommandKeyDown() ;
void SetControlKeyUp() ;
void SetCommandKeyUp() ;

Boolean	IsMenuKey(XEvent *theEvent,TMenuKey *menuKey) ;
#endif
