        subroutine bothc(natm,itype,bbump,occer)
        include 'newbonds.h'
C       Generate the constraints
C       occer false means no atom
        real bbump
        dimension itype(*)
        logical occer(*)
C       INCLUDE 'base_atoms.h'
        natom=natm
        bbum=0
        bbnd=0
        do j1=1,natom
                sbndw=5
                if(.not.occer(j1))goto 10
                k1=itype(j1)
                do j2=1,natom
                        if(occer(j2))then
                                k2=itype(j2)
C               Anti-bumbing
                        if(bumper)bbum=bbum+bondb(k1,j1,k2,j2)
C               Bonding; changed to remove same atom bonds
                if(bonding.and.j1.ne.j2)
     1                  sbndw=min(sbndw,bondx(k1,j1,k2,j2))
                        endif
                enddo
                bbnd=bbnd+max(0.,sbndw)
10              continue
        enddo
        bbump=0
        if(bumper)bbump=max(0.,bbum)
        if(bonding)bbump=bbump+bbnd
C       if(coord)then
C               write(6,*)'Calling tcoord'
C               call tcoord(natom,itype,bcord,occer)
C               write(6,*)'Exited tcoord'
C               bbump=bbump+bcord
C       endif
        bbump=bbump*10
        return
        end
        subroutine bumpv(natom,itype,bbump)
        include 'newbonds.h'
C       Generate the bumping constraint
C       occer false means no atom
        real bbump
        dimension itype(*)
        bbump=0
        if(.not.bumper)return
        do j1=1,natom
                k1=itype(j1)
                if(k1.eq.0)goto 10
                do j2=j1,natom
                        k2=itype(j2)
                        if(k2.ne.0)then
                                bbump=bbump+bondb(k1,j1,k2,j2)
                        endif
                enddo
10              continue
        enddo
        return
        end
        subroutine bondv(natom,itype,bcon)
        include 'newbonds.h'
C       Generate the bonding constraint
C       occer false means no atom
        dimension itype(*)
        bcon=0
        if(.not.bonding)return
        do j1=1,natom
                scon=5
                k1=itype(j1)
                if(k1.eq.0)goto 10
                do j2=1,natom
                        k2=itype(j2)
C       Note: change to remove same-atom bond
                        if(k2.ne.0.and.j1.ne.j2)then
                                scon=min(scon,bondx(k1,j1,k2,j2))
                        endif
                enddo
                bcon=bcon+scon
10              continue
        enddo
        return
        end
                
        subroutine bumpdr(natm,ntype)
C       Setup a matrix for the bumping constraint
        include 'newbonds.h'
C       INCLUDE 'base_atoms.h'
        natom=natm
C       if(.not.bonding)return
        if(.not.bumper)then
C               bondb=0
                return
        endif
        do j1=1,natom
                do j2=j1,natom
                        r=bondd(j1,j2)
                        do k1=1,ntype
                        do k2=k1,ntype
                                bt=0
                                tol=bumpa(k1,k2)
                                if(r.lt.tol)then
                                        if(j1.eq.j2)then
                                                bt=(tol-2*r)/tol
                                                bt=1-bt*bt
                                        else
                                                tol=(tol-r)/tol
                                                bt=tol*tol
                                        endif
                                endif
                        bondb(k1,j1,k2,j2)=bt
                        bondb(k2,j1,k1,j2)=bt
                        bondb(k1,j2,k2,j1)=bt
                        bondb(k2,j2,k1,j1)=bt
                        enddo
                        enddo
                enddo
        enddo
C       write(6,*)'Set bumping constraint matrix'
        return
        end

        subroutine bonddr(natm,ntype)
C       Setup a matrix for the bonding constraint
        include 'newbonds.h'
        real r,tol
C       INCLUDE 'base_atoms.h'
        natom=natm
        if(.not.bonding)then
C           bondx=0
            return
        endif
        do j1=1,natom
                do j2=j1,natom
                        r=bondd(j1,j2)
                        do k1=1,ntype
                        do k2=k1,ntype
                                bt=0
                                tol=bonda(k1,k2)
C       Trap < 0.25 to mean no bonding
                                if(tol.lt.0.25)then
                                        bt=25
                                else if(r.gt.tol)then
                                        tol=(r-tol)/tol
                                        bt=tol*tol
                                endif
                        bondx(k1,j1,k2,j2)=bt
                        bondx(k2,j1,k1,j2)=bt
                        bondx(k1,j2,k2,j1)=bt
                        bondx(k2,j2,k1,j1)=bt
                        enddo
                        enddo
                enddo
        enddo
C       write(6,*)'Set bond constraint matrix'
        return
        end

        subroutine bonddset(x,y,z,symm,natm)
C       Setup a matrix for the minimum distance of each atom to the 
C       expanded set of symmetry equivalent atoms
        include 'newbonds.h'
        character*4 symm
        real dx,dy,dz,bb
        dimension x(*),y(*),z(*),xe(12),ye(12)
C       INCLUDE 'base_atoms.h'
        natom=natm
        do j1=1,natom
        call asymm(x(j1),y(j1),ne,xe,ye,symm)
        do j2=j1,natom
C               dz=z(j1)-z(j2)
                dz=0
                n0=1
                bmin=999
                if(j1.eq.j2)n0=2
                do n=n0,ne
                        dx=x(j2)-xe(n)
                        dy=y(j2)-ye(n)
                        dx=dx-nint(dx)
                        dy=dy-nint(dy)
                        bb=dist3(dx,dy,dz)
                        bmin=min(bb,bmin)
                enddo
                if(bmin.gt.1e-5)bmin=sqrt(bmin)
                bondd(j1,j2)=bmin
                bondd(j2,j1)=bmin
        enddo
        enddo
C       write(6,*)'Set bond distance matrix'
        return
        end

      real function dist3(dx,dy,dz)
C     Return distance between two atoms
        real ang,aa,bb,ab,cc,dx,dy,dz
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      save aflag,aa,bb,ab,cc
        logical aflag
      data aflag/.true./
      if(aflag)then
                ang=cell(6)*asin(1.0d0)/90.d0
                aa=cell(1)*cell(1)
                bb=cell(2)*cell(2)
                ab=2.*cell(1)*cell(2)*cos(ang)
                cc=cell(3)*cell(3)
                aflag=.false.
      endif
      dist3=dx*dx*aa+dy*(dy*bb+dx*ab)+dz*dz*cc
C      dist3=sqrt(r)
      return
      end
