        real function snewcon(x,y,z,symm,itype,natm)
        include 'newbonds.h'
        real x(*),y(*),z(*),bbump
        character*4 symm
        integer itype(*)
        natom=natm
C       Setup the matrix of values
        call sbondset(x,y,z,symm,natom)
C       Do the bonding constraint
        call sbondr(natom,itype)
C       Do the bumping constraint
        call sbumpr(natom,itype)
        if(coord)then
                call scordset(x,y,z,symm,natom)
        endif
C       Generate the constraint value
        call sbothc(natom,itype,bbump)
        snewcon=bbump*10
        return
        end

        subroutine sbothc(natom,itype,bbump)
        include 'newbonds.h'
C       Generate the bumping constraint
C       occer false means no atom
        real bbump,dminb
        dimension itype(*)
        bbum=0
        bbnd=0
        do j1=1,natom
                dminb=25
                do j2=1,natom
C       Bumping
                if(bumper)bbum=bbum+max(sbondb(j1,j2),0.)
C       Bonding; changed to remove same atom
                if(bonding.and.j1.ne.j2)dminb=min(dminb,sbondx(j1,j2))
                enddo
                bbnd=bbnd+max(dminb,0.)
10              continue
        enddo
        bbump=0
        if(bumper)bbump=max(bbum,0.)
        if(bonding)bbump=bbump+max(bbnd,0.)
        if(coord)then
                call scoord(natom,itype,bcord)
                bbump=bbump+max(bcord,0.)
        endif
        return
        end
        subroutine sbumpr(natom,itype)
C       Setup a matrix for the bumping constraint
        include 'newbonds.h'
        real r,tol
        integer itype(*)
        if(.not.bumper)then
C               sbondb=0
                return
        endif
        do j1=1,natom
                k1=itype(j1)
                do j2=j1,natom
                        r=sbond(j1,j2)
                        k2=itype(j2)
                        sbondb(j1,j2)=0
                        tol=bumpa(k1,k2)
                        if(r.lt.tol)then
                                if(j1.eq.j2)then
                                     if(r.lt.tol*0.5)then
                                        tol=r/tol
                                     else
                                        tol=(tol-r)/tol
                                     endif
                                     sbondb(j1,j2)=tol*tol
                                else
                                     tol=(tol-r)/tol
                                     sbondb(j1,j2)=tol*tol
                                endif
                        endif
                sbondb(j2,j1)=sbondb(j1,j2)
                enddo
        enddo
        return
        end
        subroutine sbondr(natom,itype)
C       Setup a matrix for the bonding constraint
        include 'newbonds.h'
        real r,tol
        integer itype(*)
        if(.not.bonding)then
C               sbondx=0
                return
        endif
        do j1=1,natom
                k1=itype(j1)
                do j2=j1,natom
                        r=sbond(j1,j2)
                        k2=itype(j2)
                        sbondx(j1,j2)=0
                        tol=bonda(k1,k2)
C       Trap tol < 0.25 to mean no bonding
                        if(tol.lt.0.25)then
                                sbondx(j1,j2)=25
                        else if(r.gt.tol)then
                                tol=(r-tol)/tol
                                sbondx(j1,j2)=tol*tol
                        endif
                        sbondx(j2,j1)=sbondx(j1,j2)
                enddo
        enddo
        return
        end
        subroutine sbondset(x,y,z,symm,natom)
C       Setup a matrix for the minimum distance of each atom to the 
C       expanded set of symmetry equivalent atoms
        include 'newbonds.h'
        character*4 symm
        real dx,dy,dz,bb,sdist2,bmin
        real x(*),y(*),z(*),xe(12),ye(12)
        integer ncont(20)
        dimension cell(6),tempf(20)
        common /sfcom1/tempf,ncont,natomq,cell
        do j1=1,natom
        do j2=1,natom
        call asymm(x(j2),y(j2),ne,xe,ye,symm)
C               dz=(z(j1)-z(j2))*cell(3)
C               dz=dz*dz
                dz=0
                n0=1
                bmin=999
                if(j1.eq.j2)n0=2
                do n=n0,ne
                        dx=x(j1)-xe(n)
                        dy=y(j1)-ye(n)
                        dx=dx-nint(dx)
                        dy=dy-nint(dy)
                        bb=sdist2(dx,dy)
                        bmin=min(bb,bmin)
                enddo
                bmin=bmin+dz
                if(bmin.gt.1e-4)bmin=sqrt(bmin)
                sbond(j1,j2)=bmin
C               sbond(j2,j1)=bmin
        enddo
        enddo
        return
        end
      real function sdist3(dx,dy,dz)
C     Return distance between two atoms
      real ang,aa,bb,ab,cc,dx,dy,dz
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      save aflag,aa,bb,ab,cc
      logical aflag
      data aflag/.true./
      if(aflag)then
                   ang=cell(6)*asin(1.0d0)/90.d0
                   aa=cell(1)*cell(1)
                   bb=cell(2)*cell(2)
                   ab=2.*cell(1)*cell(2)*cos(ang)
                   cc=cell(3)*cell(3)
                   aflag=.false.
      endif
      sdist3=dx*dx*aa+dy*(dy*bb+dx*ab)+dz*dz*cc
C      sdist3=sqrt(r)
      return
      end
      real function sdist2(dx,dy)
C     Return distance between two atoms
      real ang,aa,bb,ab,dx,dy
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      save aflag,aa,bb,ab
      logical aflag
      data aflag/.true./
      if(aflag)then
                   ang=cell(6)*asin(1.0d0)/90.d0
                   aa=cell(1)*cell(1)
                   bb=cell(2)*cell(2)
                   ab=2.*cell(1)*cell(2)*cos(ang)
                   aflag=.false.
      endif
      sdist2=dx*dx*aa+dy*(dy*bb+dx*ab)
C      sdist3=sqrt(r)
      return
      end
