           subroutine BBLuke(Y,S,YY,F,STEP,MAXMIX,MEMORY,DMIX,DELTA)
           implicit real*4 (a-h,o-z)
           dimension STEP(MAXMIX),F(MAXMIX),YY(MEMORY,MEMORY)
           dimension Y(MAXMIX,MEMORY),S(MAXMIX,MEMORY)
           real*4 WTMP(MAXMIX),ZTMP(MAXMIX)
!--------------------------------------------------------------------
!          Bad Broyden according to Luke
!
!          Input Parameters
!          MAXMIX:         Length of the variable vector
!          MEMORY:         Total number of memory values to use
!                          Most recent is last
!          Y,S:            Conventional Y and S arrays
!          YY:             Matrix of Y*Y values
!          F:              -Grad(MAXMIX) at the current point (residue)
!          DMIX:           Scaler for initial matrix
!
!          Output
!          STEP            Bad Broyden Step
!--------------------------------------------------------------------
!
!           allocate(WTMP(MAXMIX),ZTMP(MAXMIX))
!           TEMPZW= -DOT_PRODUCT(Y(1:MAXMIX,MEMORY),F(1:MAXMIX))
           TEMPZW = 0
           DO J=1,MAXMIX
              TEMPZW=TEMPZW-Y(J,MEMORY)*F(J)
           ENDDO
           TEMPZW=  TEMPZW/YY(MEMORY,MEMORY)
!
           DO J=1,MAXMIX
              Wtmp(J)= -F(J)
              Ztmp(J)=  S(J,MEMORY)*TEMPZW
           ENDDO
           DO J=0,MEMORY-2
              TEMPW=TEMPZW
              TEMPZW=0.0D0
              DO K=1,MAXMIX
                 Wtmp(K) = Wtmp(K)- Y(K,MEMORY-J)*TEMPW
                 TEMPZW =  TEMPZW+Y(K,MEMORY-J-1)*Wtmp(K)
              ENDDO
              TEMPZW = TEMPZW/YY(MEMORY-J-1,MEMORY-J-1)
              DO K=1,MAXMIX
                 Ztmp(K)=Ztmp(K)+S(K,MEMORY-J-1)*TEMPZW
              ENDDO
           ENDDO
!
!           Finish up
           DO J=1,MAXMIX
              Wtmp(J)=Wtmp(J) - Y(J,1)*TEMPZW
!          Resolve sign of Ztmp...does not match writeup
              STEP(J) = -DMIX*Wtmp(J)+Ztmp(J)
           ENDDO
!
!           deallocate(Wtmp, Ztmp)

!--------------------------------------------------------------------
!           end bad Broyden according to Luke
!--------------------------------------------------------------------
           return
           end

