C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SGM1M (FHK, H, K, NREF, SYMM, IDEF )
C     Let us look for sigma1 definitions of missing beams
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         include 'Nlimit.h'
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION FHK(*)
         INTEGER IFOUND(NHK2), IDEF(NHK2,60)
         CHARACTER*4 SYMM
         CHARACTER*1 SIGNER
         INTEGER HE(20), KE(20), ISE(20), H(*), K(*)
         INTEGER HM(NHK2), KM(NHK2)
         DIMENSION SUMM(NHK2)
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         INTEGER II1, II2, II3, II4, II5
         REAL RR1, RR2, RR3
         LOGICAL LL1, LL2
 
C     Missing beams
         DO   J=NREF+1,NPAD
           II4 = H(J)
           II5 = K(J)
           HM(J-NREF) = II4
           KM(J-NREF) = II5
         END DO
         NMSSD = NPAD - NREF 
 
         IF (NPAD - NREF .NE. 0) THEN
           write (10,*)' '
           WRITE (6, *) 'There are ', NPAD - NREF ,
     X        ' holes in the data'
           WRITE (10, *) 'There are ', NPAD - NREF ,
     X        ' holes in the data'
           DO   J=1,NPAD-NREF
             WRITE (10, 902) HM(J), KM(J)
  902        FORMAT(' ** Undetermined Beam (',I3,',',I3,')')
           END DO
C     Now the same code as in sigma1, looking at unknowns
C     Change -- make npad not nref here
           DO   J=1,NPAD
C     Zero array of found values for later
             IFOUND(J) = 0
             SUMM(J) = 0.
             IF (H(J) .EQ. 0 .AND. K(J) .EQ. 0) I0 = J
           END DO
 
           DO   J=1,NREF
             IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
               IHH = H(J)
               IKK = K(J)
               CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
               RR2 = FHK(J) * FHK(J)
               DO   I1=1,NE
                 II1 = ISE(I1)
                 LL1 = II1 .EQ. 3
                 LL2 = II1 .EQ. 1000
                 II2 = HE(I1)
                 II3 = KE(I1)
                 RR1 = RR2
                 DO   I2=I1,NE
                   ISIGN = 0
                   ISIGN1 = 0
                   ISIGN2 = 0
                   IF (II1 * ISE(I2) .EQ. (-1)) ISIGN = 1
                   IF (LL1) THEN
                     ISIGN1 = 1
                   END IF
                   IF (ISE(I2) .EQ. 3) ISIGN2 = 1
                   IF (LL2) ISIGN1 = (-1)
                   IF (ISE(I2) .EQ. 1000) ISIGN2 = (-1)
                   ISIGN1 = ISIGN1 * ISIGN2
                   ITHERE = 0
                   IF (ISIGN .GT. 0) ITHERE = 1
                   IF (ISIGN1 .NE. 0) ITHERE = ISIGN1
                   IF (ITHERE .NE. 0) THEN
C     Note: there may be more cases to include later.      See if this beam is p
                     IHH = II2 + HE(I2)
                     IKK = II3 + KE(I2)
C     See if this beam is part of the starting set
                     JK = ICHECK (IHH,IKK,HM,KM,NMSSD)
                     IF (JK .GT. 0) THEN
C     Store the index, positive for 2pi, -ve for pi
                       SUMM(JK) = SUMM(JK) + RR1 * ITHERE
                       IF (I1 .NE. I2) SUMM(JK) = SUMM(JK) + RR1 *
     X                    ITHERE
                       N = IFOUND(JK) + 1
                       IFOUND(JK) = IFOUND(JK) + 1
                       IDEF(JK,N) = ITHERE * J
                     END IF
                   END IF
 
C     Done searching this reflection
                 END DO
               END DO
             END IF
           END DO
 
 
 
           WRITE (10, 10)
           WRITE (10, 20)
   20      FORMAT('Sigma-1 Relationships on missing beams'/
     X        'Beams (1x1?) strongly defined by Sigma-1 relationships '/
     X        'but are absent from the data may be strong')
C           WRITE (10, 10)
           RR3 = FHK(I0)
C     Print out the results
           DO   J=1,NMSSD
             IF (IFOUND(J) .GT. 0) THEN
               WRITE (10, 10)
               WRITE (10, 1) HM(J), KM(J)
   10          FORMAT(
     X            '*************************************************')
    1          FORMAT('Beams defining (',I3,',',I3,'), E: Unknown')
               DO   I=1,IFOUND(J)
                 IND = ABS (IDEF(J,I))
                 SIGNER = '+'
                 IF (IDEF(J,I) / IND .EQ. (-1)) SIGNER = '-'
                 WRITE (10, 2) H(IND), K(IND), FHK(IND), SIGNER
    2            FORMAT('Beam (',I3,',',I3,') E:',F10.5,' Sign ',A)
               END DO
               IF (IFOUND(J) .GT. 1) THEN
                 SEST = SUMM(J) / RR3
                 WRITE (10, 201) SUMM(J), SEST
                 IF (SEST .GT. 2.D0) WRITE (1, 202) HM(J), KM(J), SEST
  202            FORMAT('REM WARNING: Missing Reflection (',I3,',',I3,
     X              ', 0) ','May be large, Estimated E ',F10.5)
               END IF
             END IF
  201        FORMAT('Total squared  ',F10.5,' Guesstimate E, ',F8.4)
           END DO
           WRITE (10, 10)
           RETURN
         END IF
 
         WRITE (10, *) 'No Sigma-1 relationships on missing beams'
         RETURN
       END
 
