      subroutine calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C       Given x,y,z
C       Return in fcalc, acalc, values for nref beams
C       With scale in scl
        dimension xe(12),ye(12)
        dimension ih(*),k(*),l(*),ftrueh(*),fcalc(*),acalc(*)
        dimension wts(*),fgot(*),zatom(*),itype(*)
        dimension x(*),y(*),z(*),ahk(*)
C       real*8 fbump
        character*4 symm
        complex amp, amp2
        include 'errref.h'
        include 'ffact.h'
         include 'Nlimit.h'
C        PARAMETER (NHK2 = 900)
        DIMENSION MULTI(NHK2)
        COMMON /MPCOMM/MULTI
C     Zero term
      f0=0
      ntot=0
      call settyp(itype,fgot,natom,zatom)
      do n=1,natom
         call asymm(x(n),y(n),ne,xe,ye,symm)
         f0=f0+ne*ffact(nref,itype(n))
         ntot=ntot+ne
      enddo
      write(6,*)natom,' irreducible atoms, ',ntot,' total'
      pi2=4.*asin(1.0)
      s1=0.0
      s2=0.0
      s3=0.0
      sa1=0
      sa2=0
C     Calculate the structure factor
      do j=1,nref
      u=ih(j)*pi2
      v=k(j)*pi2
C      w=l(j)*pi2
      amp=0.0
      do n=1,natom
         amp2=0
         call asymm(x(n),y(n),ne,xe,ye,symm)
C         zp=w*z(n)
         zp=0
         do nn=1,ne
         p=u*xe(nn)+v*ye(nn)+zp
         amp2=amp2+cmplx(cos(p),-sin(p))
         enddo
         amp=amp+amp2*ffact(j,itype(n))
      enddo
      tamp=amp*conjg(amp)
      if(tamp.gt.1d-10)then
        fcalc(j)=sqrt(tamp)/f0
        acalc(j)=atan2(aimag(amp),real(amp))
      else
        acalc(j)=pi2
        fcalc(j)=0
      endif
      if(acalc(j).lt.1e-3)acalc(j)=acalc(j)+pi2
      if((ih(j).ne.0).or.(k(j).ne.0).or.(l(j).ne.0))then
C               Let's fit the structure factors, R**2 fashion
                fc=fcalc(j)
                fh=ftrueh(j)
                tmp=acalc(j)-ahk(j)
                twt=1+tmp
                twt=twt/(1+twt)*multi(j)
                s1=s1+fc*fh*twt
                s2=s2+fc*fc*twt
                sa1=sa1+fc*multi(j)
                sa2=sa2+fh*multi(j)
      endif
      enddo
C     Calculated R-factor
C       s1 has calculated, s2 has observed
      scl=s1/s2
C     Trap negative scale
      if(scl.lt.0)scl=sa2/sa1
C      if(erron.gt.7)scl=sqrt(scl)
      err=0.0
      open(unit=13,file='rfcalc.dat')
      write(13,*)'Output of R**2 on S.F. fitted data ',scl
      write(13,99)
99    format('   H   K   L      Fobs        Fcalc     Diff*100')
      R2=0
      S2=0
      R1=0
      S1=0
      do j=1,nref
        fcalc(j)=fcalc(j)*scl
          write(13,9909)ih(j),k(j),l(j),ftrueh(j),
     1  fcalc(j),(ftrueh(j)-fcalc(j))*100,acalc(j),ahk(j)
9909    format(3i4,6f12.6)
      if((ih(j).ne.0).or.(k(j).ne.0).or.l(j).ne.0)then
        fc=fcalc(j)
        fh=ftrueh(j)
        errt=fh-fc
        R2=R2+errt*errt
        R1=R1+abs(errt)
        S1=S1+fh
        S2=S2+fh*fh
      endif
      enddo
      R1=R1/S1
      R2=sqrt(R2/S2)
C      write(6,*) 'R2 ',R2,' R1 ',R1,' Scalings ',scl
C      write(13,*)'R2 ',R2,' R1 ',R1,' Scalings ',scl           
      close(unit=13)
      return
      end

