c  This program is free software; you can redistribute it and/or modify
c  it under the terms of the GNU General Public License as published by
c  the Free Software Foundation; either version 2 of the License, or
c  (at your option) any later version.
c 
c  This program is distributed in the hope that it will be useful,
c  but WITHOUT ANY WARRANTY; without even the implied warranty of
c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c  GNU General Public License for more details.
c 
c  You should have received a copy of the GNU General Public License
c  along with this program; if not, write to the Free Software
c  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c 
c
c program cross selects parents and performs crossover
c in a given population

c     selection supports chromosomes with high fitness

      program cross1

      INCLUDE 'CrossPars.h'
c  nindiv: number of chromosomes in one population
c  nchild: number of children
c  totbit: total number of bits describing 1 chromosome
c  bit(i,j): bit j in chromosome i
c  pmark1 , pmark2 , dmark: pointer
c  nparam: number of parameters
c  fit(i): fitness of chromosome i
c  idum: seed value for random number generation
c  dummy: dummy character
c  tens: is a tnsion variable to control how strong you want to converge r1
      integer nchild , nindiv , totbit, bit(mindiv,mparam*mnbits) 
      integer pmark1 , pmark2 , dmark, nbit(mparam)
      real fit(mindiv), bitsum1(mindiv),csim(mindiv),cs(mindiv)
      real css1(mindiv),css2(mindiv),css3(mindiv)
      integer bcount(mparam),ifit(mindiv)
      real wheel(mindiv)
      integer ring(mindiv,mparam),rcalc(mindiv,mparam)
      character*2 dum
      character*20 tnsion,ttemp
      character*600 line
      real r(97), r1,tens,ahk(mparam)
      integer*4 idum,ix1,ix2,ix3,iff
      real xcf(-150:150)
      save bit, ring, rcalc,bitsum1
c     xcf coefficients
      pi2=4.*asin(1.0)
      do j=-150,150
        a=pi2*j/64.
        xcf(j)=1.+cos(a)
      enddo
      
        call getarg(1,tnsion)
        call getarg(2,ttemp)
        read(ttemp,*,err=991,end=991)xopt
        goto 992
991     xopt=0
992     continue
      open (1,file='bithelp',status='old')
      open (2,file='fitfile',status='old')
      open (3,file='cross1.check',status='unknown')
      open (4,file='lpop',status='unknown')
      open (5,file='control',status='old')
      open (12,file='random.hold')
      open (13,file='calc2.log')

   10 format (i4)
   20 format (f15.4,a2,600i1)
   30 format (f15.4,a2,600i1)


c======================================================================
c read in random number generator parameters from file 'random.hold'
c======================================================================
      read(12,*) ix1,ix2,ix3,idum,iff
      do i=0,31
        read(12,*) (r(j),j=(i*3+1),(i*3+3))
      enddo
      read(12,*) r(97)
      
c======================================================================
c read needed information from file 'bithelp'
c======================================================================

c number of parameters, bits, children
      read (5,10) nparam
      do i=1,nparam
         read (5,10)nbit(i)
      enddo
      bcount(1)=nbit(1)
      do i=2,nparam
        bcount(i)=bcount(i-1)+nbit(i)
      enddo
      do 150 i=1,3
         read (5,*)
150   continue
      read (5,*) nchild

c total number of bits for one chromosome?
      read (1,10) totbit

c total number of chromosomes in one population?
      read (1,10) nindiv

c======================================================================
c read in tnsion variable from execution line
        read (tnsion,*,err=151) tens
        goto 152
 151    tens=1.0
 152    continue

c======================================================================
C       write(6,*)'Got 1'
c read fitness and bitcode for all chromosomes
c======================================================================
        npt=nindiv*20
        nindiv=0
        fmin=1e7
        fmax=-1e7
C        write(6,*)totbit
      do 100 i=1,npt
         read(2,201,err=153,end=153)line
 201     format(a)
         read (line,20,err=153,end=153)fit(i),dum,(bit(i,j),j=1,totbit)
         ii=18+totbit
         read(line(ii:ii+10),*)ifit(i)
C        write(6,*)'Got 2'
         if(fit(i).lt.fmin)fmin=fit(i)
         if(fit(i).gt.fmax)fmax=fit(i)
         nindiv=nindiv+1
c        write(15,*)fit(i),ifit(i)

c       Convert bit-string to a number between 0-64
               kk=0
               do k=1,nparam
               iactval = 0
               ii=1
               do j=nbit(k),1,-1
                  iactval = iactval + bit(i,j+kk)*ii
                  ii=ii*2
               enddo
               kk=kk+nbit(k)
               ring(i,k)=iactval*(64/ii)
               enddo
100     continue
153     continue

c       Read from calc2.log the final values
        ngot=0
        do j=1,9999999
        read(13,201)line
        do i=1,nindiv
        if(j.eq.ifit(i))then
        ngot=ngot+1
        read(line,*)ip,ff,(ahk(jj),jj=1,nparam)
        do k=1,nparam
                rcalc(i,k)=nint(ahk(k)*64/360.)
        enddo
        if(ngot.eq.nindiv)goto 1530
        endif
        enddo
        enddo
1530    continue        
c       Run through and find cross-similarity
c       Tension adjusted fitness
c       max at start, decreasing
        wsum=0
        frange=(fmin-fmax)*float(nindiv)
        ttens=9
        fff=ttens*tens+1
        do i=1,nindiv
                ff=(fit(i)-fmax)/frange
                wheel(i)=ff*(nindiv+1-i)*ttens*tens+1
                wheel(i)=wheel(i)/fff
                wsum=wsum+wheel(i)
                bitsum1(i)=wheel(i)
        enddo
        do i=1,nindiv
                wheel(i)=wheel(i)/wsum
        enddo
        do i=2,nindiv
                wheel(i)=wheel(i-1)+wheel(i)
        enddo
        csum=0
        ctt=sqrt(float(nindiv))
        do i=1,nindiv
                csim(i)=0
                c2=0
                c3=0
                do j=1,nindiv
                        temp=0.
                        temp2=0.
                        if(j.eq.i)goto 87
                        do jj=1,nparam
                        idiff=ring(i,jj)-ring(j,jj)
                        temp=temp+xcf(idiff)
                        idiff=rcalc(i,jj)-rcalc(j,jj)
                        temp2=temp2+xcf(idiff)
                        enddo
                c2=c2+temp*bitsum1(j)
                c3=c3+temp2*bitsum1(j)
87              enddo
c       c2 now contains the distance weighted probability
c       save in csim(i) the shared fitness probability
                c4=(c2+c3*0.5)/float(nindiv)
                c4=c4*c4
                csim(i)=ctt*bitsum1(i)/c4
                if(i.eq.1)then
                        cscl1=csim(i)
                        cscl2=c2
                        cscl3=c3
                endif
C               write(3,89)i,bitsum1(i),csim(i)/cscl1,c2/cscl2,
C     $ c3/cscl3,fit(i)
89              format(i5,5f12.6)
                csum=csum+csim(i)
        css2(i)=c2/cscl2
        css3(i)=c3/cscl3
        enddo

C       Renormalize sharing terms
        ss2=0
        ss3=0
        do i=1,nindiv
                ss2=ss2+css2(i)
                ss3=ss3+css3(i)
        enddo
        st2=0
        st3=0
        ss2=ss2/nindiv
        ss3=ss3/nindiv
        s2min=100
        s2max=-100
        s3min=100
        s3max=-100
        do i=1,nindiv
                css2(i)=css2(i)/ss2
                css3(i)=css3(i)/ss3
                if(css2(i).gt.s2max)s2max=css2(i)
                if(css2(i).lt.s2min)s2min=css2(i)
                if(css3(i).gt.s3max)s3max=css3(i)
                if(css3(i).lt.s3min)s3min=css3(i)
                t2=css2(i)-1
                t3=css3(i)-1
                st2=st2+t2*t2
                st3=st3+t3*t3
        enddo
        if(st2.gt.1d-5)then
                st2=sqrt(st2/nindiv)
        else
                st2=1
        endif
        if(st3.gt.1d-5)then
                st3=sqrt(st3/nindiv)
        else
                st3=1
        endif
        write(3,*)'Sharing mode F1'
        write(3,*)'STD of populations ',st2,st3
        write(6,*)'STD of populations ',st2,st3
        if(st2.gt.xstd.or.st3.gt.xstd)then
        write(3,*)'Warning, STD large, danger of premature convergence'
        write(6,*)'Warning, STD large, danger of premature convergence'

                do j=1,nindiv
                        t=1-bitsum1(j)
                        bitsum1(j)=1-t*0.5
                enddo
        endif
        write(3,606)
606     format('  Member  Weight      Wheel      Share 1 ',
     1         '    Share 2     Fitness')
        csum=0
        st2=max(3.0,xstd/st2)
        st3=max(3.0,xstd/st3)
C       Limit minimum > 1/3
        trap2=1-s2min
        st2=min(st2,0.667/trap2)*shareamp
        trap3=1-s3min
        st3=min(st3,0.667/trap3)*shareamp
        do i=1,nindiv
                css2(i)=1+(css2(i)-1)*st2
                css3(i)=1+(css3(i)-1)*st3
                css2(i)=max(0.1,css2(i))
                css3(i)=max(0.1,css3(i))
                csim(i)=2.d0*bitsum1(i)/(css2(i)+css3(i))
                write(3,89)i,csim(i),bitsum1(i),css2(i),
     $ css3(i),fit(i)
        csum=csum+csim(i)

        enddo

c       Renormalize
        do i=1,nindiv
                csim(i)=csim(i)/csum
                cs(i)=csim(i)
        enddo

        write(3,3301)
3301    format(/'Cross-over Table'/
     1  '   #1   #2   Fit #1    Fit #2    Prob #1',
     2  '   Prob #2')
c======================================================================
c produce large population as next generation
c======================================================================
        

c======================================================================
c start loop for reproduction
        sumcur=1
        nc2=nchild/2
        do 200 m=1,nc2

c       We now have, the absolute probabilities
c       weighted by a shared distanace fitness term
c       Sort these up
        csim(1)=cs(1)/sumcur
        do i=2,nindiv
                csim(i)=csim(i-1)+cs(i)/sumcur
        enddo
c        select first parent
c        create random number for parent selection
                call ranc1(ix1,ix2,ix3,idum,iff,r,r1)
                
        do i=1,nindiv
                if(r1.le.csim(i))then
                        pmark1=i
                        goto 210
                endif
        enddo
        pmark1=nindiv
210     continue

c        select second parent

cc *************** NEW version *************** EL 4_4_97
cc this is based on a sharing algorithm where the 
cc second parent is chosen based upon how similar 
cc it is to the first parent. Goldberg 1985.

cc Modified by LDM to treat each gene as a ring
        
        bsum=0
        do ii=1,nindiv
                bitsum1(ii)=0.
                if(ii.eq.pmark1)goto 86
                do jj=1,nparam
c       This is a saw-tooth, min when values differ by half of range
                        idiff=ring(ii,jj)-ring(pmark1,jj)
                        bitsum1(ii)=bitsum1(ii)+xcf(idiff)
                enddo
c       Do not Weight by shared fitness as well
                bitsum1(ii)=bitsum1(ii)*cs(ii)
                if(cs(ii).lt.1e-7)bitsum1(ii)=0
                bsum=bsum+bitsum1(ii)
86      enddo
        
        do ii=1,nindiv
                bitsum1(ii)=bitsum1(ii)/bsum
        enddo
        do ii=2,nindiv
                bitsum1(ii)=bitsum1(ii)+bitsum1(ii-1)
        enddo

c        create random number for parent selection
        idebtr=0
 300     call ranc1(ix1,ix2,ix3,idum,iff,r,r1)
 
c        support chromosomes with high fitness
        do i=1,nindiv
                if(r1.le.bitsum1(i).and.cs(i).gt.1e-6)then
                        pmark2=i
                        goto 310
                endif
        enddo
        if(cs(nindiv).lt.1e-6.and.idebtr.lt.20)then
                idebtr=idebtr+1
                goto 300
        endif
        pmark2=nindiv
310     continue
        
         if (pmark1 .eq. pmark2) goto 300



c     select dividing point
c        create random number for dividing point
        itries=0
320             call ranc1(ix1,ix2,ix3,idum,iff,r,r1)
                dmark = 1 + aint(r1*(real(nparam)))
                if(dmark.ge.nparam)goto 320
                dmark=bcount(dmark)
c       Check that dividing point produces new individuals
        call trapdiv(bit,pmark1,pmark2,dmark,totbit,iflag)
        itries=itries+1
        if(itries.lt.10)then
                if(iflag.eq.2)goto 300
                if(iflag.eq.1)goto 320
        endif

c     write next generation into file 'lpop'
        write(3,88)pmark1,pmark2,fit(pmark1),fit(pmark2),
     1  cs(pmark1)*nchild,cs(pmark2)*nchild
88      format(2i5,4f10.6)

         write (4,30) 1.,'  ',(bit(pmark1,j),j=1,dmark),
     1                        (bit(pmark2,j),j=dmark+1,totbit)

         write (4,30) 2.,'  ',(bit(pmark2,j),j=1,dmark),
     2                        (bit(pmark1,j),j=dmark+1,totbit)
        
c end loop for reproduction
c       Reduce probability for parents
        cs(pmark1)=cs(pmark1)-1.0/float(nchild)
        cs(pmark2)=cs(pmark2)-1.0/float(nchild)
        if(cs(pmark1).lt.0.1/float(nchild))cs(pmark1)=0
        if(cs(pmark2).lt.0.1/float(nchild))cs(pmark2)=0
        sumcur=0
        do i=1,nindiv
                sumcur=sumcur+cs(i)
        enddo

200   continue
C       Debug output
C        write(3,*)'Debug'
C        do i=1,nindiv
C                write(3,3414)i,cs(i)*nchild
C3414    format(i4,f12.5)
C        enddo

c======================================================================
c Save numbers for random number generator
c======================================================================
      rewind(12)
      write(12,*) ix1,ix2,ix3,idum,iff
      do i=0,31
        write(12,*) (r(j),j=(i*3+1),(i*3+3))
      enddo
      write(12,*) r(97)
      

      end

c======================================================================

c subroutine ranc1() is a random number generator care Numerical Recepies Book
c      real*8 function ranc1(idum)
      subroutine ranc1(ix1,ix2,ix3,idum,iff,r,random)
c      implicit real*8 (a-h,o-z)
      real r(97),random
      integer*4 ix1,ix2,ix3 
      parameter (m1=259200,ia1=7141,ic1=54773,rm1=1./m1)
      parameter (m2=134456,ia2=8121,ic2=28411,rm2=1./m2)
      parameter (m3=243000,ia3=4561,ic3=51349)
      if (idum.lt.0.or.iff.eq.0) then
              iff=1
              ix1=mod(ic1-idum,m1)
              ix1=mod(ia1*ix1+ic1,m1)
              ix2=mod(ix1,m2)
              ix1=mod(ia1*ix1+ic1,m1)
              ix3=mod(ix1,m3)
              do j=1,97
                      ix1=mod(ia1*ix1+ic1,m1)
                      ix2=mod(ia2*ix2+ic2,m2)
                      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
              enddo
              idum=1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      random=r(j)
      if(random.gt.1.0d0)random=random-int(random)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      return
      end
