C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine geneticb(nvar,vali,nchild,nparent,ncycles,
     $  nel,nsol,mprb,f,initg)
      include 'Gpars.h'
      include 'ffact2.h'
      common /fomgen2/ntypes,zocc
      dimension itcode(20),zocc(20)
      integer vali(*)
      real mprob,mprb
C     logical recfile
      complex f(*)
      logical ldebug
      character*7 filen
      parameter (ldebug=.false.)
      xfc1=1
      xfc2=7.5
c     Set seed value (for consistency)
      idum=-1
c     over-ride parent reduction
      nparent=nchild
      do j=1,nvar
         nvals(j)=vali(j)
      enddo
c     Decode the occupancies
C      call settyp(itcode,zocc,ntypes,zatom)
      do j=1,20
         itcode(j)=j
      enddo
      npars=nvar
C     Initialize (if requested)
      if(initg.lt.0)call ginitN(nchild)
C     Calculate FOMs
      call fomcalcb(nchild,nvar,fomchild,child,ngmax,npop,f,itcode,-1)
C     Average fom of population
      foma=0
      do j=1,nchild
         foma=foma+fomchild(j)
      enddo
      foma=foma/float(nchild)
       if(ldebug)then
        if(irun.lt.10)then
                write(filen,901)'solns0',irun
        else
                write(filen,902)'solns',irun
        endif
901     format(a,i1)
902     format(a,i2)
        irun=irun+1
        open(unit=16,file=filen)
      endif
C
C     Retain best to date (+ elite)
      nelite=0
      call bestmem1(nchild,nsol,nparent,nelite)
      if(ldebug)then
        do j=1,nchild
        write(16,913)fomchild(j),(child(k,j),k=1,npars)
913             format(f10.5,'  ',50i1)
        enddo
        close(unit=16)
      endif
C
      fomss=0
      do j=1,nsol
         fomss=fomss+fomsol(j)
      enddo
      fomss=fomss/float(nsol)
      write(6,1)'Cycle ',0,' Average ',foma,' Best ',fomsol(1),
     1 ' Sol Ave ',fomss

      do nc=1,ncycles
C     Generate Children
      tension=1+0.5*exp(-nc/3.)
      call crossN(tension,nchild,nparent,sdev)
        mprob=mprb*xfc1+exp(-sdev*xfc2)
C       write(6,*)'STD dev of population ',sdev,' mut ',mprob
C     Mutate
      call mutate(mprob,nchild)

C     Calculate FOMs
      call fomcalcb(nchild,nvar,fomchild,child,ngmax,npop,f,itcode,1)

C     Average fom of population
      foma=0
      do j=1,nchild
         foma=foma+fomchild(j)
      enddo
      foma=foma/float(nchild)

C     Retain best to date (+ elite)
      nelite=0
      if(2*(nc/2).eq.nc)nelite=nel
      call bestmem(nchild,nsol,nparent,nelite)
      fomss=0
      do j=1,nsol
         fomss=fomss+fomsol(j)
      enddo
      fomss=fomss/float(nsol)
      write(6,1)'Cycle ',nc,' Average ',foma,' Best ',fomsol(1),
     1 ' Sol Ave ',fomss,' STD ',sdev
C
      if(ldebug)then
        if(irun.lt.10)then
                write(filen,901)'solns0',irun
        else
                write(filen,902)'solns',irun
        endif
        irun=irun+1
        open(unit=16,file=filen)
       do j=1,nsol
         write(16,913)fomsol(j),(solutions(k,j),k=1,npars)
       enddo
       close(unit=16)
      endif
C
      enddo
      return
1     format(a,i4,a,f8.4,a,f8.4,a,f8.4,a,f8.4)
      end
