C       These subroutines are for testing only and should not be
C       distributed.
        subroutine fscalet3(NATOMS,F,Z,N,Rescale,hist,fhist)
C       Suppose we have NATOMS(1,2..) with structure factors
C       F(1,2...) and U amplitudes Z(1,2...)
C       Find the effective scaling term FEFF numerically
        implicit real*8 (A-H,O-Z)
        parameter(NPT=90000)
        data iseed/1/
        save iseed
        real*4 F(N),Z(N),Rescale
        dimension natoms(N)
        dimension WZ(20),WF(20),hist(20),fhist(20)
C       Initialize if needed
        if(iseed.eq.1)then
           call ZBQLINI(ISEED)
           ISEED=0
        endif
        do j=1,20
           hist(j)=0
           fhist(j)=0
        enddo
        sumz=0
        sumf=0
        do j=1,n
           sumz=sumz+z(j)*natoms(j)
           sumf=sumf+f(j)*natoms(j)
        enddo
C       Shuffle
        do j=1,N
           work=dble(natoms(j))
           WZ(J)=dble(Z(J))*work
           WF(J)=dble(F(J))*work
        enddo
        PI2=4.D0*asin(1.D0)
        DRescale=0.D0
        DUMMY=0.D0
            do iter=1,NPT
10             continue
               t=ZBQLU01(DUMMY)
               sumfr=t*WF(1)
               sumfi=0
               sumzr=t*wz(1)
               sumzi=0
               DO j=2,N
C                 Random number, 0 to 1
                     phase=ZBQLU01(DUMMY)*pi2
                     amp=ZBQLU01(DUMMY)
                     ampf=amp*wf(j)
                     ampz=amp*wz(j)
C                    Complex contributions
                     ca=cos(phase)
                     sa=sin(phase)
                     sumfr=sumfr+ca*ampf
                     sumfi=sumfi+sa*ampf
                     sumzr=sumzr+ca*ampz
                     sumzi=sumzi+sa*ampz
               ENDDO
C              Intensities
               F2_F=sumfr*sumfr+sumfi*sumfi
               F2_Z=sumzr*sumzr+sumzi*sumzi
C              Divisor, trapped for zero
               if((F2_Z.lt.1D-4).or.(F2_F.lt.1D-4))goto 10
               Rthis=sqrt(F2_Z/F2_F)
               DRescale =DRescale +Rthis
               F2_F=sqrt(F2_F)
               IU=(20*F2_F/sumF)+1
               if(iu.le.20)then
                        hist(iu)=hist(iu)+Rthis
                        fhist(iu)=fhist(iu)+1
               endif
        enddo
C       Normalize
        Rescale=DRescale/dble(NPT)
        do j=1,20
           hist(j)=hist(j)/Rescale
        enddo
        return
        end
        subroutine scalecentold(NATOMS,F,Z,N,Rescale)
C       Suppose we have NATOMS(1,2..) with structure factors
C       F(1,2...) and U amplitudes Z(1,2...)
C       Find the effective scaling term FEFF numerically
C       Centro-symmetric case
        implicit real*8 (A-H,O-Z)
        parameter(NPT=1600)
        data iseed/1/
        save iseed
        real*4 F(N),Z(N),Rescale
        dimension natoms(N)
        dimension WZ(20),WF(20)
C       Initialize if needed
        if(iseed.eq.1)then
           call ZBQLINI(ISEED)
           ISEED=0
        endif
C       Shuffle
        do j=1,N
           work=sqrt(dble(natoms(j)))
           WZ(J)=dble(Z(J))*work
           WF(J)=dble(F(J))*work
        enddo
        DRescale=0.D0
            do iter=1,NPT
10             sumf=0.d0
               sumz=0.d0
               DO j=1,N
C                 Gaussian random number, STD 1, Mean 0
                  g=ZBQLNOR(0.D0,1.D0)
                  sumf=sumf+g*WF(j)
                  sumz=sumz+g*WZ(j)
               ENDDO
C              Intensities
               F2_F=sumf*sumf
               F2_Z=sumz*sumz
C              Divisor, trapped for zero
               if((F2_Z.lt.1D-4).or.(F2_F.lt.1D-4))goto 10
               DRescale =DRescale +sqrt(F2_Z/F2_F)
        enddo
C       Normalize
        Rescale=DRescale/dble(NPT)
        return
        end
        subroutine fscale(NATOMS,F,Z,N,Rescale,hist,fhist)
C       Suppose we have NATOMS(1,2..) with structure factors
C       F(1,2...) and U amplitudes Z(1,2...)
C       Find the effective scaling term FEFF numerically
        implicit real*8 (A-H,O-Z)
        parameter(NPT=20000)
        data iseed/1/
        save iseed
        real*4 F(N),Z(N),Rescale
        dimension natoms(N),hist(*) ,fhist(*)
C        do j=1,n
C           write(6,*)J,F(j),Z(J),N
C        enddo
C        dimension WZ(20),WF(20)
C       Initialize if needed
        if(iseed.eq.1)then
           call ZBQLINI(ISEED)
           ISEED=0
        endif
        sumz=0
        sumf=0
        do j=1,N
          sumz=sumz+z(j)*natoms(j)
          sumf=sumf+f(j)*natoms(j)
        enddo
C        write(6,*)sumz
        do j=1,20
           hist(j)=0
           fhist(j)=0
        enddo
C       Shuffle
C        do j=1,N
C           work=sqrt(dble(natoms(j)))
C           WZ(J)=dble(Z(J))*work
C           WF(J)=dble(F(J))*work
C        enddo
        PI2=4.D0*asin(1.D0)
        DRescale=0.D0
        DUMMY=0.D0
            do iter=1,NPT
10             continue
               sumfr=0
               sumfi=0
               sumzr=0
               sumzi=0
               DO j=1,N
                  tzr=0
                  tzi=0
                  DO J2=1,natoms(j)
                     phase=ZBQLU01(DUMMY)*pi2
                     tzr=tzr+cos(phase)
                     tzi=tzi+sin(phase)
                  enddo
                  sumfr=sumfr+tzr*f(j)
                  sumfi=sumfi+tzi*f(j)
                  sumzr=sumzr+tzr*z(j)
                  sumzi=sumzi+tzi*z(j)
               ENDDO
C              Intensities
               F2_F=(sumfr*sumfr+sumfi*sumfi)
               F2_Z=(sumzr*sumzr+sumzi*sumzi)
C              Divisor, trapped for zero
               if((F2_Z.lt.1D-4).or.(F2_F.lt.1D-4))goto 10
               F2_Z=sqrt(F2_Z)
               F2_F=sqrt(F2_F)
               Rthis= (F2_Z/F2_F)
               DRescale =DRescale + Rthis
               U=(F2_f)/sumf
C               write(16,*)U,f2_z,sumz,rthis
               IU=int(20*U)+1
               if(iu.gt.20)iu=20
               hist(IU)=hist(IU)+Rthis
               fhist(iu)=fhist(iu)+1
        enddo
C       Normalize
        Rescale=DRescale/dble(NPT)
        do j=1,20
C           t=dble(fhist(j))/(fhist(j)*fhist(j)+0.01)
           hist(j)=hist(j)/Rescale
C           write(16,*)j,hist(j)*t,nhist(j)
C           hist(j)=hist(j)*t/Rescale
        enddo
        return
        end
        subroutine scalecent(NATOMS,F,Z,N,Rescale)
C       Suppose we have NATOMS(1,2..) with structure factors
C       F(1,2...) and U amplitudes Z(1,2...)
C       Find the effective scaling term FEFF numerically
        implicit real*8 (A-H,O-Z)
        parameter(NPT=1600)
        data iseed/1/
        save iseed
        real*4 F(N),Z(N),Rescale
        dimension natoms(N)
        dimension WZ(20),WF(20)
C       Initialize if needed
        if(iseed.eq.1)then
           call ZBQLINI(ISEED)
           ISEED=0
        endif
C       Shuffle
        do j=1,N
           work=sqrt(dble(natoms(j)))
           WZ(J)=dble(Z(J))*work
           WF(J)=dble(F(J))*work
        enddo
        PI2=4.D0*asin(1.D0)
        DRescale=0.D0
        DUMMY=0.D0
            do iter=1,NPT
10             continue
               sumfr=0
               sumzr=0
               DO j=1,N
                  DO J2=1,natoms(j)/2
                     phase=ZBQLU01(DUMMY)*pi2
                     sumfr=sumfr+cos(phase)*F(J)
                     sumzr=sumzr+cos(phase)*z(j)
                  enddo
               ENDDO
C              Intensities
               F2_F=sumfr*sumfr
               F2_Z=sumzr*sumzr
C              Divisor, trapped for zero
               if((F2_Z.lt.1D-4).or.(F2_F.lt.1D-4))goto 10
               DRescale =DRescale +sqrt(F2_Z/F2_F)
        enddo
C       Normalize
        Rescale=DRescale/dble(NPT)
        return
        end
        subroutine fscalett(NATOMS,F,Z,N,Rescale,hist,fhist)
C       Suppose we have NATOMS(1,2..) with structure factors
C       F(1,2...) and U amplitudes Z(1,2...)
C       Find the effective scaling term FEFF numerically
        implicit real*8 (A-H,O-Z)
        parameter(NPT=10000)
        data iseed/1/
        save iseed
        real*4 F(N),Z(N),Rescale
        dimension natoms(N)
        dimension WZ(20),WF(20),hist(20),fhist(20)
C       Initialize if needed
        if(iseed.eq.1)then
           call ZBQLINI(ISEED)
           ISEED=0
        endif
        do j=1,20
           hist(j)=0
           fhist(j)=0
        enddo
        sumz=0
        sumf=0
        do j=1,n
           sumz=sumz+z(j)*natoms(j)
           sumf=sumf+f(j)*natoms(j)
        enddo
C       Shuffle
        do j=1,N
           work=sqrt(dble(natoms(j)))
           WZ(J)=dble(Z(J))*work
           WF(J)=dble(F(J))*work
        enddo
        PI2=4.D0*asin(1.D0)
        DRescale=0.D0
        DUMMY=0.D0
            do iter=1,NPT
10             continue
               DO j=1,N
C                 Gaussian random number, STD 1, Mean 0
                  g=ZBQLNOR(0.D0,1.D0)
C                 Phase shift for j>1
                  ampf=g*WF(j)
                  ampz=g*WZ(j)
                  if(j.gt.1)then
C                    random number between 0 & 1
                     phase=ZBQLU01(DUMMY)*pi2
C                    Complex contributions
                     ca=cos(phase)
                     sa=sin(phase)
                     sumfr=sumfr+ca*ampf
                     sumfi=sumfi+sa*ampf
                     sumzr=sumzr+ca*ampz
                     sumzi=sumzi+sa*ampz
                  else
                     sumfr=ampf
                     sumfi=0
                     sumzr=ampz
                     sumzi=0
                  endif
               ENDDO
C              Intensities
               F2_F=sumfr*sumfr+sumfi*sumfi
               F2_Z=sumzr*sumzr+sumzi*sumzi
C              Divisor, trapped for zero
               if((F2_Z.lt.1D-4).or.(F2_F.lt.1D-4))goto 10
               Rthis=sqrt(F2_Z/F2_F)
               DRescale =DRescale +Rthis
               F2_Z=sqrt(F2_Z)
               F2_F=sqrt(F2_F)
               IU=(20*F2_Z/sumz)+1
               if(iu.le.20)then
                        hist(iu)=hist(iu)+Rthis
                        fhist(iu)=fhist(iu)+1
               endif
        enddo
C       Normalize
        Rescale=DRescale/dble(NPT)
        do j=1,20
           hist(j)=hist(j)/Rescale
        enddo
        return
        end
******************************************************************
********	FILE: randgen.f				***********
********	AUTHORS: Richard Chandler		***********
********		 (richard@stats.ucl.ac.uk)	***********
********		 Paul Northrop 			***********
********		 (northrop@stats.ox.ac.uk)	***********
********	LAST MODIFIED: 26/8/03			***********
********	See file randgen.txt for details	***********
*******************************************************************

      BLOCK DATA ZBQLBD01
*
*       Initializes seed array etc. for random number generator.
*       The values below have themselves been generated using the
*       NAG generator.
*
      COMMON /ZBQL0001/ ZBQLIX,B,C
      DOUBLE PRECISION ZBQLIX(43),B,C
      INTEGER I
      DATA (ZBQLIX(I),I=1,43) /8.001441D7,5.5321801D8,
     +1.69570999D8,2.88589940D8,2.91581871D8,1.03842493D8,
     +7.9952507D7,3.81202335D8,3.11575334D8,4.02878631D8,
     +2.49757109D8,1.15192595D8,2.10629619D8,3.99952890D8,
     +4.12280521D8,1.33873288D8,7.1345525D7,2.23467704D8,
     +2.82934796D8,9.9756750D7,1.68564303D8,2.86817366D8,
     +1.14310713D8,3.47045253D8,9.3762426D7 ,1.09670477D8,
     +3.20029657D8,3.26369301D8,9.441177D6,3.53244738D8,
     +2.44771580D8,1.59804337D8,2.07319904D8,3.37342907D8,
     +3.75423178D8,7.0893571D7 ,4.26059785D8,3.95854390D8,
     +2.0081010D7,5.9250059D7,1.62176640D8,3.20429173D8,
     +2.63576576D8/
      DATA B / 4.294967291D9 /
      DATA C / 0.0D0 /
      SAVE /ZBQL0001/
      END
******************************************************************
      SUBROUTINE ZBQLINI(SEED)
******************************************************************
*       To initialize the random number generator - either
*       repeatably or nonrepeatably. Need double precision
*       variables because integer storage can't handle the
*       numbers involved
******************************************************************
*	ARGUMENTS
*	=========
*	SEED	(integer, input). User-input number which generates
*		elements of the array ZBQLIX, which is subsequently used
*		in the random number generation algorithm.
******************************************************************
*	VARIABLES
*	=========
*	SEED	See above
*	ZBQLIX	Seed array for the random number generator. Defined
*		in ZBQLBD01
*	B,C	Used in congruential initialisation of ZBQLIX
*	INIT	Indicates whether generator has already been initialised
*
      INTEGER SEED,SS,MM,HH,DD,FILNO,I
      INTEGER INIT
      DOUBLE PRECISION ZBQLIX(43),B,C
      DOUBLE PRECISION TMPVAR1,DSS,DMM,DHH,DDD

      COMMON /ZBQL0001/ ZBQLIX,B,C
      SAVE INIT
      SAVE /ZBQL0001/
*
*	Ensure we don't call this more than once in a program
*
      IF (INIT.GE.1) THEN
       IF(INIT.EQ.1) THEN
        INIT = 2
       ENDIF
       RETURN
      ELSE
       INIT = 1
      ENDIF

       TMPVAR1 = DMOD(DBLE(SEED),B)
      ZBQLIX(1) = TMPVAR1
      DO 100 I = 2,43
       TMPVAR1 = ZBQLIX(I-1)*3.0269D4
       TMPVAR1 = DMOD(TMPVAR1,B)
       ZBQLIX(I) = TMPVAR1
 100  CONTINUE
      END
******************************************************************
      FUNCTION ZBQLU01(DUMMY)
*
*       Returns a uniform random number between 0 & 1, using
*       a Marsaglia-Zaman type subtract-with-borrow generator.
*       Uses double precision, rather than integer, arithmetic
*       throughout because MZ's integer constants overflow
*       32-bit integer storage (which goes from -2^31 to 2^31).
*       Ideally, we would explicitly truncate all integer
*       quantities at each stage to ensure that the double
*       precision representations do not accumulate approximation
*       error; however, on some machines the use of DNINT to
*       accomplish this is *seriously* slow (run-time increased
*       by a factor of about 3). This double precision version
*       has been tested against an integer implementation that
*       uses long integers (non-standard and, again, slow) -
*       the output was identical up to the 16th decimal place
*       after 10^10 calls, so we're probably OK ...
*
      DOUBLE PRECISION ZBQLU01,DUMMY,B,C,ZBQLIX(43),X,B2,BINV
      INTEGER CURPOS,ID22,ID43

      COMMON /ZBQL0001/ ZBQLIX,B,C
      SAVE /ZBQL0001/
      SAVE CURPOS,ID22,ID43
      DATA CURPOS,ID22,ID43 /1,22,43/

      B2 = B
      BINV = 1.0D0/B
 5    X = ZBQLIX(ID22) - ZBQLIX(ID43) - C
      IF (X.LT.0.0D0) THEN
       X = X + B
       C = 1.0D0
      ELSE
       C = 0.0D0
      ENDIF
      ZBQLIX(ID43) = X
*
*     Update array pointers. Do explicit check for bounds of each to
*     avoid expense of modular arithmetic. If one of them is 0 the others
*     won't be
*
      CURPOS = CURPOS - 1
      ID22 = ID22 - 1
      ID43 = ID43 - 1
      IF (CURPOS.EQ.0) THEN
       CURPOS=43
      ELSEIF (ID22.EQ.0) THEN
       ID22 = 43
      ELSEIF (ID43.EQ.0) THEN
       ID43 = 43
      ENDIF
*
*     The integer arithmetic there can yield X=0, which can cause
*     problems in subsequent routines (e.g. ZBQLEXP). The problem
*     is simply that X is discrete whereas U is supposed to
*     be continuous - hence if X is 0, go back and generate another
*     X and return X/B^2 (etc.), which will be uniform on (0,1/B).
*
      IF (X.LT.BINV) THEN
       B2 = B2*B
       GOTO 5
      ENDIF

      ZBQLU01 = X/B2

      END
      FUNCTION ZBQLNOR(MU,SIGMA)
*
*       Returns a random number Normally distributed with mean
*       MU and standard deviation |SIGMA|, using the Box-Muller
*       algorithm
*
      DOUBLE PRECISION THETA,R,ZBQLNOR,ZBQLU01,PI,MU,SIGMA
      DOUBLE PRECISION SPARE
      INTEGER STATUS
      SAVE STATUS,SPARE,PI
      DATA STATUS /-1/

      IF (STATUS.EQ.-1) PI = 4.0D0*DATAN(1.0D0)

      IF (STATUS.LE.0) THEN
       THETA = 2.0D0*PI*ZBQLU01(0.0D0)
       R = DSQRT( -2.0D0*DLOG(ZBQLU01(0.0D0)) )
       ZBQLNOR = (R*DCOS(THETA))
       SPARE = (R*DSIN(THETA))
       STATUS = 1
      ELSE
       ZBQLNOR = SPARE
       STATUS = 0
      ENDIF

      ZBQLNOR = MU + (SIGMA*ZBQLNOR)

      END
