C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C

      subroutine grid3Dn(fw,f,h,k,l,natom,nr2,x,y,z,
     1  obest,rbest,isymm,winwts,n1,n2,n3,rflag,wts,fwt_on,ntypes
     2  ,edm_on,autoon)
      dimension x(*),y(*),z(*),winwts(*),wts(*)
      include 'ffact2.h'
      include 'rfact.h'
      include 'Atoms.h'
      include 'Just_Pars.h'
      include 'GenPass.h'
      include 'errref.h'
      include 'Constraints.h'
      include 'newbonds.h'
      logical fwt_on,ldebug
      dimension f(*)
C      dimension xmm(1500)
      integer itype(natf),itypew(natf)
      dimension fhk(1500)
      dimension occ(natf),wt(1500),err2(200)
      complex fw(*)
      integer h(*),k(*),l(*)
      dimension obest(*),zocc(20)
C      dimension xe(20),ye(20),itcode(20)
      dimension xb(natf),yb(natf),zb(natf)
      character*4 ssy,Isymm

C     Size for grid
      INCLUDE 'GridSize.h'
      dimension err(MaxGrid),ind(MaxGrid),work(MaxGrid)
      logical rflag,specx,specy
      logical gotentry
      dimension ftrueh(nhk2h)
      common /sfcom40/ftrueh,gotentry
      Include 'Sfacts.h'
      character*4 sftemp
      logical edm_on, autoon
      include 'hunting.h'
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
      include 'STO111.h'
C     Code debugging
C      ldebug=.true.
      irg=-1
      symm=isymm
      nlimn=10
      ssy=symm
      if(ntypes.gt.1)then
         if(edm_on.or.autoon)then
C       Copy constraints over
            nlimn=1
            do j=1,ntypes
               liml(j)=contmin(j)
               limn(j)=contmax(j)
C               if(ldebug)write(6,*)contmin(j),contmax(j)
               zocc(j)=zatom(j)
            enddo
            if(contents)nlimn=-1
        else
             write(6,*)'Enter z*occ for each'
             read(5,*)(zocc(j),j=1,ntypes)
             do j=1,ntypes
                limn(j)=9999
                liml(j)=0
             enddo
             write(6,300)'Limit numbers ? (<1) '
300          format(a,$)
301          format(a,i2,a,f6.3,a,$)
             read(5,*)nlimn
             if(nlimn.lt.0)then
                do j=1,ntypes
                write(6,301)'Type ',j,' z*occ ',zocc(j),' Min/Max ? '
                read(5,*)liml(j),limn(j)
                enddo
             endif
        endif
      else
         zocc(1)=1
         ntypes=1
      endif
C     Cleanup atoms close to symmetry points
      do i=1,2
         do j=1,natom
            if(specx(x(j),y(j),symm))inod=1
            if(specy(x(j),y(j),symm))inod=1
            call cleaner(x(j),y(j),symm,1.0)
         enddo
      enddo


      do j=1,natom
         call asymm(x(j),y(j),ne,xr,yr,symm)
         numbn(j)=ne
      enddo
      ntyp=ntypes+1
C     Decode the occupancies
C      call settyp(itcode,zocc,ntypes,zatom)
C      write(6,*)(itcode(kk),zocc(kk),zatom(kk),kk=1,ntypes)
C       do kk=1,ntypes
C          zocc(kk)=zatom(kk)
C       enddo
C     Run through and eliminate 0,0,0 reflection
      f0=0.
      do j=1,nr2-1
            fhk(j)=ftrueh(j)*wts(j)
            f0=f0+fhk(j)*fhk(j)
            wt(j)=wts(j)/winwts(j)
      enddo
      f0=0.
      do j=1,nrref
        f0=f0+rfhk(j)*rfhk(j)
      enddo
      nref=nr2-1
C     setup the temporary file with reduced values
      call setup3Db(h,k,l,fw,nref,natom,x,y,z,symm,wt)
C     Do a grid search
      imax=ntyp**natom-1
      ebest=1e9
      jptmp=imax/10
      jp=max(100,jptmp)
      if(jp.gt.1000)then
         jp=1000*nint(jp*0.001)
      else
         jp=100*nint(jp*0.01)
      endif
      jp2=jp
      do j=1,natom
         xr(j)=x(j)
         yr(j)=y(j)
C         zr(j)=z(j)
         zr(j)=0
      enddo
      do ival=1,imax
      
      ivt=ival
      do j=1,ntypes
        igotn(j)=0
      enddo
C      if(ldebug)nmine=0
      do j=1,natom
C        decode the occupancy from ival
         ip=ivt-ntyp*(ivt/ntyp)
         if(ip.gt.0)then
            occ(j)=zatom(ip)
            itype(j)=ip
            igotn(ip)=igotn(ip)+numbn(j)
C           if(ldebug)nmine=nmine+1
         else
            occ(j)=0.
            itype(j)=0
         endif
         ivt=ivt/ntyp
      enddo
C      if(ldebug)write(77,*)nmine,ival
c       trap for too many
        err(ival)=0
        if(nlimn.lt.0)then
                do j=1,ntypes
                if(igotn(j).gt.limn(j))then
                        err(ival)=err(ival)+0.25 * contwt
                else if(igotn(j).lt.liml(j))then
                        err(ival)=err(ival)+0.25 * contwt
                endif
                enddo
        endif
C
C     Get the R-factor, without #atom correction for Chi
      chifactor=1
      err(ival)=err(ival)+robgenb(fhk,fw,nref,natom,occ,itype,irg)
        if(chemon)then
C       Accumulate nett valence charge
                ValCharge=BaseCharge
                do jv=1,10
                        ValCharge=ValCharge+igotn(jv)*ValAtoms(jv)
                enddo
C       Penalty function
                rstoich=(1-exp(-abs(ValCharge)*ValPen))*ValW
                err(ival)=err(ival) + rstoich * chemwt
        endif
C       write(78,*)ValW,rstoich,chemwt,chemon,ValCharge
C      endif
      if(err(ival).lt.ebest)then
         ebest=err(ival)
         ibest=ival
      endif
      if(ival.eq.jp)then
         write(6,31)' Done ',ival,' Best is ',ebest
         write(10,31)' Done ',ival,' Best is ',ebest
         jp=jp+jp2
      endif
      enddo
      write(6,31)' Done ',imax,' Best is ',ebest
      write(10,31)' Done ',imax,' Best is ',ebest
31      format(a,i6,a,f10.5)
      
C     Now do a sort
      do j=1,imax
         ind(j)=j
         work(j)=err(j)/1.5
      enddo
      call sortag(work,imax,ind)
        
C     refine the top num values and output/return them
      num=25
      if(symm.eq.'p3  ')num=40
      if(imax.lt.num)num=imax
      rbest=1e9
C     if(rflag)num=12
      if(rflag)write(6,40)' Refining top ',num,' .... slow !'
40      format(a,i2,a)
      do j=1,num
         i=ind(j)
         ival=i
         nat=0
         do jj=1,natom
            ip=ival-ntyp*(ival/ntyp)
            if(ip.gt.0)then
               nat=nat+1
               xr(nat)=x(jj)
               yr(nat)=y(jj)
C               zr(nat)=z(jj)
               zr(nat)=0
               occ(nat)=zatom(ip) !zocc(ip)
               itypew(nat)=ip !itcode(ip)
            endif
            ival=ival/ntyp
         enddo
C     refine
        errg=err2(j)
        errg2=errg
        if(errg.gt.1.5)goto 100
        if(nat.lt.1)goto 100
C      if(fwt_on)then

!      call settyp(itypew,occ,nat,zatom)
      if(rflag)then
        call gref3Dn(fhk,nref,nat,
     $  xr,yr,zr,symm,h,k,l,15,n1,n2,n3,errg2,itypew)
      endif
C     return the top values
      write(13,30)'REM Test ',j,' G-of-Fit ',errg2
      write(10,30)'REM Test ',j,' G-of-Fit ',errg2
C      nbest=0
       if(errg2.lt.rbest)then
          rbest=errg2
          do jj=1,nat
             xb(jj)=xr(jj)
             yb(jj)=yr(jj)
             zb(jj)=zr(jj)
             obest(jj)=occ(jj)
             nbest=nat
          enddo
       endif 
        if(nsd.le.29.and.errg2.lt.rbest*3)nsd=nsd+1
        do jj=1,nat
          sftemp=sfacts(itypew(jj))
          isf2=2
          if(sftemp(2:2).eq.' ')isf2=1
          if(jj.lt.10)then
            write(13,101)sftemp(1:isf2),jj,xr(jj),yr(jj),zr(jj),
     1       occ(jj),0.05
            write(10,101)sftemp(1:isf2),jj,xr(jj),yr(jj),zr(jj),
     1       occ(jj),0.05
         else
            write(13,111)sftemp(1:isf2),jj,xr(jj),yr(jj),zr(jj),
     1      occ(jj),0.05
            write(10,111)sftemp(1:isf2),jj,xr(jj),yr(jj),zr(jj),occ(jj)
     1       ,0.05
         endif
         if(nsd.le.30.and.errg2.lt.rbest*3)then
                xsd(jj,nsd)=xr(jj)
                ysd(jj,nsd)=yr(jj)
                zsd(jj,nsd)=zr(jj)
                isd(jj,nsd)=itypew(jj)
                fomseed(nsd)=errg2
                ntsd(nsd)=nat
         endif
        enddo
        write(6,30)' Solution ',j,' G-of-Fit ',errg2
30      format(a,i3,a,2f8.4,2f12.7)
100   continue
      enddo
            
C10      format('Q',i1,'  1 ',4f10.6,2x,2f8.3)
C11      format('Q',i2,' 1 ',4f10.6,2x,2f8.3)
101     format(a,i1,'  1 ',4f10.6,2x,2f8.3)
111     format(a,i2,' 1 ',4f10.6,2x,2f8.3)
      do j=1,nbest
         x(j)=xb(j)
         y(j)=yb(j)
C         z(j)=zb(j)
         z(j)=0
      enddo
C      write(6,*)ntsd(1),nat,nbest
      natom=nbest
      return
      end
