      Subroutine nsfac(AX,BX,CX,SYMB,OK,zizz)
      DIMENSION AX(5),BX(5)
      CHARACTER*4 SYMB,SYMBU
      CHARACTER*1 DUM
      LOGICAL OK,ION
C                                                                                                     
C - Fitparameters of all atoms/ions (with the excepetion of O1-)                                      
C   from publication "New Analytical Scattering Factor Functions                                      
C   for Free Atoms and Ions", D. Waasmaier & A. Kirfel, Acta Cryst.                                   
C   A 1995, in press)                                                                                 
C                                                                                                     
C - Fit for O1- based on the tabulated values of Table 2 (D.REZ,                                      
C   P.REZ & I.GRANT, Acta Cryst. (1994), A50, 481-497).                                               
C                                                                                                     
C - Fits for all other atoms/ions based on the tabulated values                                       
C   of Table 6.1.1.1 (atoms) and Table 6.1.1.3 (ions)                                                 
C   (International Tables for Crystallography, Vol. C, 1992).                                         
C
      Parameter (Natoms=216)
      DIMENSION A(Natoms,5), B(Natoms,5), C(Natoms)
      CHARACTER*4 ATOM(Natoms)
      SAVE A,B,C,ATOM
C
C     Rutile fit for Ti2+, O1- using densities from Wien2k for rutile
      DATA ATOM(117)/'TI2+'/, C(117)/0.12931918E+01/
      DATA (A(117,J),J=1,5)/0.94817036E+01,0.47272746,0.32299894E+01,
     1      0.25000049E+00,0.6852464E+01/
      DATA (B(117,J),J=1,5)/0.76174672E+01,0.53453840,0.52455515E+02,
     1      0.10860350E+03,0.49709626E+00/
      DATA ATOM(103)/'O1- '/, C(103)/0.15822403E+00/
      DATA (A(103,J),J=1,5)/0.49131652E+01,0.25050348,0.15733882E+01,
     1      0.25000080E+00,0.10646800E+01/
      DATA (B(103,J),J=1,5)/0.12591590E+02,0.79620322E+01,0.28323898,
     1      0.23915213E+02,0.35409596E+01/

C
C     **** END OF EXTRA FITS ***
C
      DATA ATOM(  1)/'H   '/C(  1)/  0.000049/
      DATA (A(  1,J),J=1,5)/  0.413048,  0.294953,  0.187491,  0.080701,
     1      0.023736/
      DATA (B(  1,J),J=1,5)/ 15.569946, 32.398468,  5.711404, 61.889874,
     1      1.334118/
C             ********
      DATA ATOM(  2)/'HE  '/C(  2)/  0.000487/
      DATA (A(  2,J),J=1,5)/  0.732354,  0.753896,  0.283819,  0.190003,
     1      0.039139/
      DATA (B(  2,J),J=1,5)/ 11.553918,  4.595831,  1.546299, 26.463964,
     1      0.377523/
C             ********
      DATA ATOM(  3)/'LI  '/C(  3)/  0.002542/
      DATA (A(  3,J),J=1,5)/  0.974637,  0.158472,  0.811855,  0.262416,
     1      0.790108/
      DATA (B(  3,J),J=1,5)/  4.334946,  0.342451, 97.102966,201.363831,
     1      1.409234/
C             ********
      DATA ATOM(  4)/'BE  '/C(  4)/  0.002511/
      DATA (A(  4,J),J=1,5)/  1.533712,  0.638283,  0.601052,  0.106139,
     1      1.118414/
      DATA (B(  4,J),J=1,5)/ 42.662079,  0.595420, 99.106499,  0.151340,
     1      1.843093/
C             ********
      DATA ATOM(  5)/'B   '/C(  5)/  0.003823/
      DATA (A(  5,J),J=1,5)/  2.085185,  1.064580,  1.062788,  0.140515,
     1      0.641784/
      DATA (B(  5,J),J=1,5)/ 23.494068,  1.137894, 61.238976,  0.114886,
     1      0.399036/
C             ********
      DATA ATOM(  6)/'C   '/C(  6)/  4.297983/
      DATA (A(  6,J),J=1,5)/  2.657506,  1.078079,  1.490909, -4.241070,
     1      0.713791/
      DATA (B(  6,J),J=1,5)/ 14.780758,  0.776775, 42.086842, -0.000294,
     1      0.239535/
C             ********
      DATA ATOM(  7)/'N   '/C(  7)/-11.804902/
      DATA (A(  7,J),J=1,5)/ 11.893780,  3.277479,  1.858092,  0.858927,
     1      0.912985/
      DATA (B(  7,J),J=1,5)/  0.000158, 10.232723, 30.344690,  0.656065,
     1      0.217287/
C             ********
      DATA ATOM(  8)/'O   '/C(  8)/  0.027014/
      DATA (A(  8,J),J=1,5)/  2.960427,  2.508818,  0.637853,  0.722838,
     1      1.142756/
      DATA (B(  8,J),J=1,5)/ 14.182259,  5.936858,  0.112726, 34.958481,
     1      0.390240/
C             ********
      DATA ATOM(  9)/'F   '/C(  9)/  0.032557/
      DATA (A(  9,J),J=1,5)/  3.511943,  2.772244,  0.678385,  0.915159,
     1      1.089261/
      DATA (B(  9,J),J=1,5)/ 10.687859,  4.380466,  0.093982, 27.255203,
     1      0.313066/
C             ********
      DATA ATOM( 10)/'NE  '/C( 10)/  0.025576/
      DATA (A( 10,J),J=1,5)/  4.183749,  2.905726,  0.520513,  1.135641,
     1      1.228065/
      DATA (B( 10,J),J=1,5)/  8.175457,  3.252536,  0.063295, 21.813910,
     1      0.224952/
C             ********
      DATA ATOM( 11)/'NA  '/C( 11)/  0.079712/
      DATA (A( 11,J),J=1,5)/  4.910127,  3.081783,  1.262067,  1.098938,
     1      0.560991/
      DATA (B( 11,J),J=1,5)/  3.281434,  9.119178,  0.102763,132.013947,
     1      0.405878/
C             ********
      DATA ATOM( 12)/'MG  '/C( 12)/  0.126842/
      DATA (A( 12,J),J=1,5)/  4.708971,  1.194814,  1.558157,  1.170413,
     1      3.239403/
      DATA (B( 12,J),J=1,5)/  4.875207,108.506081,  0.111516, 48.292408,
     1      1.928171/
C             ********
      DATA ATOM( 13)/'AL  '/C( 13)/  0.139509/
      DATA (A( 13,J),J=1,5)/  4.730796,  2.313951,  1.541980,  1.117564,
     1      3.154754/
      DATA (B( 13,J),J=1,5)/  3.628931, 43.051167,  0.095960,108.932388,
     1      1.555918/
C             ********
      DATA ATOM( 14)/'SI  '/C( 14)/  0.145073/
      DATA (A( 14,J),J=1,5)/  5.275329,  3.191038,  1.511514,  1.356849,
     1      2.519114/
      DATA (B( 14,J),J=1,5)/  2.631338, 33.730728,  0.081119, 86.288643,
     1      1.170087/
C             ********
      DATA ATOM( 15)/'P   '/C( 15)/  0.155233/
      DATA (A( 15,J),J=1,5)/  1.950541,  4.146930,  1.494560,  1.522042,
     1      5.729711/
      DATA (B( 15,J),J=1,5)/  0.908139, 27.044952,  0.071280, 67.520187,
     1      1.981173/
C             ********
      DATA ATOM( 16)/'S   '/C( 16)/  0.154722/
      DATA (A( 16,J),J=1,5)/  6.372157,  5.154568,  1.473732,  1.635073,
     1      1.209372/
      DATA (B( 16,J),J=1,5)/  1.514347, 22.092527,  0.061373, 55.445175,
     1      0.646925/
C             ********
      DATA ATOM( 17)/'CL  '/C( 17)/  0.146773/
      DATA (A( 17,J),J=1,5)/  1.446071,  6.870609,  6.151801,  1.750347,
     1      0.634168/
      DATA (B( 17,J),J=1,5)/  0.052357,  1.193165, 18.343416, 46.398396,
     1      0.401005/
C             ********
      DATA ATOM( 18)/'AR  '/C( 18)/  0.265954/
      DATA (A( 18,J),J=1,5)/  7.188004,  6.638454,  0.454180,  1.929593,
     1      1.523654/
      DATA (B( 18,J),J=1,5)/  0.956221, 15.339877, 15.339862, 39.043823,
     1      0.062409/
C             ********
      DATA ATOM( 19)/'K   '/C( 19)/  0.253614/
      DATA (A( 19,J),J=1,5)/  8.163991,  7.146945,  1.070140,  0.877316,
     1      1.486434/
      DATA (B( 19,J),J=1,5)/ 12.816323,  0.808945,210.327011, 39.597652,
     1      0.052821/
C             ********
      DATA ATOM( 20)/'CA  '/C( 20)/  0.196255/
      DATA (A( 20,J),J=1,5)/  8.593655,  1.477324,  1.436254,  1.182839,
     1      7.113258/
      DATA (B( 20,J),J=1,5)/ 10.460644,  0.041891, 81.390381,169.847839,
     1      0.688098/
C             ********
      DATA ATOM( 21)/'SC  '/C( 21)/  0.157765/
      DATA (A( 21,J),J=1,5)/  1.476566,  1.487278,  1.600187,  9.177463,
     1      7.099750/
      DATA (B( 21,J),J=1,5)/ 53.131023,  0.035325,137.319489,  9.098031,
     1      0.602102/
C             ********
      DATA ATOM( 22)/'TI  '/C( 22)/  0.102473/
      DATA (A( 22,J),J=1,5)/  9.818524,  1.522646,  1.703101,  1.768774,
     1      7.082555/
      DATA (B( 22,J),J=1,5)/  8.001879,  0.029763, 39.885422,120.157997,
     1      0.532405/
C             ********
      DATA ATOM( 23)/'V   '/C( 23)/  0.067744/
      DATA (A( 23,J),J=1,5)/ 10.473575,  1.547881,  1.986381,  1.865616,
     1      7.056250/
      DATA (B( 23,J),J=1,5)/  7.081940,  0.026040, 31.909672,108.022842,
     1      0.474882/
C             ********
      DATA ATOM( 24)/'CR  '/C( 24)/  0.065510/
      DATA (A( 24,J),J=1,5)/ 11.007069,  1.555477,  2.985293,  1.347855,
     1      7.034779/
      DATA (B( 24,J),J=1,5)/  6.366281,  0.023987, 23.244839,105.774498,
     1      0.429369/
C             ********
      DATA ATOM( 25)/'MN  '/C( 25)/ -0.147293/
      DATA (A( 25,J),J=1,5)/ 11.709542,  1.733414,  2.673141,  2.023368,
     1      7.003180/
      DATA (B( 25,J),J=1,5)/  5.597120,  0.017800, 21.788420, 89.517914,
     1      0.383054/
C             ********
      DATA ATOM( 26)/'FE  '/C( 26)/ -0.304931/
      DATA (A( 26,J),J=1,5)/ 12.311098,  1.876623,  3.066177,  2.070451,
     1      6.975185/
      DATA (B( 26,J),J=1,5)/  5.009415,  0.014461, 18.743040, 82.767876,
     1      0.346506/
C             ********
      DATA ATOM( 27)/'CO  '/C( 27)/ -0.936572/
      DATA (A( 27,J),J=1,5)/ 12.914510,  2.481908,  3.466894,  2.106351,
     1      6.960892/
      DATA (B( 27,J),J=1,5)/  4.507138,  0.009126, 16.438129, 76.987320,
     1      0.314418/
C             ********
      DATA ATOM( 28)/'NI  '/C( 28)/ -2.762697/
      DATA (A( 28,J),J=1,5)/ 13.521865,  6.947285,  3.866028,  2.135900,
     1      4.284731/
      DATA (B( 28,J),J=1,5)/  4.077277,  0.286763, 14.622634, 71.966080,
     1      0.004437/
C             ********
      DATA ATOM( 29)/'CU  '/C( 29)/ -3.254477/
      DATA (A( 29,J),J=1,5)/ 14.014192,  4.784577,  5.056806,  1.457971,
     1      6.932996/
      DATA (B( 29,J),J=1,5)/  3.738280,  0.003744, 13.034982, 72.554794,
     1      0.265666/
C             ********
      DATA ATOM( 30)/'ZN  '/C( 30)/-36.915829/
      DATA (A( 30,J),J=1,5)/ 14.741002,  6.907748,  4.642337,  2.191766,
     1     38.424042/
      DATA (B( 30,J),J=1,5)/  3.388232,  0.243315, 11.903689, 63.312130,
     1      0.000397/
C             ********
      DATA ATOM( 31)/'GA  '/C( 31)/ -0.847395/
      DATA (A( 31,J),J=1,5)/ 15.758946,  6.841123,  4.121016,  2.714681,
     1      2.395246/
      DATA (B( 31,J),J=1,5)/  3.121754,  0.226057, 12.482196, 66.203621,
     1      0.007238/
C             ********
      DATA ATOM( 32)/'GE  '/C( 32)/  0.018726/
      DATA (A( 32,J),J=1,5)/ 16.540613,  1.567900,  3.727829,  3.345098,
     1      6.785079/
      DATA (B( 32,J),J=1,5)/  2.866618,  0.012198, 13.432163, 58.866047,
     1      0.210974/
C             ********
      DATA ATOM( 33)/'AS  '/C( 33)/ -2.984117/
      DATA (A( 33,J),J=1,5)/ 17.025642,  4.503441,  3.715904,  3.937200,
     1      6.790175/
      DATA (B( 33,J),J=1,5)/  2.597739,  0.003012, 14.272119, 50.437996,
     1      0.193015/
C             ********
      DATA ATOM( 34)/'SE  '/C( 34)/ -3.160982/
      DATA (A( 34,J),J=1,5)/ 17.354071,  4.653248,  4.259489,  4.136455,
     1      6.749163/
      DATA (B( 34,J),J=1,5)/  2.349787,  0.002550, 15.579460, 45.181202,
     1      0.177432/
C             ********
      DATA ATOM( 35)/'BR  '/C( 35)/ -2.492088/
      DATA (A( 35,J),J=1,5)/ 17.550570,  5.411882,  3.937180,  3.880645,
     1      6.707793/
      DATA (B( 35,J),J=1,5)/  2.119226, 16.557184,  0.002481, 42.164009,
     1      0.162121/
C             ********
      DATA ATOM( 36)/'KR  '/C( 36)/ -2.810592/
      DATA (A( 36,J),J=1,5)/ 17.655279,  6.848105,  4.171004,  3.446760,
     1      6.685200/
      DATA (B( 36,J),J=1,5)/  1.908231, 16.606236,  0.001598, 39.917473,
     1      0.146896/
C             ********
      DATA ATOM( 37)/'RB  '/C( 37)/  1.139548/
      DATA (A( 37,J),J=1,5)/  8.123134,  2.138042,  6.761702,  1.156051,
     1     17.679546/
      DATA (B( 37,J),J=1,5)/ 15.142385, 33.542667,  0.129372,224.132507,
     1      1.713368/
C             ********
      DATA ATOM( 38)/'SR  '/C( 38)/  1.140251/
      DATA (A( 38,J),J=1,5)/ 17.730219,  9.795867,  6.099763,  2.620025,
     1      0.600053/
      DATA (B( 38,J),J=1,5)/  1.563060, 14.310868,  0.120574,135.771317,
     1      0.120574/
C             ********
      DATA ATOM( 39)/'Y   '/C( 39)/  1.131787/
      DATA (A( 39,J),J=1,5)/ 17.792040, 10.253252,  5.714949,  3.170516,
     1      0.918251/
      DATA (B( 39,J),J=1,5)/  1.429691, 13.132816,  0.112173,108.197029,
     1      0.112173/
C             ********
      DATA ATOM( 40)/'ZR  '/C( 40)/  1.124859/
      DATA (A( 40,J),J=1,5)/ 17.859772, 10.911038,  5.821115,  3.512513,
     1      0.746965/
      DATA (B( 40,J),J=1,5)/  1.310692, 12.319285,  0.104353, 91.777542,
     1      0.104353/
C             ********
      DATA ATOM( 41)/'NB  '/C( 41)/  1.123452/
      DATA (A( 41,J),J=1,5)/ 17.958399, 12.063054,  5.007015,  3.287667,
     1      1.531019/
      DATA (B( 41,J),J=1,5)/  1.211590, 12.246687,  0.098615, 75.011948,
     1      0.098615/
C             ********
      DATA ATOM( 42)/'MO  '/C( 42)/  1.108770/
      DATA (A( 42,J),J=1,5)/  6.236218, 17.987711, 12.973127,  3.451426,
     1      0.210899/
      DATA (B( 42,J),J=1,5)/  0.090780,  1.108310, 11.468720, 66.684151,
     1      0.090780/
C             ********
      DATA ATOM( 43)/'TC  '/C( 43)/  1.074784/
      DATA (A( 43,J),J=1,5)/ 17.840963,  3.428236,  1.373012, 12.947364,
     1      6.335469/
      DATA (B( 43,J),J=1,5)/  1.005729, 41.901382,119.320541,  9.781542,
     1      0.083391/
C             ********
      DATA ATOM( 44)/'RU  '/C( 44)/  1.043992/
      DATA (A( 44,J),J=1,5)/  6.271624, 17.906738, 14.123269,  3.746008,
     1      0.908235/
      DATA (B( 44,J),J=1,5)/  0.077040,  0.928222,  9.555345, 35.860680,
     1    123.552246/
C             ********
      DATA ATOM( 45)/'RH  '/C( 45)/  0.995452/
      DATA (A( 45,J),J=1,5)/  6.216648, 17.919739,  3.854252,  0.840326,
     1     15.173498/
      DATA (B( 45,J),J=1,5)/  0.070789,  0.856121, 33.889484,121.686691,
     1      9.029517/
C             ********
      DATA ATOM( 46)/'PD  '/C( 46)/  0.883099/
      DATA (A( 46,J),J=1,5)/  6.121511,  4.784063, 16.631683,  4.318258,
     1     13.246773/
      DATA (B( 46,J),J=1,5)/  0.062549,  0.784031,  8.751391, 34.489983,
     1      0.784031/
C             ********
      DATA ATOM( 47)/'AG  '/C( 47)/  0.756603/
      DATA (A( 47,J),J=1,5)/  6.073874, 17.155437,  4.173344,  0.852238,
     1     17.988686/
      DATA (B( 47,J),J=1,5)/  0.055333,  7.896512, 28.443739,110.376106,
     1      0.716809/
C             ********
      DATA ATOM( 48)/'CD  '/C( 48)/  0.603504/
      DATA (A( 48,J),J=1,5)/  6.080986, 18.019468,  4.018197,  1.303510,
     1     17.974669/
      DATA (B( 48,J),J=1,5)/  0.048990,  7.273646, 29.119284, 95.831207,
     1      0.661231/
C             ********
      DATA ATOM( 49)/'IN  '/C( 49)/  0.333097/
      DATA (A( 49,J),J=1,5)/  6.196477, 18.816183,  4.050479,  1.638929,
     1     17.962912/
      DATA (B( 49,J),J=1,5)/  0.042072,  6.695665, 31.009790,103.284348,
     1      0.610714/
C             ********
      DATA ATOM( 50)/'SN  '/C( 50)/  0.119024/
      DATA (A( 50,J),J=1,5)/ 19.325171,  6.281571,  4.498866,  1.856934,
     1     17.917318/
      DATA (B( 50,J),J=1,5)/  6.118104,  0.036915, 32.529045, 95.037186,
     1      0.565651/
C             ********
      DATA ATOM( 51)/'SB  '/C( 51)/ -0.290506/
      DATA (A( 51,J),J=1,5)/  5.394956,  6.549570, 19.650681,  1.827820,
     1     17.867832/
      DATA (B( 51,J),J=1,5)/ 33.326523,  0.030974,  5.564929, 87.130966,
     1      0.523992/
C             ********
      DATA ATOM( 52)/'TE  '/C( 52)/ -0.806668/
      DATA (A( 52,J),J=1,5)/  6.660302,  6.940756, 19.847015,  1.557175,
     1     17.802427/
      DATA (B( 52,J),J=1,5)/ 33.031654,  0.025750,  5.065547, 84.101616,
     1      0.487660/
C             ********
      DATA ATOM( 53)/'I   '/C( 53)/ -0.448811/
      DATA (A( 53,J),J=1,5)/ 19.884502,  6.736593,  8.110516,  1.170953,
     1     17.548716/
      DATA (B( 53,J),J=1,5)/  4.628591,  0.027754, 31.849096, 84.406387,
     1      0.463550/
C             ********
      DATA ATOM( 54)/'XE  '/C( 54)/ -6.065902/
      DATA (A( 54,J),J=1,5)/ 19.978920, 11.774945,  9.332182,  1.244749,
     1     17.737501/
      DATA (B( 54,J),J=1,5)/  4.143356,  0.010142, 28.796200, 75.280685,
     1      0.413616/
C             ********
      DATA ATOM( 55)/'CS  '/C( 55)/ -2.322802/
      DATA (A( 55,J),J=1,5)/ 17.418674,  8.314444, 10.323193,  1.383834,
     1     19.876251/
      DATA (B( 55,J),J=1,5)/  0.399828,  0.016872, 25.605827,233.339676,
     1      3.826915/
C             ********
      DATA ATOM( 56)/'BA  '/C( 56)/ -5.183497/
      DATA (A( 56,J),J=1,5)/ 19.747343, 17.368477, 10.465718,  2.592602,
     1     11.003653/
      DATA (B( 56,J),J=1,5)/  3.481823,  0.371224, 21.226641,173.834274,
     1      0.010719/
C             ********
      DATA ATOM( 57)/'LA  '/C( 57)/-21.745489/
      DATA (A( 57,J),J=1,5)/ 19.966019, 27.329655, 11.018425,  3.086696,
     1     17.335455/
      DATA (B( 57,J),J=1,5)/  3.197408,  0.003446, 19.955492,141.381973,
     1      0.341817/
C             ********
      DATA ATOM( 58)/'CE  '/C( 58)/-38.386017/
      DATA (A( 58,J),J=1,5)/ 17.355122, 43.988499, 20.546650,  3.130670,
     1     11.353665/
      DATA (B( 58,J),J=1,5)/  0.328369,  0.002047,  3.088196,134.907654,
     1     18.832960/
C             ********
      DATA ATOM( 59)/'PR  '/C( 59)/ -3.871068/
      DATA (A( 59,J),J=1,5)/ 21.551311, 17.161730, 11.903859,  2.679103,
     1      9.564197/
      DATA (B( 59,J),J=1,5)/  2.995675,  0.312491, 17.716705,152.192825,
     1      0.010468/
C             ********
      DATA ATOM( 60)/'ND  '/C( 60)/-57.189842/
      DATA (A( 60,J),J=1,5)/ 17.331244, 62.783924, 12.160097,  2.663483,
     1     22.239950/
      DATA (B( 60,J),J=1,5)/  0.300269,  0.001320, 17.026001,148.748993,
     1      2.910268/
C             ********
      DATA ATOM( 61)/'PM  '/C( 61)/-45.973682/
      DATA (A( 61,J),J=1,5)/ 17.286388, 51.560162, 12.478557,  2.675515,
     1     22.960947/
      DATA (B( 61,J),J=1,5)/  0.286620,  0.001550, 16.223755,143.984512,
     1      2.796480/
C             ********
      DATA ATOM( 62)/'SM  '/C( 62)/-17.452166/
      DATA (A( 62,J),J=1,5)/ 23.700363, 23.072214, 12.777782,  2.684217,
     1     17.204367/
      DATA (B( 62,J),J=1,5)/  2.689539,  0.003491, 15.495437,139.862473,
     1      0.274536/
C             ********
      DATA ATOM( 63)/'EU  '/C( 63)/-31.586687/
      DATA (A( 63,J),J=1,5)/ 17.186195, 37.156837, 13.103387,  2.707246,
     1     24.419271/
      DATA (B( 63,J),J=1,5)/  0.261678,  0.001995, 14.787360,134.816299,
     1      2.581883/
C             ********
      DATA ATOM( 64)/'GD  '/C( 64)/-43.505684/
      DATA (A( 64,J),J=1,5)/ 24.898117, 17.104952, 13.222581,  3.266152,
     1     48.995213/
      DATA (B( 64,J),J=1,5)/  2.435028,  0.246961, 13.996325,110.863091,
     1      0.001383/
C             ********
      DATA ATOM( 65)/'TB  '/C( 65)/-26.851971/
      DATA (A( 65,J),J=1,5)/ 25.910013, 32.344139, 13.765117,  2.751404,
     1     17.064405/
      DATA (B( 65,J),J=1,5)/  2.373912,  0.002034, 13.481969,125.836510,
     1      0.236916/
C             ********
      DATA ATOM( 66)/'DY  '/C( 66)/-83.279831/
      DATA (A( 66,J),J=1,5)/ 26.671785, 88.687576, 14.065445,  2.768497,
     1     17.067781/
      DATA (B( 66,J),J=1,5)/  2.282593,  0.000665, 12.920230,121.937187,
     1      0.225531/
C             ********
      DATA ATOM( 67)/'HO  '/C( 67)/-41.165253/
      DATA (A( 67,J),J=1,5)/ 27.150190, 16.999819, 14.059334,  3.386979,
     1     46.546471/
      DATA (B( 67,J),J=1,5)/  2.169660,  0.215414, 12.213148,100.506783,
     1      0.001211/
C             ********
      DATA ATOM( 68)/'ER  '/C( 68)/-77.135223/
      DATA (A( 68,J),J=1,5)/ 28.174887, 82.493271, 14.624002,  2.802756,
     1     17.018515/
      DATA (B( 68,J),J=1,5)/  2.120995,  0.000640, 11.915256,114.529938,
     1      0.207519/
C             ********
      DATA ATOM( 69)/'TM  '/C( 69)/-70.839813/
      DATA (A( 69,J),J=1,5)/ 28.925894, 76.173798, 14.904704,  2.814812,
     1     16.998117/
      DATA (B( 69,J),J=1,5)/  2.046203,  0.000656, 11.465375,111.411980,
     1      0.199376/
C             ********
      DATA ATOM( 70)/'YB  '/C( 70)/-60.313812/
      DATA (A( 70,J),J=1,5)/ 29.676760, 65.624069, 15.160854,  2.830288,
     1     16.997850/
      DATA (B( 70,J),J=1,5)/  1.977630,  0.000720, 11.044622,108.139153,
     1      0.192110/
C             ********
      DATA ATOM( 71)/'LU  '/C( 71)/-51.049416/
      DATA (A( 71,J),J=1,5)/ 30.122866, 15.099346, 56.314899,  3.540980,
     1     16.943729/
      DATA (B( 71,J),J=1,5)/  1.883090, 10.342764,  0.000780, 89.559250,
     1      0.183849/
C             ********
      DATA ATOM( 72)/'HF  '/C( 72)/-49.719837/
      DATA (A( 72,J),J=1,5)/ 30.617033, 15.145351, 54.933548,  4.096253,
     1     16.896156/
      DATA (B( 72,J),J=1,5)/  1.795613,  9.934469,  0.000739, 76.189705,
     1      0.175914/
C             ********
      DATA ATOM( 73)/'TA  '/C( 73)/-44.119026/
      DATA (A( 73,J),J=1,5)/ 31.066359, 15.341823, 49.278297,  4.577665,
     1     16.828321/
      DATA (B( 73,J),J=1,5)/  1.708732,  9.618455,  0.000760, 66.346199,
     1      0.168002/
C             ********
      DATA ATOM( 74)/'W   '/C( 74)/-32.864574/
      DATA (A( 74,J),J=1,5)/ 31.507900, 15.682498, 37.960129,  4.885509,
     1     16.792112/
      DATA (B( 74,J),J=1,5)/  1.629485,  9.446448,  0.000898, 59.980675,
     1      0.160798/
C             ********
      DATA ATOM( 75)/'RE  '/C( 75)/-37.412682/
      DATA (A( 75,J),J=1,5)/ 31.888456, 16.117104, 42.390297,  5.211669,
     1     16.767591/
      DATA (B( 75,J),J=1,5)/  1.549238,  9.233474,  0.000689, 54.516373,
     1      0.152815/
C             ********
      DATA ATOM( 76)/'OS  '/C( 76)/-43.677956/
      DATA (A( 76,J),J=1,5)/ 32.210297, 16.678440, 48.559906,  5.455839,
     1     16.735533/
      DATA (B( 76,J),J=1,5)/  1.473531,  9.049695,  0.000519, 50.210201,
     1      0.145771/
C             ********
      DATA ATOM( 77)/'IR  '/C( 77)/  4.018893/
      DATA (A( 77,J),J=1,5)/ 32.004436,  1.975454, 17.070105, 15.939454,
     1      5.990003/
      DATA (B( 77,J),J=1,5)/  1.353767, 81.014175,  0.128093,  7.661196,
     1     26.659403/
C             ********
      DATA ATOM( 78)/'PT  '/C( 78)/  4.050394/
      DATA (A( 78,J),J=1,5)/ 31.273891, 18.445440, 17.063745,  5.555933,
     1      1.575270/
      DATA (B( 78,J),J=1,5)/  1.316992,  8.797154,  0.124741, 40.177994,
     1      1.316997/
C             ********
      DATA ATOM( 79)/'AU  '/C( 79)/ -6.279078/
      DATA (A( 79,J),J=1,5)/ 16.777390, 19.317156, 32.979683,  5.595453,
     1     10.576854/
      DATA (B( 79,J),J=1,5)/  0.122737,  8.621570,  1.256902, 38.008820,
     1      0.000601/
C             ********
      DATA ATOM( 80)/'HG  '/C( 80)/  4.076478/
      DATA (A( 80,J),J=1,5)/ 16.839890, 20.023823, 28.428564,  5.881564,
     1      4.714706/
      DATA (B( 80,J),J=1,5)/  0.115905,  8.256927,  1.195250, 39.247227,
     1      1.195250/
C             ********
      DATA ATOM( 81)/'TL  '/C( 81)/  4.066939/
      DATA (A( 81,J),J=1,5)/ 16.630795, 19.386616, 32.808571,  1.747191,
     1      6.356862/
      DATA (B( 81,J),J=1,5)/  0.110704,  7.181401,  1.119730, 90.660263,
     1     26.014978/
C             ********
      DATA ATOM( 82)/'PB  '/C( 82)/  4.049824/
      DATA (A( 82,J),J=1,5)/ 16.419567, 32.738590,  6.530247,  2.342742,
     1     19.916475/
      DATA (B( 82,J),J=1,5)/  0.105499,  1.055049, 25.025890, 80.906593,
     1      6.664449/
C             ********
      DATA ATOM( 83)/'BI  '/C( 83)/  4.040914/
      DATA (A( 83,J),J=1,5)/ 16.282274, 32.725136,  6.678302,  2.694750,
     1     20.576559/
      DATA (B( 83,J),J=1,5)/  0.101180,  1.002287, 25.714146, 77.057549,
     1      6.291882/
C             ********
      DATA ATOM( 84)/'PO  '/C( 84)/  4.046556/
      DATA (A( 84,J),J=1,5)/ 16.289164, 32.807171, 21.095163,  2.505901,
     1      7.254589/
      DATA (B( 84,J),J=1,5)/  0.098121,  0.966265,  6.046622, 76.598068,
     1     28.096128/
C             ********
      DATA ATOM( 85)/'AT  '/C( 85)/  3.995684/
      DATA (A( 85,J),J=1,5)/ 16.011461, 32.615547,  8.113899,  2.884082,
     1     21.377867/
      DATA (B( 85,J),J=1,5)/  0.092639,  0.904416, 26.543257, 68.372963,
     1      5.499512/
C             ********
      DATA ATOM( 86)/'RN  '/C( 86)/  4.020977/
      DATA (A( 86,J),J=1,5)/ 16.070229, 32.641106, 21.489658,  2.299218,
     1      9.480184/
      DATA (B( 86,J),J=1,5)/  0.090437,  0.876409,  5.239687, 69.188477,
     1     27.632641/
C             ********
      DATA ATOM( 87)/'FR  '/C( 87)/  4.003472/
      DATA (A( 87,J),J=1,5)/ 16.007385, 32.663830, 21.594351,  1.598497,
     1     11.121192/
      DATA (B( 87,J),J=1,5)/  0.087031,  0.840187,  4.954467,199.805801,
     1     26.905106/
C             ********
      DATA ATOM( 88)/'RA  '/C( 88)/  3.981773/
      DATA (A( 88,J),J=1,5)/ 32.563690, 21.396671, 11.298093,  2.834688,
     1     15.914965/
      DATA (B( 88,J),J=1,5)/  0.801980,  4.590666, 22.758972,160.404388,
     1      0.083544/
C             ********
      DATA ATOM( 89)/'AC  '/C( 89)/  3.939212/
      DATA (A( 89,J),J=1,5)/ 15.914053, 32.535042, 21.553976, 11.433394,
     1      3.612409/
      DATA (B( 89,J),J=1,5)/  0.080511,  0.770669,  4.352206, 21.381622,
     1    130.500748/
C             ********
      DATA ATOM( 90)/'TH  '/C( 90)/  3.922533/
      DATA (A( 90,J),J=1,5)/ 15.784024, 32.454899, 21.849222,  4.239077,
     1     11.736191/
      DATA (B( 90,J),J=1,5)/  0.077067,  0.735137,  4.097976,109.464111,
     1     20.512138/
C             ********
      DATA ATOM( 91)/'PA  '/C( 91)/  3.886066/
      DATA (A( 91,J),J=1,5)/ 32.740208, 21.973675, 12.957398,  3.683832,
     1     15.744058/
      DATA (B( 91,J),J=1,5)/  0.709545,  4.050881, 19.231543,117.255005,
     1      0.074040/
C             ********
      DATA ATOM( 92)/'U   '/C( 92)/  3.854444/
      DATA (A( 92,J),J=1,5)/ 15.679275, 32.824306, 13.660459,  3.687261,
     1     22.279434/
      DATA (B( 92,J),J=1,5)/  0.071206,  0.681177, 18.236156,112.500038,
     1      3.930325/
C             ********
      DATA ATOM( 93)/'NP  '/C( 93)/  3.769391/
      DATA (A( 93,J),J=1,5)/ 32.999901, 22.638077, 14.219973,  3.672950,
     1     15.683245/
      DATA (B( 93,J),J=1,5)/  0.657086,  3.854918, 17.435474,109.464485,
     1      0.068033/
C             ********
      DATA ATOM( 94)/'PU  '/C( 94)/  3.664200/
      DATA (A( 94,J),J=1,5)/ 33.281178, 23.148544, 15.153755,  3.031492,
     1     15.704215/
      DATA (B( 94,J),J=1,5)/  0.634999,  3.856168, 16.849735,121.292038,
     1      0.064857/
C             ********
      DATA ATOM( 95)/'AM  '/C( 95)/  3.541160/
      DATA (A( 95,J),J=1,5)/ 33.435162, 23.657259, 15.576339,  3.027023,
     1     15.746100/
      DATA (B( 95,J),J=1,5)/  0.612785,  3.792942, 16.195778,117.757004,
     1      0.061755/
C             ********
      DATA ATOM( 96)/'CM  '/C( 96)/  3.390840/
      DATA (A( 96,J),J=1,5)/ 15.804837, 33.480801, 24.150198,  3.655563,
     1     15.499866/
      DATA (B( 96,J),J=1,5)/  0.058619,  0.590160,  3.674720,100.736191,
     1     15.408296/
C             ********
      DATA ATOM( 97)/'BK  '/C( 97)/  3.213169/
      DATA (A( 97,J),J=1,5)/ 15.889072, 33.625286, 24.710381,  3.707139,
     1     15.839268/
      DATA (B( 97,J),J=1,5)/  0.055503,  0.569571,  3.615472, 97.694786,
     1     14.754303/
C             ********
      DATA ATOM( 98)/'CF  '/C( 98)/  3.005326/
      DATA (A( 98,J),J=1,5)/ 33.794075, 25.467693, 16.048487,  3.657525,
     1     16.008982/
      DATA (B( 98,J),J=1,5)/  0.550447,  3.581973, 14.357388, 96.064972,
     1      0.052450/
C             ********
      DATA ATOM( 99)/'H1- '/C( 99)/  0.000425/
      DATA (A( 99,J),J=1,5)/  0.702260,  0.763666,  0.248678,  0.261323,
     1      0.023017/
      DATA (B( 99,J),J=1,5)/ 23.945604, 74.897919,  6.773289,233.583450,
     1      1.337531/
C             ********
      DATA ATOM(100)/'LI1+'/C(100)/  0.001764/
      DATA (A(100,J),J=1,5)/  0.432724,  0.549257,  0.376575, -0.336481,
     1      0.976060/
      DATA (B(100,J),J=1,5)/  0.260367,  1.042836,  7.885294,  0.260368,
     1      3.042539/
C             ********
      DATA ATOM(101)/'BE2+'/C(101)/ -0.653773/
      DATA (A(101,J),J=1,5)/  3.055430, -2.372617,  1.044914,  0.544233,
     1      0.381737/
      DATA (B(101,J),J=1,5)/  0.001226,  0.001227,  1.542106,  0.456279,
     1      4.047479/
C             ********
      DATA ATOM(102)/'CVAL'/C(102)/  0.019722/
      DATA (A(102,J),J=1,5)/  1.258489,  0.728215,  1.119856,  2.168133,
     1      0.705239/
      DATA (B(102,J),J=1,5)/ 10.683769,  0.208177,  0.836097, 24.603704,
     1     58.954273/
C             ********
C      DATA ATOM(103)/'O1- '/C(103)/  0.046136/
C      DATA (A(103,J),J=1,5)/  3.106934,  3.235142,  1.148886,  0.783981,
C     1      0.676953/
C      DATA (B(103,J),J=1,5)/ 19.868080,  6.960252,  0.170043, 65.693512,
C     1      0.630757/
C             ********
      DATA ATOM(104)/'O2- '/C(104)/  0.025429/
      DATA (A(104,J),J=1,5)/  3.990247,  2.300563,  0.607200,  1.907882,
     1      1.167080/
      DATA (B(104,J),J=1,5)/ 16.639956,  5.636819,  0.108493, 47.299709,
     1      0.379984/
C             ********
      DATA ATOM(105)/'F1- '/C(105)/  0.069525/
      DATA (A(105,J),J=1,5)/  0.457649,  3.841561,  1.432771,  0.801876,
     1      3.395041/
      DATA (B(105,J),J=1,5)/  0.917243,  5.507803,  0.164955, 51.076206,
     1     15.821679/
C             ********
      DATA ATOM(106)/'NA1+'/C(106)/  0.045300/
      DATA (A(106,J),J=1,5)/  3.148690,  4.073989,  0.767888,  0.995612,
     1      0.968249/
      DATA (B(106,J),J=1,5)/  2.594987,  6.046925,  0.070139, 14.122657,
     1      0.217037/
C             ********
      DATA ATOM(107)/'MG2+'/C(107)/  0.058851/
      DATA (A(107,J),J=1,5)/  3.062918,  4.135106,  0.853742,  1.036792,
     1      0.852520/
      DATA (B(107,J),J=1,5)/  2.015803,  4.417941,  0.065307,  9.669710,
     1      0.187818/
C             ********
      DATA ATOM(108)/'AL3+'/C(108)/  0.019397/
      DATA (A(108,J),J=1,5)/  4.132015,  0.912049,  1.102425,  0.614876,
     1      3.219136/
      DATA (B(108,J),J=1,5)/  3.528641,  7.378344,  0.133708,  0.039065,
     1      1.644728/
C             ********
      DATA ATOM(109)/'SIVA'/C(109)/  0.146030/
      DATA (A(109,J),J=1,5)/  2.879033,  3.072960,  1.515981,  1.390030,
     1      4.995051/
      DATA (B(109,J),J=1,5)/  1.239713, 38.706276,  0.081481, 93.616333,
     1      2.770293/
C             ********
      DATA ATOM(110)/'SIVF'/C(110)/ -0.300008/
      DATA (A(110,J),J=1,5)/  2.824965,  5.774513,  0.763378,  0.215494,
     1      4.721658/
      DATA (B(110,J),J=1,5)/  0.330405,  2.313040,  2.843446, 32.845009,
     1     40.716621/
C             ********
      DATA ATOM(111)/'SIVO'/C(111)/  0.000000/
      DATA (A(111,J),J=1,5)/  2.853370,  4.619297,  1.330274,  0.074970,
     1      5.122089/
      DATA (B(111,J),J=1,5)/  1.141714, 37.616024,  0.010000,345.608185,
     1      2.508318/
C             ********
      DATA ATOM(112)/'SI4+'/C(112)/  0.097266/
      DATA (A(112,J),J=1,5)/  3.676722,  3.828496,  1.258033,  0.419024,
     1      0.720421/
      DATA (B(112,J),J=1,5)/  1.446851,  3.013144,  0.064397,  0.206254,
     1      5.970222/
C             ********
      DATA ATOM(113)/'CL1-'/C(113)/-34.916603/
      DATA (A(113,J),J=1,5)/  1.061802,  7.139886,  6.524271,  2.355626,
     1     35.829403/
      DATA (B(113,J),J=1,5)/  0.144727,  1.171795, 19.467655, 60.320301,
     1      0.000436/
C             ********
      DATA ATOM(114)/'K1+ '/C(114)/  0.257164/
      DATA (A(114,J),J=1,5)/-17.609339,  1.494873,  7.150305, 10.899569,
     1     15.808228/
      DATA (B(114,J),J=1,5)/ 18.840979,  0.053453,  0.812940, 22.264105,
     1     14.351593/
C             ********
      DATA ATOM(115)/'CA2+'/C(115)/-21.013187/
      DATA (A(115,J),J=1,5)/  8.501441, 12.880483,  9.765095,  7.156669,
     1      0.711160/
      DATA (B(115,J),J=1,5)/ 10.525848, -0.004033,  0.010692,  0.684443,
     1     27.231771/
C             ********
      DATA ATOM(116)/'SC3+'/C(116)/  0.118642/
      DATA (A(116,J),J=1,5)/  7.104348,  1.511488,-53.669773, 38.404816,
     1     24.532240/
      DATA (B(116,J),J=1,5)/  0.601957,  0.033386, 12.572138, 10.859736,
     1     14.125230/
C             ********
C      DATA ATOM(117)/'TI2+'/C(117)/  0.150362/
C      DATA (A(117,J),J=1,5)/  7.040119,  1.496285,  9.657304,  0.006534,
C     1      1.649561/
C      DATA (B(117,J),J=1,5)/  0.537072,  0.031914,  8.009958,201.800293,
C     1     24.039482/
C             ********
      DATA ATOM(118)/'TI3+'/C(118)/-35.111282/
      DATA (A(118,J),J=1,5)/ 36.587933,  7.230255, -9.086077,  2.084594,
     1     17.294008/
      DATA (B(118,J),J=1,5)/  0.000681,  0.522262,  5.262317, 15.881716,
     1      6.149805/
C             ********
      DATA ATOM(119)/'TI4+'/C(119)/ -0.110628/
      DATA (A(119,J),J=1,5)/ 45.355537,  7.092900,  7.483858,-43.498817,
     1      1.678915/
      DATA (B(119,J),J=1,5)/  9.252186,  0.523046, 13.082852, 10.193876,
     1      0.023064/
C             ********
      DATA ATOM(120)/'V2+ '/C(120)/ -0.533379/
      DATA (A(120,J),J=1,5)/  7.754356,  2.064100,  2.576998,  2.011404,
     1      7.126177/
      DATA (B(120,J),J=1,5)/  7.066315,  0.014993,  7.066308, 22.055786,
     1      0.467568/
C             ********
      DATA ATOM(121)/'V3+ '/C(121)/  0.474921/
      DATA (A(121,J),J=1,5)/  9.958480,  1.596350,  1.483442,-10.846044,
     1     17.332867/
      DATA (B(121,J),J=1,5)/  6.763041,  0.056895, 17.750029,  0.328826,
     1      0.388013/
C             ********
      DATA ATOM(122)/'V5+ '/C(122)/  0.552676/
      DATA (A(122,J),J=1,5)/ 15.575018,  8.448095,  1.612040, -9.721855,
     1      1.534029/
      DATA (B(122,J),J=1,5)/  0.682708,  5.566640, 10.527077,  0.907961,
     1      0.066667/
C             ********
      DATA ATOM(123)/'CR2+'/C(123)/  0.049870/
      DATA (A(123,J),J=1,5)/ 10.598877,  1.565858,  2.728280,  0.098064,
     1      6.959321/
      DATA (B(123,J),J=1,5)/  6.151846,  0.023519, 17.432816, 54.002388,
     1      0.426301/
C             ********
      DATA ATOM(124)/'CR3+'/C(124)/ -0.192123/
      DATA (A(124,J),J=1,5)/  7.989310,  1.765079,  2.627125,  1.829380,
     1      6.980908/
      DATA (B(124,J),J=1,5)/  6.068867,  0.018342,  6.068887, 16.309284,
     1      0.420864/
C             ********
      DATA ATOM(125)/'MN2+'/C(125)/-24.566132/
      DATA (A(125,J),J=1,5)/ 11.287712, 26.042414,  3.058096,  0.090258,
     1      7.088306/
      DATA (B(125,J),J=1,5)/  5.506225,  0.000774, 16.158575, 54.766354,
     1      0.375580/
C             ********
      DATA ATOM(126)/'MN3+'/C(126)/ -0.093713/
      DATA (A(126,J),J=1,5)/  6.926972,  2.081342, 11.128379,  2.375107,
     1     -0.419287/
      DATA (B(126,J),J=1,5)/  0.378315,  0.015054,  5.379957, 14.429586,
     1      0.004939/
C             ********
      DATA ATOM(127)/'MN4+'/C(127)/  0.672146/
      DATA (A(127,J),J=1,5)/ 12.409131,  7.466993,  1.809947,-12.138477,
     1     10.780248/
      DATA (B(127,J),J=1,5)/  0.300400,  0.112814, 12.520756,  0.168653,
     1      5.173237/
C             ********
      DATA ATOM(128)/'FE2+'/C(128)/ -9.676919/
      DATA (A(128,J),J=1,5)/ 11.776765, 11.165097,  3.533495,  0.165345,
     1      7.036932/
      DATA (B(128,J),J=1,5)/  4.912232,  0.001748, 14.166556, 42.381958,
     1      0.341324/
C             ********
      DATA ATOM(129)/'FE3+'/C(129)/-61.930725/
      DATA (A(129,J),J=1,5)/  9.721638, 63.403847,  2.141347,  2.629274,
     1      7.033846/
      DATA (B(129,J),J=1,5)/  4.869297,  0.000293,  4.867602, 13.539076,
     1      0.338520/
C             ********
      DATA ATOM(130)/'CO2+'/C(130)/-24.796852/
      DATA (A(130,J),J=1,5)/  6.993840, 26.285812, 12.254289,  0.246114,
     1      4.017407/
      DATA (B(130,J),J=1,5)/  0.310779,  0.000684,  4.400528, 35.741447,
     1     12.536393/
C             ********
      DATA ATOM(131)/'CO3+'/C(131)/ -1.147345/
      DATA (A(131,J),J=1,5)/  6.861739,  2.678570, 12.281889,  3.501741,
     1     -0.179384/
      DATA (B(131,J),J=1,5)/  0.309794,  0.008142,  4.331703, 11.914167,
     1     11.914167/
C             ********
      DATA ATOM(132)/'NI2+'/C(132)/-36.344471/
      DATA (A(132,J),J=1,5)/ 12.519017, 37.832058,  4.387257,  0.661552,
     1      6.949072/
      DATA (B(132,J),J=1,5)/  3.933053,  0.000442, 10.449184, 23.860998,
     1      0.283723/
C             ********
      DATA ATOM(133)/'NI3+'/C(133)/ -0.317618/
      DATA (A(133,J),J=1,5)/ 13.579366,  1.902844, 12.859268,  3.811005,
     1     -6.838595/
      DATA (B(133,J),J=1,5)/  0.313140,  0.012621,  3.906407, 10.894311,
     1      0.344379/
C             ********
      DATA ATOM(134)/'CU1+'/C(134)/-14.849320/
      DATA (A(134,J),J=1,5)/ 12.960763, 16.342150,  1.110102,  5.520682,
     1      6.915452/
      DATA (B(134,J),J=1,5)/  3.576010,  0.000975, 29.523218, 10.114283,
     1      0.261326/
C             ********
      DATA ATOM(135)/'CU2+'/C(135)/-14.878383/
      DATA (A(135,J),J=1,5)/ 11.895569, 16.344978,  5.799817,  1.048804,
     1      6.789088/
      DATA (B(135,J),J=1,5)/  3.378519,  0.000924,  8.133653, 20.526524,
     1      0.254741/
C             ********
      DATA ATOM(136)/'ZN2+'/C(136)/ -8.945248/
      DATA (A(136,J),J=1,5)/ 13.340772, 10.428857,  5.544489,  0.762295,
     1      6.869172/
      DATA (B(136,J),J=1,5)/  3.215913,  0.001413,  8.542680, 21.891756,
     1      0.239215/
C             ********
      DATA ATOM(137)/'GA3+'/C(137)/-33.875122/
      DATA (A(137,J),J=1,5)/ 13.123875, 35.288189,  6.126979,  0.611551,
     1      6.724807/
      DATA (B(137,J),J=1,5)/  2.809960,  0.000323,  6.831534, 16.784311,
     1      0.212002/
C             ********
      DATA ATOM(138)/'GE4+'/C(138)/  1.086542/
      DATA (A(138,J),J=1,5)/  6.876636,  6.779091,  9.969591,  3.135857,
     1      0.152389/
      DATA (B(138,J),J=1,5)/  2.025174,  0.176650,  3.573822,  7.685848,
     1     16.677574/
C             ********
      DATA ATOM(139)/'BR1-'/C(139)/  1.152674/
      DATA (A(139,J),J=1,5)/ 17.714310,  6.466926,  6.947385,  4.402674,
     1     -0.697279/
      DATA (B(139,J),J=1,5)/  2.122554, 19.050768,  0.152708, 58.690361,
     1     58.690372/
C             ********
      DATA ATOM(140)/'RB1+'/C(140)/  1.133263/
      DATA (A(140,J),J=1,5)/ 17.684320,  7.761588,  6.680874,  2.668883,
     1      0.070974/
      DATA (B(140,J),J=1,5)/  1.710209, 14.919863,  0.128542, 31.654478,
     1      0.128543/
C             ********
      DATA ATOM(141)/'SR2+'/C(141)/  1.125309/
      DATA (A(141,J),J=1,5)/ 17.694973,  1.275762,  6.154252,  9.234786,
     1      0.515995/
      DATA (B(141,J),J=1,5)/  1.550888, 30.133041,  0.118774, 13.821799,
     1      0.118774/
C             ********
      DATA ATOM(142)/'Y3+ '/C(142)/ 19.023842/
      DATA (A(142,J),J=1,5)/ 46.660366, 10.369686,  4.623042,-62.170834,
     1     17.471146/
      DATA (B(142,J),J=1,5)/ -0.019971, 13.180257,  0.176398, -0.016727,
     1      1.467348/
C             ********
      DATA ATOM(143)/'ZR4+'/C(143)/  0.827902/
      DATA (A(143,J),J=1,5)/  6.802956, 17.699253, 10.650647, -0.248108,
     1      0.250338/
      DATA (B(143,J),J=1,5)/  0.096228,  1.296127, 11.240715, -0.219259,
     1     -0.219021/
C             ********
      DATA ATOM(144)/'NB3+'/C(144)/ -8.339573/
      DATA (A(144,J),J=1,5)/ 17.714323,  1.675213,  7.483963,  8.322464,
     1     11.143573/
      DATA (B(144,J),J=1,5)/  1.172419, 30.102791,  0.080255, -0.002983,
     1     10.456687/
C             ********
      DATA ATOM(145)/'NB5+'/C(145)/-68.024780/
      DATA (A(145,J),J=1,5)/ 17.580206,  7.633277, 10.793497,  0.180884,
     1     67.837921/
      DATA (B(145,J),J=1,5)/  1.165852,  0.078558,  9.507652, 31.621656,
     1     -0.000438/
C             ********
      DATA ATOM(146)/'MO3+'/C(146)/ -1.898764/
      DATA (A(146,J),J=1,5)/  7.447050, 17.778122, 11.886068,  1.997905,
     1      1.789626/
      DATA (B(146,J),J=1,5)/  0.072000,  1.073145,  9.834720, 28.221746,
     1     -0.011674/
C             ********
      DATA ATOM(147)/'MO5+'/C(147)/-78.056595/
      DATA (A(147,J),J=1,5)/  7.929879, 17.667669, 11.515987,  0.500402,
     1     77.444084/
      DATA (B(147,J),J=1,5)/  0.068856,  1.068064,  9.046229, 26.558945,
     1     -0.000473/
C             ********
      DATA ATOM(148)/'MO6+'/C(148)/  1.141916/
      DATA (A(148,J),J=1,5)/ 34.757683,  9.653037,  6.584769,-18.628115,
     1      2.490594/
      DATA (B(148,J),J=1,5)/  1.301770,  7.123843,  0.094097,  1.617443,
     1     12.335434/
C             ********
      DATA ATOM(149)/'RU3+'/C(149)/-51.905243/
      DATA (A(149,J),J=1,5)/ 17.894758, 13.579529, 10.729251,  2.474095,
     1     48.227997/
      DATA (B(149,J),J=1,5)/  0.902827,  8.740579,  0.045125, 24.764954,
     1     -0.001699/
C             ********
      DATA ATOM(150)/'RU4+'/C(150)/-17.241762/
      DATA (A(150,J),J=1,5)/ 17.845776, 13.455084, 10.229087,  1.653524,
     1     14.059795/
      DATA (B(150,J),J=1,5)/  0.901070,  8.482392,  0.045972, 23.015272,
     1     -0.004889/
C             ********
      DATA ATOM(151)/'RH3+'/C(151)/  0.960843/
      DATA (A(151,J),J=1,5)/ 17.758621, 14.569813,  5.298320,  2.533579,
     1      0.879753/
      DATA (B(151,J),J=1,5)/  0.841779,  8.319533,  0.069050, 23.709131,
     1      0.069050/
C             ********
      DATA ATOM(152)/'RH4+'/C(152)/  0.959941/
      DATA (A(152,J),J=1,5)/ 17.716188, 14.446654,  5.185801,  1.703448,
     1      0.989992/
      DATA (B(152,J),J=1,5)/  0.840572,  8.100647,  0.068995, 22.357307,
     1      0.068995/
C             ********
      DATA ATOM(153)/'PD2+'/C(153)/  0.879336/
      DATA (A(153,J),J=1,5)/  6.122282, 15.651012,  3.513508,  9.060790,
     1      8.771199/
      DATA (B(153,J),J=1,5)/  0.062424,  8.018296, 24.784275,  0.776457,
     1      0.776457/
C             ********
      DATA ATOM(154)/'PD4+'/C(154)/  0.915874/
      DATA (A(154,J),J=1,5)/  6.152421,-96.069023, 31.622141, 81.578255,
     1     17.801403/
      DATA (B(154,J),J=1,5)/  0.063951, 11.090354, 13.466152,  9.758302,
     1      0.783014/
C             ********
      DATA ATOM(155)/'AG1+'/C(155)/  0.785127/
      DATA (A(155,J),J=1,5)/  6.091192,  4.019526, 16.948174,  4.258638,
     1     13.889437/
      DATA (B(155,J),J=1,5)/  0.056305,  0.719340,  7.758938, 27.368349,
     1      0.719340/
C             ********
      DATA ATOM(156)/'AG2+'/C(156)/  1.068247/
      DATA (A(156,J),J=1,5)/  6.401808, 48.699802,  4.799859,-32.332523,
     1     16.356710/
      DATA (B(156,J),J=1,5)/  0.068167,  0.942270, 20.639496,  1.100365,
     1      6.883131/
C             ********
      DATA ATOM(157)/'CD2+'/C(157)/  0.664795/
      DATA (A(157,J),J=1,5)/  6.093711, 43.909691, 17.041306,-39.675117,
     1     17.958918/
      DATA (B(157,J),J=1,5)/  0.050624,  8.654143, 15.621396, 11.082067,
     1      0.667591/
C             ********
      DATA ATOM(158)/'IN3+'/C(158)/  0.293677/
      DATA (A(158,J),J=1,5)/  6.206277, 18.497746,  3.078131, 10.524613,
     1      7.401234/
      DATA (B(158,J),J=1,5)/  0.041357,  6.605563, 18.792250,  0.608082,
     1      0.608082/
C             ********
      DATA ATOM(159)/'SN2+'/C(159)/ -0.042519/
      DATA (A(159,J),J=1,5)/  6.353672,  4.770377, 14.672025,  4.235959,
     1     18.002131/
      DATA (B(159,J),J=1,5)/  0.034720,  6.167891,  6.167879, 29.006456,
     1      0.561774/
C             ********
      DATA ATOM(160)/'SN4+'/C(160)/ -0.172219/
      DATA (A(160,J),J=1,5)/ 15.445732,  6.420892,  4.562980,  1.713385,
     1     18.033537/
      DATA (B(160,J),J=1,5)/  6.280898,  0.033144,  6.280899, 17.983601,
     1      0.557980/
C             ********
      DATA ATOM(161)/'SB3+'/C(161)/  1.516108/
      DATA (A(161,J),J=1,5)/ 10.189171, 57.461918, 19.356573,  4.862206,
     1    -45.394096/
      DATA (B(161,J),J=1,5)/  0.089485,  0.375256,  5.357987, 22.153736,
     1      0.297768/
C             ********
      DATA ATOM(162)/'SB5+'/C(162)/ -0.445371/
      DATA (A(162,J),J=1,5)/ 17.920622,  6.647932, 12.724075,  1.555545,
     1      7.600591/
      DATA (B(162,J),J=1,5)/  0.522315,  0.029487,  5.718210, 16.433775,
     1      5.718204/
C             ********
      DATA ATOM(163)/'I1- '/C(163)/ -3.341004/
      DATA (A(163,J),J=1,5)/ 20.010330, 17.835524,  8.104130,  2.231118,
     1      9.158548/
      DATA (B(163,J),J=1,5)/  4.565931,  0.444266, 32.430672, 95.149040,
     1      0.014906/
C             ********
      DATA ATOM(164)/'CS1+'/C(164)/-19.394306/
      DATA (A(164,J),J=1,5)/ 19.939056, 24.967621, 10.375884,  0.454243,
     1     17.660248/
      DATA (B(164,J),J=1,5)/  3.770511,  0.004040, 25.311275, 76.537766,
     1      0.384730/
C             ********
      DATA ATOM(165)/'BA2+'/C(165)/-59.618172/
      DATA (A(165,J),J=1,5)/ 19.750200, 17.513683, 10.884892,  0.321585,
     1     65.149834/
      DATA (B(165,J),J=1,5)/  3.430748,  0.361590, 21.358307, 70.309402,
     1      0.001418/
C             ********
      DATA ATOM(166)/'LA3+'/C(166)/-76.846909/
      DATA (A(166,J),J=1,5)/ 19.688887, 17.345703, 11.356296,  0.099418,
     1     82.358124/
      DATA (B(166,J),J=1,5)/  3.146211,  0.339586, 18.753832, 90.345459,
     1      0.001072/
C             ********
      DATA ATOM(167)/'CE3+'/C(167)/-80.313423/
      DATA (A(167,J),J=1,5)/ 26.593231, 85.866432, -6.677695, 12.111847,
     1     17.401903/
      DATA (B(167,J),J=1,5)/  3.280381,  0.001012,  4.313575, 17.868504,
     1      0.326962/
C             ********
      DATA ATOM(168)/'CE4+'/C(168)/ -3.515096/
      DATA (A(168,J),J=1,5)/ 17.457533, 25.659941, 11.691037, 19.695251,
     1    -16.994749/
      DATA (B(168,J),J=1,5)/  0.311812, -0.003793, 16.568687,  2.886395,
     1     -0.008931/
C             ********
      DATA ATOM(169)/'PR3+'/C(169)/-30.500784/
      DATA (A(169,J),J=1,5)/ 20.879841, 36.035797, 12.135341,  0.283103,
     1     17.167803/
      DATA (B(169,J),J=1,5)/  2.870897,  0.002364, 16.615236, 53.909359,
     1      0.306993/
C             ********
      DATA ATOM(170)/'PR4+'/C(170)/ -9.016722/
      DATA (A(170,J),J=1,5)/ 17.496082, 21.538509, 20.403114, 12.062211,
     1     -7.492043/
      DATA (B(170,J),J=1,5)/  0.294457, -0.002742,  2.772886, 15.804613,
     1     -0.013556/
C             ********
      DATA ATOM(171)/'ND3+'/C(171)/-50.541992/
      DATA (A(171,J),J=1,5)/ 17.120077, 56.038139, 21.468307, 10.000671,
     1      2.905866/
      DATA (B(171,J),J=1,5)/  0.291295,  0.001421,  2.743681, 14.581367,
     1     22.485098/
C             ********
      DATA ATOM(172)/'PM3+'/C(172)/-46.767181/
      DATA (A(172,J),J=1,5)/ 22.221066, 17.068142, 12.805423,  0.435687,
     1     52.238770/
      DATA (B(172,J),J=1,5)/  2.635767,  0.277039, 14.927315, 45.768017,
     1      0.001455/
C             ********
      DATA ATOM(173)/'SM3+'/C(173)/ -9.714854/
      DATA (A(173,J),J=1,5)/ 15.618565, 19.538092, 13.398946, -4.358811,
     1     24.490461/
      DATA (B(173,J),J=1,5)/  0.006001,  0.306379, 14.979594,  0.748825,
     1      2.454492/
C             ********
      DATA ATOM(174)/'EU2+'/C(174)/-26.204315/
      DATA (A(174,J),J=1,5)/ 23.899035, 31.657497, 12.955752,  1.700576,
     1     16.992199/
      DATA (B(174,J),J=1,5)/  2.467332,  0.002230, 13.625002, 35.089481,
     1      0.253136/
C             ********
      DATA ATOM(175)/'EU3+'/C(175)/-19.768026/
      DATA (A(175,J),J=1,5)/ 17.758327, 33.498665, 24.067188, 13.436883,
     1     -9.019134/
      DATA (B(175,J),J=1,5)/  0.244474, -0.003901,  2.487526, 14.568011,
     1     -0.015628/
C             ********
      DATA ATOM(176)/'GD3+'/C(176)/-88.147179/
      DATA (A(176,J),J=1,5)/ 24.344999, 16.945311, 13.866931,  0.481674,
     1     93.506378/
      DATA (B(176,J),J=1,5)/  2.333971,  0.239215, 12.982995, 43.876347,
     1      0.000673/
C             ********
      DATA ATOM(177)/'TB3+'/C(177)/-33.950317/
      DATA (A(177,J),J=1,5)/ 24.878252, 16.856016, 13.663937,  1.279671,
     1     39.271294/
      DATA (B(177,J),J=1,5)/  2.223301,  0.227290, 11.812528, 29.910065,
     1      0.001527/
C             ********
      DATA ATOM(178)/'DY3+'/C(178)/-85.150650/
      DATA (A(178,J),J=1,5)/ 16.864344, 90.383461, 13.675473,  1.687078,
     1     25.540651/
      DATA (B(178,J),J=1,5)/  0.216275,  0.000593, 11.121207, 26.250975,
     1      2.135930/
C             ********
      DATA ATOM(179)/'HO3+'/C(179)/-58.026505/
      DATA (A(179,J),J=1,5)/ 16.837524, 63.221336, 13.703766,  2.061602,
     1     26.202621/
      DATA (B(179,J),J=1,5)/  0.206873,  0.000796, 10.500283, 24.031883,
     1      2.055060/
C             ********
      DATA ATOM(180)/'ER3+'/C(180)/-17.513460/
      DATA (A(180,J),J=1,5)/ 16.810127, 22.681061, 13.864114,  2.294506,
     1     26.864477/
      DATA (B(180,J),J=1,5)/  0.198293,  0.002126,  9.973341, 22.836388,
     1      1.979442/
C             ********
      DATA ATOM(181)/'TM3+'/C(181)/-10.192087/
      DATA (A(181,J),J=1,5)/ 16.787500, 15.350905, 14.182357,  2.299111,
     1     27.573771/
      DATA (B(181,J),J=1,5)/  0.190852,  0.003036,  9.602934, 22.526880,
     1      1.912862/
C             ********
      DATA ATOM(182)/'YB2+'/C(182)/-23.214935/
      DATA (A(182,J),J=1,5)/ 28.443794, 16.849527, 14.165081,  3.445311,
     1     28.308853/
      DATA (B(182,J),J=1,5)/  1.863896,  0.183811,  9.225469, 23.691355,
     1      0.001463/
C             ********
      DATA ATOM(183)/'YB3+'/C(183)/-18.103676/
      DATA (A(183,J),J=1,5)/ 28.191629, 16.828087, 14.167848,  2.744962,
     1     23.171774/
      DATA (B(183,J),J=1,5)/  1.842889,  0.182788,  9.045957, 20.799847,
     1      0.001759/
C             ********
      DATA ATOM(184)/'LU3+'/C(184)/-20.626528/
      DATA (A(184,J),J=1,5)/ 28.828693, 16.823227, 14.247617,  3.079559,
     1     25.647667/
      DATA (B(184,J),J=1,5)/  1.776641,  0.175560,  8.575531, 19.693701,
     1      0.001453/
C             ********
      DATA ATOM(185)/'HF4+'/C(185)/-18.820383/
      DATA (A(185,J),J=1,5)/ 29.267378, 16.792543, 14.785310,  2.184128,
     1     23.791996/
      DATA (B(185,J),J=1,5)/  1.697911,  0.168313,  8.190025, 18.277578,
     1      0.001431/
C             ********
      DATA ATOM(186)/'TA5+'/C(186)/-11.542459/
      DATA (A(186,J),J=1,5)/ 29.539469, 16.741854, 15.182070,  1.642916,
     1     16.437447/
      DATA (B(186,J),J=1,5)/  1.612934,  0.160460,  7.654408, 17.070732,
     1      0.001858/
C             ********
      DATA ATOM(187)/'W6+ '/C(187)/  3.945157/
      DATA (A(187,J),J=1,5)/ 29.729357, 17.247808, 15.184488,  1.154652,
     1      0.739335/
      DATA (B(187,J),J=1,5)/  1.501648,  0.140803,  6.880573, 14.299601,
     1     14.299618/
C             ********
      DATA ATOM(188)/'OS4+'/C(188)/  3.988390/
      DATA (A(188,J),J=1,5)/ 17.113485, 15.792370, 23.342392,  4.090271,
     1      7.671292/
      DATA (B(188,J),J=1,5)/  0.131850,  7.288542,  1.389307, 19.629425,
     1      1.389307/
C             ********
      DATA ATOM(189)/'IR3+'/C(189)/  4.009459/
      DATA (A(189,J),J=1,5)/ 31.537575, 16.363338, 15.597141,  5.051404,
     1      1.436935/
      DATA (B(189,J),J=1,5)/  1.334144,  7.451918,  0.127514, 21.705648,
     1      0.127515/
C             ********
      DATA ATOM(190)/'IR4+'/C(190)/  4.006865/
      DATA (A(190,J),J=1,5)/ 30.391249, 16.146996, 17.019068,  4.458904,
     1      0.975372/
      DATA (B(190,J),J=1,5)/  1.328519,  7.181766,  0.127337, 19.060146,
     1      1.328519/
C             ********
      DATA ATOM(191)/'PT2+'/C(191)/  4.032512/
      DATA (A(191,J),J=1,5)/ 31.986849, 17.249048, 15.269374,  5.760234,
     1      1.694079/
      DATA (B(191,J),J=1,5)/  1.281143,  7.625512,  0.123571, 24.190826,
     1      0.123571/
C             ********
      DATA ATOM(192)/'PT4+'/C(192)/  4.094551/
      DATA (A(192,J),J=1,5)/ 41.932713, 16.339224, 17.653894,  6.012420,
     1    -12.036877/
      DATA (B(192,J),J=1,5)/  1.111409,  6.466086,  0.128917, 16.954155,
     1      0.778721/
C             ********
      DATA ATOM(193)/'AU1+'/C(193)/  4.040792/
      DATA (A(193,J),J=1,5)/ 32.124306, 16.716476, 16.814100,  7.311565,
     1      0.993064/
      DATA (B(193,J),J=1,5)/  1.216073,  7.165378,  0.118715, 20.442486,
     1     53.095985/
C             ********
      DATA ATOM(194)/'AU3+'/C(194)/  4.042679/
      DATA (A(194,J),J=1,5)/ 31.704271, 17.545767, 16.819551,  5.522640,
     1      0.361725/
      DATA (B(194,J),J=1,5)/  1.215561,  7.220506,  0.118812, 20.050970,
     1      1.215562/
C             ********
      DATA ATOM(195)/'HG1+'/C(195)/  4.068430/
      DATA (A(195,J),J=1,5)/ 28.866837, 19.277540, 16.776051,  6.281459,
     1      3.710289/
      DATA (B(195,J),J=1,5)/  1.173967,  7.583842,  0.115351, 29.055994,
     1      1.173968/
C             ********
      DATA ATOM(196)/'HG2+'/C(196)/  4.052869/
      DATA (A(196,J),J=1,5)/ 32.411079, 18.690371, 16.711773,  9.974835,
     1     -3.847611/
      DATA (B(196,J),J=1,5)/  1.162980,  7.329806,  0.114518, 22.009489,
     1     22.009493/
C             ********
      DATA ATOM(197)/'TL1+'/C(197)/  4.054030/
      DATA (A(197,J),J=1,5)/ 32.295044, 16.570049, 17.991013,  1.535355,
     1      7.554591/
      DATA (B(197,J),J=1,5)/  1.101544,  0.110020,  6.528559, 52.495068,
     1     20.338634/
C             ********
      DATA ATOM(198)/'TL3+'/C(198)/ -9.256075/
      DATA (A(198,J),J=1,5)/ 32.525639, 19.139185, 17.100321,  5.891115,
     1     12.599463/
      DATA (B(198,J),J=1,5)/  1.094966,  6.900992,  0.103667, 18.489614,
     1     -0.001401/
C             ********
      DATA ATOM(199)/'PB2+'/C(199)/  4.065623/
      DATA (A(199,J),J=1,5)/ 27.392647, 16.496822, 19.984501,  6.813923,
     1      5.233910/
      DATA (B(199,J),J=1,5)/  1.058874,  0.106305,  6.708123, 24.395554,
     1      1.058874/
C             ********
      DATA ATOM(200)/'PB4+'/C(200)/  4.044678/
      DATA (A(200,J),J=1,5)/ 32.505657, 20.014240, 14.645661,  5.029499,
     1      1.760138/
      DATA (B(200,J),J=1,5)/  1.047035,  6.670321,  0.105279, 16.525040,
     1      0.105279/
C             ********
      DATA ATOM(201)/'BI3+'/C(201)/  4.043703/
      DATA (A(201,J),J=1,5)/ 32.461437, 19.438683, 16.302486,  7.322662,
     1      0.431704/
      DATA (B(201,J),J=1,5)/  0.997930,  6.038867,  0.101338, 18.371586,
     1     46.361046/
C             ********
      DATA ATOM(202)/'BI5+'/C(202)/  4.113663/
      DATA (A(202,J),J=1,5)/ 16.734028, 20.580494,  9.452623, 61.155834,
     1    -34.041023/
      DATA (B(202,J),J=1,5)/  0.105076,  4.773282, 11.762162,  1.211775,
     1      1.619408/
C             ********
      DATA ATOM(203)/'RA2+'/C(203)/  3.956572/
      DATA (A(203,J),J=1,5)/  4.986228, 32.474945, 21.947443, 11.800013,
     1     10.807292/
      DATA (B(203,J),J=1,5)/  0.082597,  0.791468,  4.608034, 24.792431,
     1      0.082597/
C             ********
      DATA ATOM(204)/'AC3+'/C(204)/  3.838984/
      DATA (A(204,J),J=1,5)/ 15.584983, 32.022125, 21.456327,  0.757593,
     1     12.341252/
      DATA (B(204,J),J=1,5)/  0.077438,  0.739963,  4.040735, 47.525002,
     1     19.406845/
C             ********
      DATA ATOM(205)/'TH4+'/C(205)/  3.831122/
      DATA (A(205,J),J=1,5)/ 15.515445, 32.090691, 13.996399, 12.918157,
     1      7.635514/
      DATA (B(205,J),J=1,5)/  0.074499,  0.711663,  3.871044, 18.596891,
     1      3.871044/
C             ********
      DATA ATOM(206)/'U3+ '/C(206)/  3.706622/
      DATA (A(206,J),J=1,5)/ 15.360309, 32.395657, 21.961290,  1.325894,
     1     14.251453/
      DATA (B(206,J),J=1,5)/  0.067815,  0.654643,  3.643409, 39.604965,
     1     16.330570/
C             ********
      DATA ATOM(207)/'U4+ '/C(207)/  3.705863/
      DATA (A(207,J),J=1,5)/ 15.355091, 32.235306,  0.557745, 14.396367,
     1     21.751173/
      DATA (B(207,J),J=1,5)/  0.067789,  0.652613, 42.354237, 15.908239,
     1      3.553231/
C             ********
      DATA ATOM(208)/'U6+ '/C(208)/  3.700591/
      DATA (A(208,J),J=1,5)/ 15.333844, 31.770849, 21.274414, 13.872636,
     1      0.048519/
      DATA (B(208,J),J=1,5)/  0.067644,  0.646384,  3.317894, 14.650250,
     1     75.339699/
C             ********
      DATA ATOM(209)/'NP3+'/C(209)/  3.603370/
      DATA (A(209,J),J=1,5)/ 15.378152, 32.572132, 22.206125,  1.413295,
     1     14.828381/
      DATA (B(209,J),J=1,5)/  0.064613,  0.631420,  3.561936, 37.875511,
     1     15.546129/
C             ********
      DATA ATOM(210)/'NP4+'/C(210)/  3.603039/
      DATA (A(210,J),J=1,5)/ 15.373926, 32.423019, 21.969994,  0.662078,
     1     14.969350/
      DATA (B(210,J),J=1,5)/  0.064597,  0.629658,  3.476389, 39.438942,
     1     15.135764/
C             ********
      DATA ATOM(211)/'NP6+'/C(211)/  3.600942/
      DATA (A(211,J),J=1,5)/ 15.359986, 31.992825, 21.412458,  0.066574,
     1     14.568174/
      DATA (B(211,J),J=1,5)/  0.064528,  0.624505,  3.253441, 67.658318,
     1     13.980832/
C             ********
      DATA ATOM(212)/'PU3+'/C(212)/  3.428895/
      DATA (A(212,J),J=1,5)/ 15.356004, 32.769127, 22.680210,  1.351055,
     1     15.416232/
      DATA (B(212,J),J=1,5)/  0.060590,  0.604663,  3.491509, 37.260635,
     1     14.981921/
C             ********
      DATA ATOM(213)/'PU4+'/C(213)/  3.480408/
      DATA (A(213,J),J=1,5)/ 15.416219, 32.610569, 22.256662,  0.719495,
     1     15.518152/
      DATA (B(213,J),J=1,5)/  0.061456,  0.607938,  3.411848, 37.628792,
     1     14.464360/
C             ********
      DATA ATOM(214)/'PU6+'/C(214)/  3.502325/
      DATA (A(214,J),J=1,5)/ 15.436506, 32.289719, 14.726737, 15.012391,
     1      7.024677/
      DATA (B(214,J),J=1,5)/  0.061815,  0.606541,  3.245363, 13.616438,
     1      3.245364/
C             ********
      DATA ATOM(215)/'MGIN'/C(215)/  0.328847/
      DATA (A(215,J),J=1,5)/  0.257260,  1.438479,  1.968000,  2.400207,
     1      3.607183/
      DATA (B(215,J),J=1,5)/ 13.498580,  0.152078,  7.014306,  1.845831,
     1      3.676989/
C             ********
      DATA ATOM(216)/'OOIN'/C(216)/  0.259992/
      DATA (A(216,J),J=1,5)/ -1.981000,  1.080188,  1.535386,  4.358089,
     1      4.746281/
      DATA (B(216,J),J=1,5)/ 13.415700,  4.294517,  0.336337, 10.009640,
     1     26.618240/
C             ********
      ION=.false.
C     Ensure that symb is upper case, may not be needed
      SYMBU=SYMB
      I1 = ICHAR ('a')
      I2 = ICHAR ('z')
      do j=1,4
           DUM = SYMBU(j:j)
           IDUM = ICHAR (DUM)
           IF(DUM .eq. '+' .or. DUM .eq. '-')then
             ION=.true.
           ELSE IF (IDUM .GT. 126 .OR. IDUM .LT. 32) THEN
             DUM = ' '
           ELSE IF (IDUM .GE. I1 .AND. IDUM .LE. I2) THEN
             DUM = CHAR (IDUM - 32)
           END IF
           SYMBU(J:J) = DUM
      ENDDO
      DO J=1,Natoms
         IF (SYMBU.EQ.ATOM(J))THEN
            CX=C(J)
            SUMZ=CX
            DO K=1,5 
               AX(K)=A(J,K)
               BX(K)=B(J,K)
               SUMZ=SUMZ+AX(K)
            ENDDO
C           Trap rounding errors, except for ions
            IZ=NINT(SUMZ)
            DIFF=IZ-SUMZ
            IF(ion)then
C                write(10,*)'     Nett Charge ',ZIZZ-SUMZ
            else
C                write(10,*)'     Neutrality correction ',DIFF
                CX=CX+(IZ-SUMZ)
            ENDIF
            OK=.TRUE.
            RETURN
         ENDIF
      ENDDO
      OK=.FALSE.
      RETURN
      END
