C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE STGEN (FOMF, IFOM, CHILD, PARAM, ASK, IPOP, BITS, IFIT
     X    , KCNT )
C     Store our output:
C           If ifom=0, it's old
C           If ifom=1, it's new
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C     This is fixed at 1 for binary data !
C  mindiv: maximal number of chromosomes per population
         PARAMETER (MPARAM = 80, MNBITS = 4, MINDIV = 2000)
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 6  - Increased from 8 to 10 for multislice use
C     Number of members - 500
C     Number of children - 4*mindiv (2400)
         PARAMETER (MCHILD = MINDIV)
C     Note: mnbits*mparam appears in several array declarations
C
C     nhk2 for total number of beams (also must change nhk !
         PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         LOGICAL XRAY
         DIMENSION LL(9)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
 
 
         DIMENSION ASK(MCHILD,MPARAM)
         DIMENSION FOMF(*), IFOM(*)
         INTEGER PARAM, CHILD, IFIT(*)
         INTEGER BITS, BIT(320)
         CHARACTER DUMMY2*17
         CHARACTER*400 LINE
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
 
         OPEN (UNIT=10, FILE='calculated.log', ACCESS='append')
         OPEN (UNIT=11, FILE='population')
         OPEN (UNIT=12, FILE='fitfile', ACCESS='append')
         DO   J=1,CHILD
           IF (IFOM(J) .GT. 0) THEN
C           It's a new one
             WRITE (10, 1) IPOP, FOMF(J), (ASK(J,K), K=1,PARAM)
    1        FORMAT(I4,F7.4,200F6.1)
             KCNT = KCNT + 1
             IFIT(J) = KCNT
           END IF
 
C     Get the coding from population
           READ (11, 40) DUMMY2, (BIT(I), I=1,BITS)
   40      FORMAT(A17,200I1)
 
C     Tack it on to the end of fitfile
           WRITE (LINE, 30) FOMF(J), '  ', (BIT(I), I=1,BITS)
           LINE(BITS + 18:BITS + 18) = ' '
           WRITE (LINE(BITS + 19:BITS + 24), 31) IFIT(J)
   31      FORMAT(I6)
           WRITE (12, 32) LINE(1:BITS + 24)
   32      FORMAT(A)
   30      FORMAT(F15.4,A2,200I1)
         END DO
 
C     That's all folks!
         RETURN
       END
