C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE PADAP (H, K, NREF, SYMM, NPAD, R1, R2, M, MULTI )
C     Pad at end of h,k additional reflections for consistency
C     with entropy limits of extnsion
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         INTEGER H(*), K(*), HMAX, KMAX, HE(20), KE(20), ISE(20)
         INTEGER M(3), MULTI(*)
         CHARACTER*4 SYMM
C         INTEGER II1, II2, II3
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         HMAX = (-1)
         KMAX = (-1)
         RRP3 = R1*R1*4.D0
         DO   N=1,NREF
           CALL EQUIV2 (HE,KE,ISE,H(N),K(N),NE,SYMM)
           DO NN=1,NE
                HMAX = MAX (HMAX, HE(NN))
                KMAX = MAX (KMAX, KE(NN))
           ENDDO
         END DO
         I1 = MAX (HMAX, KMAX) + 10
         NPAD = NREF
         II3 = -I1
         IF(printf)then
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           write(10,2)'For P3 Padding, HMAX=',hmax,' KMAX=',kmax
         ELSE
           write(10,2)'For Padding, HMAX=',hmax,' KMAX=',kmax
         ENDIF
         write(10,3)'Orthogonal Reciprocal sampling ',r1,r2
2        format(/a,i3,a,i3)
3        format(a,2F10.6/)
         ENDIF
 
C     Range limits need to be double-checked
         DO   J1=0,I1
C     Angst Check -- should be the same, but...
              JL=-I1
C           IF (SYMM .EQ. 'p3  ') THEN
C             JL = 0
C           ELSE IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
C             JL = J1
C           ELSE IF (SYMM .EQ. 'p1  ' .OR. SYMM .EQ. 'p2  ') THEN
C             JL = II3
C           ELSE IF (SYMM(1:2) .EQ. 'p4') THEN
C             JL = J1
C           ELSE
C             JL = 0
C           END IF
           DO 20 J2=JL,I1
 
C     Trap for centering
             IF (SYMM(1:1) .EQ. 'c') THEN
               IF (((J1 + J2) / 2) * 2 .NE. J1 + J2) GO TO 20
             END IF
             IH = J1
             IK = J2
             IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
C                IF(PATTC.LT.-5.)THEN
                  RR = DBLE(J1*J1+J2*J2+J1*J2)*RRP3
C                ELSE
C                  CALL P3EXP (IH,IK,J1,J2)
C                  X2 = IK * R2
C                  X1 = IH * R1
C                  RR = X1*X1 + X2*X2
C                ENDIF
             ELSE
C               Where they will be
                X2 = IK * R2
                X1 = IH * R1
                RR = X1*X1 + X2*X2
             ENDIF
C           Mock circular aperture
             IF (RR .LT. 1.D0) THEN
 
C           Do we have this reflection already ?
               CALL EQUIV2 (HE,KE,ISE,J1,J2,NE,SYMM)
               DO   J=1,NPAD
                 II1 = K(J)
                 II2 = H(J)
                 DO   JJ=1,NE
                   IF (HE(JJ) .EQ. II2 .AND. KE(JJ) .EQ. II1) GO TO 10
                 END DO
               END DO
C           No
               IF (PRINTF) WRITE (10, 11) J1, J2
   11          FORMAT('Padding with (',I3,',',I3,')')
               NPAD = NPAD + 1
               H(NPAD) = J1
               K(NPAD) = J2
               MULTI(NPAD) = NE
   10          CONTINUE
             END IF
   20      END DO
         END DO
 
C     For p3 cases, reduce h,k
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=NREF+1,NPAD
             KLOW = 9999
             CALL EQUIV2 (HE,KE,ISE,H(J),K(J),NE,SYMM)
             DO   JJ=1,NE
             IND=1
               IF (ABS (KE(JJ)) .LT. KLOW) THEN
                 KLOW = ABS (KE(JJ))
                 IND = JJ
               END IF
             END DO
             H(J) = HE(IND)
             K(J) = KE(IND)
             IF (H(J) .LT. 0.D0) THEN
               H(J) = -H(J)
               K(J) = -K(J)
             END IF
           END DO
         END IF
 
         RETURN
       END

