C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SCLCAL (F1, F2, F3, N, SINPUT, ERR )
         DIMENSION F1(*), F2(*), F3(*)
         DOUBLEPRECISION SCALE, E1, E2, E3, FA, FB, FC, EST
C     initial estimate
         SCALE = SINPUT
         E1 = SCALE
         E2 = SCALE * 1.02D0
         STEP = SCALE * 0.02D0
         FA = ERRVAL (F1,F2,F3,N,E1)
C     Try on one side
         FB = ERRVAL (F1,F2,F3,N,E2)
C        write(6,*)Fa,Fb,E1,E2
   10    IF (FB .LE. FA) THEN
           E3 = E2 + STEP
           FC = ERRVAL (F1,F2,F3,N,E3)
C          write(6,*)Fa,Fb,Fc,E1,E2,E3
           IF (FC .GT. FB) THEN
C           It is bracketed between the three
           ELSE
C           We are walking down
             E1 = E2
             FA = FB
             E2 = E3
             FB = FC
             GO TO 10
           END IF
         ELSE
C     We went up, so flip around and try other side
           STEP = -STEP
           TEMP = FA
           TEMPE = E1
           E1 = E2
           FA = FB
           E2 = TEMPE
           FB = TEMP
           GO TO 10
         END IF
 
C     We now have the minimum bracketed between
C     e1,e2,e3 with corresponding values v1,v2,v3
C     write(6,*)'Got a bracket'
         ERR = GSRCH (E1,E2,E3,EST,F1,F2,F3,N,ITER)
C     write(10,*)'Iterations to fit ',iter
C     write(6,*)'Iterations to fit ',iter
         SINPUT = EST
         RETURN
       END
