C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPM2D (N1, N2, M, C, MPROJ )
C      This version just applies the model, nothing else
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C        DIMENSION WTMP1(512*512),WTMP2(512*512)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
 
C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
C             WTMP1(JK)=XR
C             WTMP2(JK)=XI
           END DO
         END DO
C        call debpic(N1,N2,WTMP1,2)
C        call debpic(N1,N2,WTMP2,3)
C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(0.5,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               X = (EA*(1-FILT(JK)) + EM*FILT(JK)) * FTEMP
               C(JK) = X * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               X =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               X = XC * FILT(JK) + (1 - FILT(JK)) * X
               C(JK) = MAX (DBLE (X), 0.D0) * FAC
    2          CONTINUE
         END IF
 
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
C
       SUBROUTINE modelsharp (N1, N2, M, C, MPROJ )
C      This version returns the model in the imaginary part
C      The conventional entropy in the real part
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C        DIMENSION WTMP1(512*512),WTMP2(512*512)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)

C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
C             WTMP1(JK)=XR
C             WTMP2(JK)=XI
           END DO
         END DO

C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C        write(10,*)'Scaling term ',scl,s1,s2,s1/s2
C        write(6,*)'Scaling term ',scl,s1,s2,s1/s2
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF*FTEMP
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               EM = (EA*(1-FILT(JK)) + EM*FILT(JK))
C               XR =  EA
               C(JK) = cmplx(EA,EM) * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = XC * FILT(JK) + (1 - FILT(JK)) * XR
C     Entropy term for solution
               XR = XR/XMEAN
               IF (XR .GT. 1D-6) THEN
                 XR = XR * LOG (XR) *FTEMP
               ELSE
                 XR = 0.
               END IF
               XI = MAX(XI, 0.D0)
               C(JK) = CMPLX(XR,XI) * FAC
    2          CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
       SUBROUTINE modelsharp0 (N1, N2, M, C, MPROJ )
C      This version returns the model in the imaginary part
C      The conventional entropy in the real part
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C        DIMENSION WTMP1(512*512),WTMP2(512*512)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)

C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
C             WTMP1(JK)=XR
C             WTMP2(JK)=XI
           END DO
         END DO

C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C        write(10,*)'Scaling term ',scl,s1,s2,s1/s2
C        write(6,*)'Scaling term ',scl,s1,s2,s1/s2
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF*FTEMP
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               XI = (EA*(1-FILT(JK)) + EM*FILT(JK))
C               XR =  EA
               C(JK) = cmplx(XI,XI) * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = XC * FILT(JK) + (1 - FILT(JK)) * XR
C     Entropy term for solution
C               XR = XR/XMEAN
C               IF (XR .GT. 1D-6) THEN
C                 XR = XR * LOG (XR) *FTEMP
C               ELSE
C                 XR = 0.
C               END IF
               XI = MAX(XI, 0.D0)
               C(JK) = CMPLX(XI,XI) * FAC
    2          CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
       SUBROUTINE modelstrong (N1, N2, M, C, MPROJ )
C      This version returns the model in the imaginary part
C      The conventional entropy in the real part
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C        DIMENSION WTMP1(512*512),WTMP2(512*512)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)

C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
C             WTMP1(JK)=XR
C             WTMP2(JK)=XI
           END DO
         END DO

C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C        write(10,*)'Scaling term ',scl,s1,s2,s1/s2
C        write(6,*)'Scaling term ',scl,s1,s2,s1/s2
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF*FTEMP
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               EM = (EA*(1-FILT(JK)) + EM*FILT(JK))
C               XR =  EA
               C(JK) = cmplx(EM,EA) * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = XC * FILT(JK) + (1 - FILT(JK)) * XR
C     Entropy term for solution
               XR = XR/XMEAN
               IF (XR .GT. 1D-6) THEN
                 XR = XR * LOG (XR) *FTEMP
               ELSE
                 XR = 0.
               END IF
               XI = MAX(XI, 0.D0)
               C(JK) = CMPLX(XI,XR) * FAC
    2          CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
