/*
  mb_sim.h
 */

typedef struct{
  UVW   incidence, surf_norm;
  R_HKL zolzbase1, zolzbase2;
  double  H_tilt, G_tilt;      /* tilt from ZA */
  BEAM_SEARCH_PAR  beam_search;
  char  hg_file[256];   /* file name of HG data */
  int  calc_range_flag, calc_type;
  int  num_points;
  double H_begin, H_end, G_begin, G_end;

  double accel_kvol;
  int  num_exact, num_bethe;  HKL *reflex;
  int  num_g, *calc_g;  /* (*)  ==> ig */
/*  int  *num_points_lnp; */
                        /* (*)  ==> ig, only for calc_type 4 */
/*  double	*H_begin_lnp, *H_end_lnp, *G_lnp; */
                        /* (*)  ==> ig, only for calc_type 4 */
/*  R_HKL	**k_xy_lnp; */
                        /* (**) ==> ig, ik, only for calc_type 4 */
  int  num_thickness;  double  *thickness;
  int  num_k_points;  R_HKL	*k_xy;
  int  *h_pos, *g_pos;
  double  *H, *G, ***intensity;	/* (*) ==> ik, (***) ==> ig, it, ik */
  int  disp_type;

  /* For DISP_SURF & BLOCH */
  int  branch_begin, branch_end;

  /* For BLOCH, SPCELL & DENSITIES */
  double  x_begin, x_end, y_begin, y_end, z_begin, z_end;
  int  num_points_x, num_points_y, num_points_z, unitcell_xyz_flag;
  R_UVW	x1, x2, x3; /* <== dummy ? */

  /* For SPCELL */
  int     Ncell_a, Ncell_b, Ncell_c;
  double  H_aperture, coef_cs, df, org_u, org_v, org_w;

  /* For E_DENSITY_PROJ_MODE */
  double  area_proj_cell; 
} SIM_DATA;		/* ----- For SIM, SPCELL, DISP_SURF and BLOCH ----- */


typedef struct{
  UVW   incidence, surf_norm;
  R_HKL zolzbase1, zolzbase2;
  double  H_tilt, G_tilt;
  double H_min, H_max, G_min, G_max;
  int  hpix_max, hpix_min, gpix_max, gpix_min;
  double accel_kvol;
  CELL_PAR  bv;
  double  thickness;
  int  num_cal_g;
  int  num_k_points;
  double  *xpos, *ypos;  /* ng */
  int  *hpix, *gpix; /* nk */
  double  *H, *G, **intensity; /* (*) ==> nk, (**) ==> ng, nk */
  HKL  *cal_g;   /* ng */
} SIM_RES;


int find_n_g( int nr, HKL g, HKL *reflex );
void mb_simulation( FILE *fi, FILE *fo_log, char *infile );
/*
void mb_sim_spcell( FILE *fi, char *infile );
void mb_sim_coherent( FILE *fi, char *infile );
  */
void mb_dispersion_surface( FILE *fi, FILE *fo_log, char *infile );
void mb_bloch_state( FILE *fi, FILE *fo_log, char *infile );
void mb_tfringe( FILE *fi, FILE *fo_log, char *infile );

void fget_sd_beams(SIM_DATA *sd, CRYSTAL_STRCT_DATA *csd, FILE *fi);
void free_sd(SIM_DATA *sd);

#include "e_density.h"
