/*
 * rfsearch.h (for rfsearch.c)
 */
#define LZ_MAX_NUM	100

typedef struct{
  int		flag_bs,
  /*
   *	0: manual search (GBA),
   *  1: auto search wg (GBA),
   *  2: auto search sg (GBA),
   *  3: auto search multi-sg (each layer, GBA)
   *
   *	10: manual search (simple Bethe),
   *  11: auto search wg (simple Bethe),
   *  12: auto search sg (simple Bethe)
   *	13: auto search multi-sg (each layer, simple Bethe)
   */
  nglim, lzmin, lzmax;
  double gmax, disksize, wgbmin, wgmax, sgbmin, sgmax,
  xigmax, wg2bmin, wg2max, xig2max,
  sge_max[LZ_MAX_NUM], sgb_max[LZ_MAX_NUM], xig_max[LZ_MAX_NUM];
} BEAM_SEARCH_PAR;

int find_n_g( int nr, HKL g, HKL *reflex );
void reflex_g_chk( int nth_g, HKL g_target, int nexact, HKL exact_reflex[] );
