// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "symops.h"
#include "atoms.h"
#include "funcdefs.h"
#include "numbers.h"
extern long gNumBasisAtoms,gNumUnitCellAtoms,gNumSymops,gSymopsAreChanged ;
// -----------------------------------------------------------------
// Apply the symmetry operators to the basis atoms to produce the 
// atoms in the unit cell
// -----------------------------------------------------------------
void ApplySymmetries() {
	long i,j,ndx,icount ;
	float xc,yc,zc ;
	float xnew,ynew,znew ;
	static long first = TRUE ;

	ndx = 0 ;
	for (j=0;j<gNumBasisAtoms;j++) {
		icount = ndx ;
		xc = (basis+j)->xc.val.fv ;
		yc = (basis+j)->yc.val.fv ;
		zc = (basis+j)->zc.val.fv ;
		for (i=0;i<gNumSymops;i++) {
			if (first || gSymopsAreChanged) decode_symop(i) ;
			xnew = symop[i].matr[0][0]*xc + symop[i].matr[0][1]*yc +
				symop[i].matr[0][2]*zc + symop[i].matr[0][3] ;
			ynew = symop[i].matr[1][0]*xc + symop[i].matr[1][1]*yc +
				symop[i].matr[1][2]*zc + symop[i].matr[1][3] ;
			znew = symop[i].matr[2][0]*xc + symop[i].matr[2][1]*yc +
				symop[i].matr[2][2]*zc + symop[i].matr[2][3] ;
			xnew = one(xnew) ;
			ynew = one(ynew) ;
			znew = one(znew) ;
			if (not_equiv(xnew,ynew,znew,icount,ndx)) {
				(atom+ndx)->xc.val.fv = xnew ;
				(atom+ndx)->yc.val.fv = ynew ;
				(atom+ndx)->zc.val.fv = znew ;
				(atom+ndx)->dw.val.fv = (basis+j)->dw.val.fv ;
				(atom+ndx)->occ.val.fv = (basis+j)->occ.val.fv ;
				(atom+ndx)->type.val.iv = (basis+j)->type.val.iv ;
				(atom+ndx)->no.val.iv = (basis+j)->no.val.iv ;
				(atom+ndx)->name.val.cv = (basis+j)->name.val.cv ;
				ndx++ ;
			}
		}
	}
	gNumUnitCellAtoms = ndx ;
	if (first) first = FALSE ;
	gSymopsAreChanged = FALSE ;
}     

