#ifndef __CSelection
#define __CSelection
#include "types.h"
#include "funcdefs.h"
class CSelection {

public:
	CSelection(Rect *clipRect = nil) ;
	~CSelection() ;
	void	GetSelectionRect(Rect &rect) { rect = mSelectionRect ; } ;
	void 	DoMouseDown(Point &loc) ;
	Boolean IsNullSelection() { return (mSelectionRect.left == mSelectionRect.right
			|| mSelectionRect.top == mSelectionRect.bottom) ; } ;
	Boolean	IsInside(Point &loc) { return PtInRect(&loc,&mSelectionRect) ; } ;
	void 	Zoom(float factor,short x,short y) ;
	void 	Pan(short dx,short dy) ;
	void	Update(Rect *clipRect) ;
	void 	Modify(Point &loc) ;
private:
	Rect	mSelectionRect ;
	Rect	mTopLeftCorner ;
	Rect	mTopRightCorner ;
	Rect	mBottomLeftCorner ;
	Rect	mBottomRightCorner ;
	Rect	mTopMiddle ;
	Rect	mLeftMiddle ;
	Rect	mBottomMiddle ;
	Rect	mRightMiddle ;

	RgnHandle	mClipRgn ;
	
	void	Draw(Boolean drawHandles=false) ;
	void 	Drag(Point &loc) ;
	void 	DragTopLeft(Point &loc) ;
	void 	DragTopRight(Point &loc) ;
	void 	DragBottomLeft(Point &loc) ;
	void 	DragBottomRight(Point &loc) ;
	void 	DragTop(Point &loc) ;
	void 	DragLeft(Point &loc) ;
	void 	DragBottom(Point &loc) ;
	void 	DragRight(Point &loc) ;
	void 	Shift(Point &loc) ;
	void 	SetActiveHandles() ;
	void	DrawHandles() ;
} ;

#endif

