#ifndef __TApplication
#define __TApplication

#include <forms.h>
#include "TWindowList.h"
#include "TWindow.h"

class TApplication {

	public:
		TApplication(long argc,char *argv[]) ;
		~TApplication() ;
		
		virtual void	Initialize() ;
		virtual void	MainLoop() ;
		void			ProcessModalEvent(XEvent *event) ;
		virtual void	AddWindow(TWindow *theWindow) { mWindowList->AddWindow(theWindow) ; theWindow->SetWindowList(mWindowList) ; } ;
		virtual void	RemoveWindow(TWindow *theWindow)  { mWindowList->RemoveWindow(theWindow) ; } ;
		TWindow 		*FindWindow(Window window)  { return mWindowList->GetWindow(window) ; } ;
		
	protected:
	
		virtual void	ProcessEvents() ;

		Boolean		mDone ;
		Point		mMouseLoc ;
    	
		// List of Open windows
		TWindowList	*mWindowList ;

		virtual	void DoIdle() ;
		virtual	void CleanUp() ;
		virtual	void SetupColors() ;
				
		virtual		void SelectCursor() ;	
		virtual		long GetToolIndex() { return -1 ; } ;
		void		GetVisual(Boolean forcePseudoColor,XVisualInfo *vinfo) ;
		
	    /* Run */
		virtual	void 	DoKeyDown(XEvent *event)  ;
		virtual	void 	DoKeyUp(XEvent *event)  ;
		virtual	void 	DoMouseDown(XEvent *event) ;
		virtual	void 	DoUpdate(XEvent *event)  ;
		virtual	void 	DoResizeWindow(XEvent *event) ;
		virtual void	DoClientMessage(XEvent *event) ;
		
		virtual	void	DefineXForms() {} ;
		virtual	void	DefineWindows() {} ;
		virtual	void	ShowXForms() {} ;
	    		
} ;


#endif

