// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
//#include <memory.h>
#include <stdio.h>
#include "TAtom.h"

TAtom::TAtom() {
// set the new fields for backwards compatibility
	rad = -1.0;
	tag = 0 ;
	type = 1 ;
	color.red = 0xFFFF ;
	color.green = 0xFFFF ;
	color.blue = 0xFFFE ;
	state = kNormalState ;
	groupnumber = -1 ;
	name = NULL ;
	refine = kRefineX & kRefineY ;
}

TAtom::~TAtom() {
}

TAtom&
TAtom::operator=(const TAtom& s) {
	name = s.name ;
	tag = s.tag ;
	type = s.type ;
	no = s.no ;
	xc = s.xc ;
	yc = s.yc ;
	zc = s.zc ;
	dw = s.dw ;
	occ = s.occ ;
	rad = s.rad ;
	color = s.color ;
	state = s.state ;
	groupnumber = s.groupnumber ;
	refine = s.refine ;
	
	return *this ;
}
SAtom::SAtom() {
	index = 0 ;		// index to the original atom in the mAtomList
	location.h = 0 ;	// Location on the screen
	location.v = 0 ;	// Location on the screen
	location.d = 0 ;	// Location on the screen
	position.h = 0. ;	// Position in Angstrom from the arbitrary origin
	position.v = 0. ;	// Position in Angstrom from the arbitrary origin
	position.d = 0. ;	// Position in Angstrom from the arbitrary origin
	rad = 0 ;
	state = kNormalState ;
	groupnumber = -1 ;	//
}

SAtom::~SAtom() {
	//delete atom ;
}

SAtom&
SAtom::operator=(const SAtom& s) {
	atom = s.atom ;
	index = s.index ;
	location = s.location ;
	position = s.position ;
	rad = s.rad ;
	state = s.state ;
	groupnumber = s.groupnumber ;
	return *this ;
}

