#ifndef __COMPARISONWINDOW_H
#define __COMPARISONWINDOW_H

#include "CSelection.h"

#define NUM_CTOOLS	4

typedef enum { kCPointerTool=0,kCSelectionTool,kCMagnifyingGlass,kCHandTool} KCToolType ;
	 
class TComparisonAreaWindow {

public:
	static long ID ; 
	TComparisonAreaWindow() ;
	~TComparisonAreaWindow() ;
	
	WindowPtr	GetWindow() { return (WindowPtr) mWindow ; } ;
	short		ProcessEvents() ;
	
private:

	ModalFilterUPP	mDialogFilter ;
	TImage		*mExperimentalImage ;
	DialogPtr 	mWindow ;
	Rect		mImageRect ;
	Rect		mActualImageRect ;
	KCToolType	mCurrentTool ;
	CIconHandle	mToolIcons[NUM_CTOOLS] ;
	FRect		mImageSelectionRect ;
	CSelection	*mImageSelection ;
	Boolean		mIsInsideActiveRect ;
	Point		mImageCenter ;
	float		mImageMagnification ;
	GrafPtr		mSavedPort ;
	
	void		DoMouseDownInImage(Point &loc) ;
	void		DrawIcons() ;
	void		DeselectTool(KCToolType tool) ;
	void		SelectTool(KCToolType tool) ;
	void		Draw() ;
	void		DrawExperimentalImage(Boolean drawFrame) ;
	void		DrawImageComparisonRect() ;
	static pascal 	Boolean DialogFilter(DialogPtr tp,EventRecord *theEvent,short *itemHit) ;
	
} ;

#endif // __COMPARISONAREAWINDOW_H

