#include "TFile.h"

TFile::TFile() {
	mFP = nil ;
	mSize = 0 ;
	mData = nil ;
	mIsOpen = false ;
}

TFile::TFile(char *fileName) {
	mFP = nil ;
	mSize = 0 ;
	mData = nil ;
	mIsOpen = false ;
	strcpy(mFileName,fileName) ;
}

TFile::TFile(char *fileName,FileMode	fileMode) {
	mFP = nil ;
	mSize = 0 ;
	mData = nil ;
	mIsOpen = false ;
	strcpy(mFileName,fileName) ;
	Open(fileMode) ;
}


TFile::~TFile() {
	if (mIsOpen && mFP != nil)
		fclose(mFP) ;
}

Boolean	TFile::Open(FileMode	fileMode) {
	long	fileStartPos,fileEndPos ;
	switch(fileMode) {
		case kRead:
			mFP = fopen(mFileName,"r") ;
			// Get the file size
			fileStartPos = ftell(mFP) ;
			if (fseek(mFP,0,2) == 0) {
				fileEndPos = ftell(mFP) ;
				mSize = fileEndPos - fileStartPos ;
				fseek(mFP,fileStartPos,0) ;
			}
			break ;
		case kWrite:
			mFP = fopen(mFileName,"w") ;
			break ;
	}
	if (mFP != nil)
		mIsOpen = true ;
        return mIsOpen ;
}

Boolean	TFile::Read() {
	return true ;
}

Boolean	TFile::Write() {
	return true ;
}

Boolean	TFile::Read(void *data,ULong numBytes) {
	ULong numBytesRead ;

	numBytesRead = fread(data,1,numBytes,mFP) ;
	if (numBytesRead == numBytes) 
		return(true) ;
	else 
		return (false) ;
}

Boolean	TFile::Write(void *data,ULong numBytes) {
	ULong numBytesWritten ;
	numBytesWritten = fwrite(data,1,numBytes,mFP) ;
	if (numBytesWritten == numBytes)
		return(true) ;
	else 
		return (false) ;
}

FSInfo::FSInfo() {
	mReply = false ;
	strcpy(mFileName,"") ;
}

void	ChooseFile(char *prompt,char *pattern,FSInfo &fsInfo) {
	
	char *directoryName = (char *)fl_show_fselector(prompt,".",pattern,
		fsInfo.mFileName) ;

	if (directoryName != NULL) {
		strcpy(fsInfo.mFileName,directoryName) ;
		fsInfo.mReply = true ;
	}
	else {
		fsInfo.mReply = false ; 
	}
}
	
