#ifndef __REFINEMENTWINDOW_H
#define __REFINEMENTWINDOW_H

#include "CCrystal.h"
#include "CSelection.h"

#define NUM_TOOLS	11

typedef enum { kXPointerTool=0,kXSelectionTool,kXRotateTool, kXQuestionMark,
	 kXMagnifyingGlass, kXRulerTool,kXAngleTool,kXAddTool,kXDeleteTool,kXHandTool,
	 kXSizeAtomTool } KXToolType ;
	 
class TRefinementWindow {

public:
	static long ID ; 
	TRefinementWindow() ;
	~TRefinementWindow() ;
	
	WindowPtr	GetWindow() { return (WindowPtr) mWindow ; } ;
	void		ProcessEvents(EventRecord &theEvent) ;
	
private:

	ModalFilterUPP	mDialogFilter ;
	TImage		*mExperimentalImage ;
	CCrystal	*mCrystal ;
	DialogPtr 	mWindow ;
	Rect		mModelRect ;
	Rect		mImageRect ;
	Rect		mActualImageRect ;
	KXToolType	mCurrentTool ;
	CIconHandle	mToolIcons[NUM_TOOLS] ;
	FRect		mImageSelectionRect ;
	FRect		mModelSelectionRect ;
	CSelection	*mImageSelection ;
	CSelection	*mModelSelection ;
	Boolean		mIsInsideActiveRect ;
	Point		mImageCenter ;
	float		mImageMagnification ;
	
	void		DrawInfoWindow() ;
	void		WriteInfo(char *text) ;
	void		DoMouseDownInModel(Point &loc) ;
	void		DoMouseDownInImage(Point &loc) ;
	void		DrawIcons() ;
	void		DeselectTool(KXToolType tool) ;
	void		SelectTool(KXToolType tool) ;
	void		Draw() ;
	void		DrawExperimentalImage() ;
	void		UpdateExperimentalImage() ;
	void		DrawModel() ;
	void		DrawImageComparisonRect() ;
	static pascal 	Boolean DialogFilter(DialogPtr tp,EventRecord *theEvent,short *itemHit) ;
	
} ;

#endif // __REFINEMENTWINDOW_H

