#ifndef __TSetImageAreaPage__
#define __TSetImageAreaPage__

#include "TPage.h"
#include "CSelection.h"

typedef enum { kComparePointer,kCompareSelection,kCompareMagnify,kCompareHand} 
CompareToolType ;

class TSetImageAreaPage : public TPage {
	public:
		TSetImageAreaPage(TWindow *window = nil) ;
		~TSetImageAreaPage() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
	private:
		void 			DrawExpImageDisplayArea() ;
		void			DrawImageComparisonRect() ;
		void			DoMouseDownInImage(Point &loc) ;
		void			DrawExperimentalImage() ;
		void			PositionImage() ;
		void			SizeImage() ;

		TRadioButton	*mCompareEntireImage ;
		TRadioButton	*mCompareSelection ;
		TButton			*mSetNewSelection ;
		TButton			*mResetView ;
		TUserRect		*mExpImageFrame ;
		TButton			*mOK ;
		TButton			*mCancel ;

		TImage			*mExpImage ;

		TPushButton		*mArrowButton ;
		TPushButton		*mRectButton ;
		TPushButton		*mMagnifyButton ;
		TPushButton		*mHandButton ;

		CSelection		*mImageSelection ;
		Point			mImageCenter ;
		Rect			mImageRect ;
		Rect			mActualImageRect ;
		FRect			mImageSelectionRect ;

		CompareToolType	mCurrentTool ;
		float			mImageMagnification ;
		Boolean			mIsInsideActiveRect ;
} ;

#endif //__TSetImageAreaPage__

