// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "microscopes.h"
extern char *NcemssDir ;
// --------------------------------------------------------------------------
// This routine reads the data file ncemssdir:microscope.dat 
// to set the parameters for known microscopes           
// --------------------------------------------------------------------------
void get_microscopes() {

    FILE *fp ;
    long i,numb_of_mic ;
    char buffer[80],*cp,*cp1;


    strcpy(buffer,NcemssDir) ;
#ifdef VMS
    strcat(buffer,"microscope.dat") ;
#else
    strcat(buffer,"/microscope.dat") ;
#endif
    fp = fopen(buffer,"r") ;
    if (fp==NULL) {
        fprintf(stderr,"\n Unable to open the file %s",buffer) ; fflush(stderr) ;
        exit(1) ;
    }
    fgets(buffer,80,fp) ;
    sscanf(buffer,"%d",&numb_of_mic) ;
    for (i=0;i<numb_of_mic;i++) {
		fscanf(fp,"%s %f %f %f %f",microscope[i].name,&microscope[i].voltage,
			&microscope[i].sph_ab,&microscope[i].delta,
			&microscope[i].theta) ;
		cp = microscope[i].name ;
		cp1 = cp ;
		while (*cp++ = toupper(*cp1++)) ; /* Convert to upper case */
	}
}

#ifdef ALLIANT
char toupper(char lowerChar) {
	char upperChar ;

	if (lowerChar >= 'a' && lowerChar <= 'z') {
		upperChar = lowerChar - ('a'-'A') ;
	}
	else {
		upperChar = lowerChar ;
	}
	return upperChar ;
}
#endif
