// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "atoms.h"
#define IDY 5
#include "menudef.h"
#include "menu_index.h"
#include "params.h"
extern char *chemsymb[],stext[] ;
extern long gCalculationIsChanged,gPGisChanged,istart,istop,gNumUnitCellAtoms,gNumBasisAtoms,gBasisIsChanged ;
extern MENUS gMenuList[] ;
extern struct { long status ; } calculation ;
extern float irrat_fract[4] ;
#define PG_MASK	1
// --------------------------------------------------------------------------
// function to modify atom position fields                         
// --------------------------------------------------------------------------
	void mod_atom(long i) {

	long 	ntype,ic,j,iz,number ;
	char	name[8] ;
	AtomRec	*unit ;

	gCalculationIsChanged = TRUE ;
	gPGisChanged = TRUE ;
	calculation.status &= ~PG_MASK ;
	i-- ;
	tryagain :
	eraser((*gCurrentButton)->xl,(*gCurrentButton)->yl,
		(*gCurrentButton)->xh,(*gCurrentButton)->yh) ;
	j = istart + i/6 ;
	if (gCurrentMenu == &gMenuList[CH_ATOM]) {
		unit = atom+j ;
		number = gNumUnitCellAtoms ;
	}
	else {
		unit = basis+j ;
		number = gNumBasisAtoms ;
		gBasisIsChanged = TRUE ;
	}
	ic = i%6 ;
	cp_abs((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY) ;
	switch(ic) {
		case 0 :/* CHANGE THE CHEMICAL SYMBOL */
			ReadString(name,8) ;
			if((iz=atomno(name))!=-1) {
				eraser(0,60,960,100) ;
				unit->no.val.iv = iz ;
				unit->name.val.cv = chemsymb[iz-1] ;
			}
			else {
				err(3) ;
				goto tryagain ;
			}
			break ;
		case 1 :/* CHANGE THE X-COORDINATE */
			unit->xc.val.fv = get_float(0.) ;
			for (j=0;j<4;j++) {
				if (fabs(unit->xc.val.fv-irrat_fract[j]) < 0.0005)
					unit->xc.val.fv = irrat_fract[j] ;
			}
			break ;
		case 2 :/* CHANGE THE Y-COORDINATE */
			unit->yc.val.fv = get_float(0.) ;
			for (j=0;j<4;j++) {
				if (fabs(unit->yc.val.fv-irrat_fract[j]) < 0.0005)
					unit->yc.val.fv = irrat_fract[j] ;
			}
			break ;
		case 3 :/* CHANGE THE Z-COORDINATE */
			unit->zc.val.fv = get_float(0.) ;
			for (j=0;j<4;j++) {
				if (fabs(unit->zc.val.fv-irrat_fract[j]) < 0.0005)
					unit->zc.val.fv = irrat_fract[j] ;
			}
			break ;
		case 4 :/* CHANGE THE DEBYE-WALLER-FACTOR */
			unit->dw.val.fv = get_float(0.5) ;
			break ;
		case 5 :/* CHANGE THE OCCUPANCY FACTOR */
			unit->occ.val.fv = get_float(1.0) ;
			break ;
	}
	eraser((*gCurrentButton)->xl,(*gCurrentButton)->yl,
		(*gCurrentButton)->xh,(*gCurrentButton)->yh) ;
		
	switch(ic) {
		case 0 :
			temdtx((*gCurrentButton)->xl,
			 (*gCurrentButton)->yl+IDY,unit->name.val.cv) ;
			eraser(0,60,820,764) ;
			if (gCurrentMenu == &gMenuList[CH_ATOM]) {
				if((ntype=types(atom,number))!=gInputParameter[13].iv) 
					gInputParameter[13].iv = ntype ;
				sort(atom,number) ;
				displ_atoms(atom) ;
			}
			else {
				if((ntype=types(basis,number))!=gInputParameter[13].iv) 
					gInputParameter[13].iv = ntype ;
				sort(basis,number) ;
				displ_atoms(basis) ;
			}
			break ;
		case 1 :
			sprintf(stext,"%.4f",unit->xc.val.fv) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 2 :
			sprintf(stext,"%.4f",unit->yc.val.fv) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 3 :
			sprintf(stext,"%.4f",unit->zc.val.fv) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 4 :
			sprintf(stext,"%.4f",unit->dw.val.cv) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			if (gCurrentMenu == &gMenuList[CH_ATOM])
				ntype = types(atom,number) ;
			else
				ntype = types(basis,number) ;
			if (ntype != gInputParameter[13].iv) {
				eraser(0,60,820,764) ;
				if (gCurrentMenu == &gMenuList[CH_ATOM]) {
					sort(atom,number) ;
					displ_atoms(atom) ;
				}
				else {
					sort(basis,number) ;
					displ_atoms(basis) ;
				}
				gInputParameter[13].iv = ntype ;
			}
			break ;
		case 5 :
			sprintf(stext,"%4.2f",unit->occ.val.fv) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
	}
}

