// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "MslicRecord.h"
#include "errors.h"
#include "PutMessage.h"
#include "TAmplitudePage.h"
#include "globals.h"

void	SetPage(TPage *) ;


// --------------------------------------------------------------------------
// Runs the routine for plotting of amplitudes and phases. Invoked by the
//  "AMPLIT" command                                                    
// --------------------------------------------------------------------------
void run_ampli() { 

	eraser(0,120,1020,160) ;
	on_highlight() ;
	gCurrentCommand = gCurrentButton ;

	if (gMsliceRec.iplot) {
		off_highlight() ;
		// Old code
		/* -------
		PlotAmplitudes() ; 		
		if (gIOError) err_io(gIOError) ;
		------ */
		// New code
		TAmplitudePage *thePage = new TAmplitudePage(gControlWindow) ;
		if (thePage != nil) {
			SetPage(thePage) ;
			thePage->Show() ;
		}	
	}
	else {
		off_highlight() ;
		err_seq(4) ;
		return ;
	}
}

