// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "displ.h"
#include "devices.h"
#include "globals.h"
extern GDevice *OutDevice ;
extern long NUM_DEFOC,MULTIPLE_CTF ;
// ------------------------------------------------------------------
// Sets up and calls the routine CTFPLOT. CTFPLOT plots the 
//  contrast transfer function to the screen             
// ------------------------------------------------------------------
void run_ctfplot() {
    long i,num_display ;

    on_highlight() ;
    gCurrentCommand = gCurrentButton ;
    SetWatchCursor() ;
    switch(OutDevice->type) {
	case WS:
		SetOffscreenPort(gOffscreenPtr) ;
		ClearDisplay() ;
		break ;
	case FS: 
		return ;
		break ;
	case LP:
		open_ps_file("laserprinter.ps") ;
		LandScape() ;
		break ;
    }
    setup_trnsf() ;
    gDisplayRec.dfocus = gDisplayRec.f1 ;
    ctfplot() ;
    switch(OutDevice->type) {
	case WS:
		UnSetOffscreenPort(gOffscreenPtr) ;
		UpdateImageScreen() ;
		SetPort(gControlWindow) ;
		break ;
	case LP:
		close_ps_file() ;
		break ;
    }
    off_highlight() ;
    InitCursor() ;
}
