// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
#include "atoms.h"
#include "storage.h"
static long iorigox,iorigoy ;
static float scale_fact ;
extern long PERSP,SCREEN_BUILD ;
float X_0_LOCATION ;
float Y_0_LOCATION ;
float X_1_LOCATION ;
float Y_1_LOCATION ;
float X_2_LOCATION ;
float Y_2_LOCATION ;
#define MIN(x,y)    (((x) < (y)) ? (x) : (y))
#define MAX(x,y)    (((x) < (y)) ? (y) : (x))
extern short gShadedSpheres ;
/************************************************************************/
/* Plots the three-dimensional outline of the unit cell                 */
/************************************************************************/
void cell3c(float *av,float *bv,float *cv) {

    long i,iax,iay,iaz,ibx,iby,ibz,icx,icy,icz,ix[8],iy[8],iz[8],maxz,minz ;
    float shrink,ax,bx,ay,by,cx,cy,az,bz,cz,ylength,xlength,perspective ;
    long minres ;
    long SWITCHED=FALSE ;
    GDevice *OldDevice ;
    
    ax = av[0]; ay = av[1]; bx = bv[0]; by = bv[1]; cx = cv[0]; cy = cv[1] ;
    az = av[2]; bz = bv[2]; cz = cv[2] ;
    xlength = ABS(ax) + ABS(bx) + ABS(cx) ;
    ylength = ABS(ay) + ABS(by) + ABS(cy) ;
    minres = MIN(OutDevice->xres,OutDevice->yres) ;
    if (SCREEN_BUILD) {
        xlength = 800/xlength ;
        ylength = 500/ylength ;
    }
    else {
    	xlength = minres/(2*xlength) ;
        ylength = minres/(2*ylength) ;
    }
    scale_fact = MIN(xlength,ylength) ;  
    iax = ax*scale_fact ;
    iay = ay*scale_fact ;
    iaz = az*scale_fact ;
    ibx = bx*scale_fact ;
    iby = by*scale_fact ;
    ibz = bz*scale_fact ;
    icx = cx*scale_fact ;
    icy = cy*scale_fact ;
    icz = cz*scale_fact ;
    iorigox = (SCREEN_BUILD ? 440 : OutDevice->xres/2) - (iax+ibx+icx)/2 ;
    iorigoy = (SCREEN_BUILD ? 390 : OutDevice->yres/2) - (iay+iby+icy)/2 ;
    ix[0] = iax ;
    ix[1] = iax+ibx ;
    ix[2] = iax+ibx+icx ;
    ix[3] = ibx ;
    ix[4] = ibx+icx ;
    ix[5] = icx ;
    ix[6] = icx+iax ;
    ix[7] = 0 ;
    iy[0] = iay ;
    iy[1] = iay+iby ;
    iy[2] = iay+iby+icy ;
    iy[3] = iby ;
    iy[4] = iby+icy ;
    iy[5] = icy ;
    iy[6] = icy+iay ;
    iy[7] = 0 ;
    iz[0] = iaz ;
    iz[1] = iaz+ibz ;
    iz[2] = iaz+ibz+icz ;
    iz[3] = ibz ;
    iz[4] = ibz+icz ;
    iz[5] = icz ;
    iz[6] = icz+iaz ;
    iz[7] = 0 ;
    minz = 32768 ;
    maxz = -32768 ;
    for (i=0;i<8;i++) {
    	ix[i] += iorigox ;
    	iy[i] += iorigoy ;
    	minz = MIN(minz,iz[i]) ;
    	maxz = MAX(maxz,iz[i]) ;
    }
    perspective = 8.*(maxz-minz) ;
    if (PERSP) {
    	for (i=0;i<8;i++) {
    		shrink = 1. + (maxz-iz[i])/perspective ;
    		ix[i] = (ix[i]-OutDevice->xres/2)/shrink + OutDevice->xres/2 ;
    		iy[i] = (iy[i]-OutDevice->yres/2)/shrink + OutDevice->yres/2 ;
    	}
    }
    if (OutDevice->type != WS) {
	/* We just want to draw to the CRT if SCREEN_BUILD */
    	if (SCREEN_BUILD) {
    		OldDevice = OutDevice ;
    		OutDevice = &WorkStation ;   /* Temporarily set output to CRT */
    		SWITCHED = TRUE ;
    	}
    }
    X_0_LOCATION = ix[7] ;   /* Location of the Origin of the unit cell */
    Y_0_LOCATION = iy[7] ;   /* for purposes of changes in BUILD_CELL   */
    X_1_LOCATION = ix[0] ;
    Y_1_LOCATION = iy[7] ;
    X_2_LOCATION = ix[3] ;
    Y_2_LOCATION = iy[3] ;
    for (i=0;i<8;i++) {
    	iy[i] = OutDevice->yres - iy[i] ;
    }
    stemdln(ix[5],iy[5],ix[4],iy[4]) ;
    stemdln(ix[4],iy[4],ix[2],iy[2]) ;
    stemdln(ix[2],iy[2],ix[6],iy[6]) ;
    stemdln(ix[6],iy[6],ix[5],iy[5]) ;

    stemdln(ix[2],iy[2],ix[1],iy[1]) ;
    stemdln(ix[1],iy[1],ix[0],iy[0]) ;
    stemdln(ix[0],iy[0],ix[6],iy[6]) ;

    stemdln(ix[1],iy[1],ix[3],iy[3]) ;
    stemdln(ix[3],iy[3],ix[4],iy[4]) ;

    stemdln(ix[7],iy[7],ix[0],iy[0]) ;
  
    stemdln(ix[7],iy[7],ix[3],iy[3]) ;
 
    stemdln(ix[7],iy[7],ix[5],iy[5]) ;
    if (SWITCHED) {
		SWITCHED = FALSE ;
		OutDevice = OldDevice ;
    }
}

void DrawAtoms(float *xp,float *yp,float *zp,float *r,long *icolor,long number) {
    long j;
    short *ipx,*ipy,*ipz,*ir ;
    float perspective,shrink ;

    ipx = (short *)(gWorkSpace+gMaxArraySize/2) ;
    ipy = ipx+gMaxAtoms ;
    ipz = ipy+gMaxAtoms ;
    ir = ipz+gMaxAtoms ;

    perspective = 8.*(*zp-*(zp+number-1))*scale_fact ;
    if (perspective == 0.) perspective = 1. ;
    for (j=0;j<number;j++) {
    	*(ir+j) = *(r+j)*scale_fact ;
    	if (*(ir+j) < 2) 
		*(ir+j) = 2 ;
    	*(ipx+j) = *(xp+j)*scale_fact + iorigox ;
    	*(ipy+j) = *(yp+j)*scale_fact + iorigoy ;
    	*(ipz+j) = *(zp+j)*scale_fact ;
    	if (PERSP) {
    		shrink = 1.+(*ipz-*(ipz+j))/perspective ;
    		*(ipx+j) = (*(ipx+j)-OutDevice->xres/2)/shrink + 
				OutDevice->xres/2 ;
    		*(ipy+j) = (*(ipy+j)-OutDevice->yres/2)/shrink + 
				OutDevice->yres/2 ;
    		*(ir+j) /= shrink ;
    		if (*(ir+j) == 0)
    																													*(ir+j) = 2 ;
    	}
    }
    //if (gShadedSpheres) {
    //	ball3d(ipx,ipy,ipz,ir,number) ;
    //}
    //else {
	DrawAtomCircles(ipx,ipy,ipz,ir,icolor,number) ;
    //}
}

void DrawAtomCircles(short *ix,short *iy,short *iz,short *ir,long *ic,long n) {
    register long i ;
    short savedColor ;

    savedColor = GetFgColor() ;
    /* Do the loop from end to beginning since the highest z is first */
    for(i=n-1;i>= 0;i--) {
		gSetFgColor(ic[i]) ;
		gFillCircle(ix[i],OutDevice->yres-1-iy[i],ir[i]) ;
		gSetFgColor(savedColor) ;
		gDrawCircle(ix[i],OutDevice->yres-1-iy[i],ir[i]) ;
    }
    SetFgColor(savedColor) ;
}
