#include <stdio.h>
#include <stdlib.h>
#ifdef __VMS
#include <lib$routines.h>
#endif
#include "header.h"
#include "menudef.h"
#include "menu_index.h"

#include "TFileViewDialog.h"
#include "config.h"

#include "TMainPage.h"
extern class TCompareImagesPage *gCompareImagesPage ;
extern class TStructureRefinementAnnealingPage *gStructureRefinementAnnealingPage ;
extern class TRefineParametersPage *gRefineParametersPage ;
TPage * GetCurrentPage() ;

extern	char	*NCEMSS_PATH ;

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
char	*EDMBrowser = BROWSER ;
char	*BrowserName = BROWSER ;

extern void PutMessage(char *) ;
void run_help() ;
// --------------------------------------------------------------------------
// Execute shell commands from within NCEMSS
// --------------------------------------------------------------------------
void run_help() {
	// Determine which menu we are in and execute the help on the current menu
	extern short gMenuNumber ;

	char filename[256] ;
	char basename[256] ;
	char command[256] ;
	char text[256] ;
	
	long	status = 0 ;
	sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,text) ;
	
	switch(gMenuNumber) {
		case SEL_SNGL_LAY:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChooseTypeOfFile") ;
			break ;
		case SEL_SNGL_STR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"SelectStructureFile") ;
			break ;
		case SEL_LAY_STR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"SelectLayeredFile") ;
			break ;
		case SEL_OLD_FL:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"SelectLayeredFile") ;
			break ;
		case MAIN_SNGL_STR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"MainParameters") ;
			break ;
		case CH_MAIN_PAR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeMainParameters") ;
			break ;
		case VIEW_BASIS:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewBasis") ;
			break ;
		case CH_BASIS_AT:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeBasis") ;
			break ;
		case VIEW_SYMOP:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewSymmops") ;
			break ;
		case CH_SYMOP:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeSymmop") ;
			break ;
		case VIEW_ATOMS:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewAtoms") ;
			break ;
		case CH_ATOM:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeAtom") ;
			break ;
		case VIEW_UNIT_CEL:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewUnitCell") ;
			break ;
		case UC_PSP_NOPSP:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewUnitCell") ;
			break ;
		case NUC_PSP_NOPSP:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ViewUnitCell") ;
			break ;
		case DSPL_SOURCE:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"DisplayResults") ;
			break ;
		case DSPL_OPER:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"DisplayResults") ;
			break ;
		case SET_BR_CNTRST:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeContrast") ;
			break ;
		case MAIN_LAY_STR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChangeLayeredParams") ;
			break ;
		case LAY_PG:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"StackLayers") ;
			break ;
		case SET_PG_SEQ:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"StackLayers") ;
			break ;
		case REM_PG_LAY:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"StackLayers") ;
			break ;
		case EXTRA_LAY_PAR:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"StackLayers") ;
			break ;
		case USE_POOL_FILE:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"ChoosePoolFile") ;
			break ;
		case UPD_FILE:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"UpdateFile") ;
			break ;
		case CRT_SWITCHES:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"Options") ;
			break ;
		case FB_SWITCHES:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"Options") ;
			break ;
		case PICK_ATOM:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"PickAtom") ;
			break ;
		case QUANTITATIVE:
			sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,"Quantitiative") ;
			// Try to see which page we are on
			TPage *currentPage = GetCurrentPage() ;
			if (currentPage == (TPage*) gCompareImagesPage) {
				fprintf(stderr,"\nCompareImagesPage") ;
			}
			if (currentPage == (TPage*) gStructureRefinementAnnealingPage) {
				fprintf(stderr,"\nStructureRefinementAnnealingPage") ;
			}
			if (currentPage == (TPage*) gRefineParametersPage) {
				fprintf(stderr,"\nRefineParametersPage") ;
			}
			break ;
	}
	
	// Check to see if we have the browser
    	// If BROWSER environnment variable is set, use it
    	if ((BrowserName = getenv("BROWSER")) != NULL) {
    	    EDMBrowser = BrowserName ;
	    //sprintf(EDMBrowser,"%s",BrowserName) ;
    	}
	#ifdef HAVE_SYS_STAT_H
		struct stat sb ;
		
		// Generate empty files if we don't have them
		sprintf(filename,"%s.htm",basename) ;
		status = stat(filename,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the file
			sprintf(command,"touch %s",filename) ;
			fprintf(stderr,"\n%s",command) ;
			system(command) ;
		}
		sprintf(filename,"%s.txt",basename) ;
		status = stat(filename,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the file
			sprintf(command,"touch %s",filename) ;
			fprintf(stderr,"\n%s",command) ;
			system(command) ;
		}
						
		status = stat(EDMBrowser,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the browser
			// Load in the equivalent text files and show in a forms file browser
			sprintf(filename,"%s.txt",basename) ;			
			TFileViewDialog *fileViewDialog = new TFileViewDialog(filename) ;

			if (!fileViewDialog->IsValid()) {
				delete fileViewDialog ;
				char otext[256] ;
				sprintf(otext,"Failed to load the file %s",filename) ;
				PutMessage(otext) ;
			}
		}
		else {
			// Try to open the browser using the path and name of the browser	
			sprintf(filename,"%s.htm",basename) ;
			sprintf(command,"%s %s &",EDMBrowser,filename) ;
			
			status = system(command) ;
			
			// If we didn't get a browser at this moment, we are without on-line help
		}
	#else
		// We don't have stat to verify the existence of the browser
		// Load in the equivalent text files and show in a forms file browser
		sprintf(filename,"%s.txt",basename) ;			
		TFileViewDialog *fileViewDialog = new TFileViewDialog(filename) ;

		if (!fileViewDialog->IsValid()) {
			delete fileViewDialog ;
			char otext[256] ;
			sprintf(otext,"Failed to load the file %s",filename) ;
			PutMessage(otext) ;
		}
	#endif
	
}

void run_help(char *text) ;
// --------------------------------------------------------------------------
// Execute shell commands from within NCEMSS
// --------------------------------------------------------------------------
void run_help(char *text) {	char filename[256] ;
	char basename[256] ;
	char command[256] ;
	
	long	status = 0 ;
	sprintf(basename,"%s/documentation/%s",NCEMSS_PATH,text) ;
	
	// Check to see if we have the browser
	#ifdef HAVE_SYS_STAT_H
		struct stat sb ;


		// Generate empty files if we don't have them
		sprintf(filename,"%s.htm",basename) ;
		status = stat(filename,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the file
			sprintf(command,"touch %s",filename) ;
			fprintf(stderr,"\n%s",command) ;
			system(command) ;
		}
		sprintf(filename,"%s.txt",basename) ;
		status = stat(filename,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the file
			sprintf(command,"touch %s",filename) ;
			fprintf(stderr,"\n%s",command) ;
			system(command) ;
		}


		status = stat(EDMBrowser,&sb) ;
		if (status == -1) {
			// We failed to verify the existence of the browser
			// Load in the equivalent text files and show in a forms file browser
			sprintf(filename,"%s.txt",basename) ;			
			TFileViewDialog *fileViewDialog = new TFileViewDialog(filename) ;

			if (!fileViewDialog->IsValid()) {
				delete fileViewDialog ;
				char otext[256] ;
				sprintf(otext,"Failed to load the file %s",filename) ;
				PutMessage(otext) ;
			}
		}
		else {
			// Try to open the browser using the path and name of the browser	
			sprintf(filename,"%s.htm",basename) ;
			sprintf(command,"%s %s &",EDMBrowser,filename) ;
			
			status = system(command) ;
			
			// If we didn't get a browser at this moment, we are without on-line help
		}
	#else
		// We don't have stat to verify the existence of the browser
		// Load in the equivalent text files and show in a forms file browser
		sprintf(filename,"%s.txt",basename) ;			
		TFileViewDialog *fileViewDialog = new TFileViewDialog(filename) ;

		if (!fileViewDialog->IsValid()) {
			delete fileViewDialog ;
			char otext[256] ;
			sprintf(otext,"Failed to load the file %s",filename) ;
			PutMessage(otext) ;
		}
	#endif
}


#ifndef VMS
// ------------------------------------------------------------------------	
// Execute shell commands from within NCEMSS 
// ------------------------------------------------------------------------	
void run_dcl() {
	char command[80] ;
	long i ;

	while (TRUE)  {
		printf("\nsh>") ; fflush(stdout) ;
		for(i=0;(command[i]=getchar())!=NEWLINE;i++)
			;
		command[i] = EOS ;
		if (strncmp(command,"EX",2)==0 || 
				strncmp(command,"ex",2)==0) {
			return ;
		}
		system(command) ;
	}
}


#else
#include <descrip.h>
// ------------------------------------------------------------------------	
// Spawn a DCL command  -- input_command 
// ------------------------------------------------------------------------	
void dcl(char *input_command) {
	struct dsc$descriptor_s dcl_command ;

	/* Build the descriptor for the input DCL command */
	dcl_command.dsc$a_pointer = input_command ;
	dcl_command.dsc$b_class = DSC$K_CLASS_S ;
	dcl_command.dsc$b_dtype = DSC$K_DTYPE_T ;
	dcl_command.dsc$w_length = strlen(input_command) ;
	LIB$SPAWN(&dcl_command) ;
}

// ------------------------------------------------------------------------	
// Spawns a DCL command        
// ------------------------------------------------------------------------	
void run_dcl() {
	char string[80];
	struct dsc$descriptor_s dcl_command ;
	long s,iexit;

	iexit = 0 ;
	dcl_command.dsc$a_pointer = string ;
	dcl_command.dsc$b_class = DSC$K_CLASS_S ;
	dcl_command.dsc$b_dtype = DSC$K_DTYPE_T ;
	do {
		printf("\nDCL>") ;
		for (s=0;(string[s]=getchar())!='\n';s++)
			;
		string[s] = '\0' ;
		dcl_command.dsc$w_length = s ;
		if ((strncmp(string,"exit",2)==0) ||
			(strncmp(string,"EXIT",2)==0)) iexit = TRUE ;
		if (!iexit)
			LIB$SPAWN(&dcl_command) ;
		else
			return ;
	} while (!iexit) ;
}
#endif
void open_semper_file(char *filename) {
}
void qiow() {
}

