#include "header.h"
void eraser(long,long,long,long) ;
void temdtx(long,long,char *) ;

extern struct {
	float cntrst ;
	float brite ;
} laswrit ;
extern char stext[] ;

void write_postscript_file(char *postscript_file,char *out,long *ncol,long *nrow) ;

void write_postscript_file(char *postscript_file,char *out,long *ncol,long *nrow) {
  /*---------------------------------------------------------------
       Creates a postscript_file generating a halftone image
       of the image that is passed long the byte array out
       Full file name is expected to be in "filename", but
       the transfer routine is "C" such that we get the address
       of the array coming over
   --------------------------------------------------------------- */
	long ic,lr4,nr4,i,j,k,il ;
	float rk,bc ;
	char bb[768],*outpt,*inpt ;
	FILE *fp,*fpin ;

/*      -------Open the output postscript file ------------- */
	fp = fopen(postscript_file,"w") ;
	if (fp==NULL) {
		eraser(0,0,1020,32) ;
		temdtx(0,10,"Failed to open a PostScript Output file !!") ;
		return ;
	}

/*      ---- Start writing the prolog ---------------------------- */
	fpin = fopen("ncemss$dir:lprint.las","r") ;
	if (fpin==NULL) {
		eraser(0,0,1020,32) ;
		sprintf(stext,
		"Failed to open the prolog file : %s",postscript_file) ;
		temdtx(0,10,stext) ;
		return ;
	}

/*      Transfer the entire content to the Postscript file   */
	while (fgets(bb,80,fpin)!= NULL)
		fprintf(fp,"%s",bb) ;

/*      --- close the source of the prolog ---------   */
	fclose(fpin) ;

/*      ----  Add dimension definitions -------------- */
	ic = 2048/512 ;
	lr4=(*ncol)*ic ;
	nr4=(*nrow)*ic ;

	fprintf(fp,"\n/cbitWidth %d def\n",*ncol) ;
	fprintf(fp,"/cbitHt %d def\n",*nrow) ;
	fprintf(fp,"%d %d absidtransform scale \n",lr4,nr4) ;
	fprintf(fp,"Center\nDoit") ;

/*      ------ Write the rows into the PostScript file ---------- */
	if (laswrit.cntrst >= 0.) {
		bc = ((1.+laswrit.cntrst)*laswrit.brite-laswrit.cntrst)*255 ;
	}
	else {
		bc = (1.-laswrit.cntrst)*laswrit.brite*255 ;
	}

	for (j=0,inpt=out;j<(*nrow);j++) {
		fprintf(fp,"\n") ;
		for (i=0,outpt=bb;i<(*ncol);i++) {
			k = *inpt++ ;
			if (k <0) k = k+256 ;
			rk = laswrit.cntrst*k+bc ;
			rk = MIN(rk,255.) ;
			rk = MAX(rk,0.) ;
			k = rk*95/255 + 32 ;   
			*outpt++ = k ;
		}
		for (il=0;il < (*ncol) ;il++) {
			if ((il+1)%73 == 0)
				fprintf(fp,"\n") ;
			fprintf(fp,"%c",bb[il]) ;
		}
	}
/*      ------ Complete laser printer program with showpage request ----- */
	fprintf(fp,"\nshowpage") ;
/*      --- Close the PostScript file ----- */
	fclose(fp) ;
}
